// This code conforms with the UFC specification version 2018.1.0
// and was automatically generated by FFC version 2019.1.0.post0.
//
// This code was generated with the option '-l dolfin' and
// contains DOLFIN-specific wrappers that depend on DOLFIN.
//
// This code was generated with the following parameters:
//

//  add_tabulate_tensor_timing:     False
//  convert_exceptions_to_warnings: False
//  cpp_optimize:                   True
//  cpp_optimize_flags:             '-O2'
//  epsilon:                        1e-14
//  error_control:                  False
//  external_include_dirs:          ''
//  external_includes:              ''
//  external_libraries:             ''
//  external_library_dirs:          ''
//  form_postfix:                   True
//  format:                         'dolfin'
//  generate_dummy_tabulate_tensor: False
//  max_signature_length:           0
//  optimize:                       True
//  precision:                      None
//  quadrature_degree:              None
//  quadrature_rule:                None
//  representation:                 'auto'
//  split:                          False

#ifndef __FORMS_H
#define __FORMS_H
#include <algorithm>
#include <cmath>
#include <iostream>
#include <stdexcept>
#include <ufc.h>

class forms_finite_element_0: public ufc::finite_element
{
public:

  forms_finite_element_0() : ufc::finite_element()
  {
    // Do nothing
  }

  ~forms_finite_element_0() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FiniteElement('Lagrange', triangle, 1)";
  }

  ufc::shape cell_shape() const final override
  {
    return ufc::shape::triangle;
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t geometric_dimension() const final override
  {
    return 2;
  }

  std::size_t space_dimension() const final override
  {
    return 3;
  }

  std::size_t value_rank() const final override
  {
    return 0;
  }

  std::size_t value_dimension(std::size_t i) const final override
  {
    return 1;
  }

  std::size_t value_size() const final override
  {
    return 1;
  }

  std::size_t reference_value_rank() const final override
  {
    return 0;
  }

  std::size_t reference_value_dimension(std::size_t i) const final override
  {
    return 1;
  }

  std::size_t reference_value_size() const final override
  {
    return 1;
  }

  std::size_t degree() const final override
  {
    return 1;
  }

  const char * family() const final override
  {
    return "Lagrange";
  }

  void evaluate_reference_basis(double * reference_values,
                                std::size_t num_points,
                                const double * X) const final override
  {
    static const double coefficients0[1][3] = { { 0.4714045207910316, -0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients1[1][3] = { { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients2[1][3] = { { 0.4714045207910316, 0.0, 0.3333333333333333 } };
    for (std::size_t k = 0; k < num_points * 3; ++k)
        reference_values[k] = 0.0;
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Map from UFC reference coordinate X to FIAT reference coordinate Y
        const double Y[2] = { 2.0 * X[ip * 2] - 1.0, 2.0 * X[ip * 2 + 1] - 1.0 };
        // Compute basisvalues for each relevant embedded degree
        double basisvalues1[3] = {};
        basisvalues1[0] = 1.0;
        const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
        basisvalues1[1] = tmp1_1;
        basisvalues1[2] = (0.5 + 1.5 * Y[1]) * basisvalues1[0];
        basisvalues1[0] *= std::sqrt(0.5);
        basisvalues1[2] *= std::sqrt(1.0);
        basisvalues1[1] *= std::sqrt(3.0);
        // Accumulate products of coefficients and basisvalues
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[3 * ip] += coefficients0[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[3 * ip + 1] += coefficients1[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[3 * ip + 2] += coefficients2[0][r] * basisvalues1[r];
    }
  }

  void evaluate_reference_basis_derivatives(double * reference_values,
                                            std::size_t order,
                                            std::size_t num_points,
                                            const double * X) const final override
  {
    if (order == 0)
    {
        evaluate_reference_basis(reference_values, num_points, X);
        return;
    }
    const std::size_t num_derivatives = std::pow(2, order);
    std::fill_n(reference_values, num_points * 3 * num_derivatives, 0.0);
    if (order > 1)
        return;
    // Tables of derivatives of the polynomial base (transpose).
    alignas(32) static const double dmats0[2][3][3] =
        { { { 0.0, 0.0, 0.0 },
            { 4.8989794855663495, 0.0, 0.0 },
            { 0.0, 0.0, 0.0 } },
          { { 0.0, 0.0, 0.0 },
            { 2.449489742783182, 0.0, 0.0 },
            { 4.242640687119285, 0.0, 0.0 } } };
    static const double coefficients0[1][3] = { { 0.4714045207910316, -0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients1[1][3] = { { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients2[1][3] = { { 0.4714045207910316, 0.0, 0.3333333333333333 } };
    const std::size_t reference_offset[3] = {};
    const std::size_t num_components[3] = { 1, 1, 1 };
    // Precomputed combinations
    const std::size_t combinations[1][2][1] =
        { { { 0 },
            { 1 } } };
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Map from UFC reference coordinate X to FIAT reference coordinate Y
        const double Y[2] = { 2.0 * X[ip * 2] - 1.0, 2.0 * X[ip * 2 + 1] - 1.0 };
        // Compute basisvalues for each relevant embedded degree
        double basisvalues1[3] = {};
        basisvalues1[0] = 1.0;
        const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
        basisvalues1[1] = tmp1_1;
        basisvalues1[2] = (0.5 + 1.5 * Y[1]) * basisvalues1[0];
        basisvalues1[0] *= std::sqrt(0.5);
        basisvalues1[2] *= std::sqrt(1.0);
        basisvalues1[1] *= std::sqrt(3.0);
        // Loop over all dofs
        for (std::size_t i = 0; i < 3; ++i)
        {
            double derivatives[2] = {};
            switch (i)
            {
            case 0:
                // Compute reference derivatives for dof 0.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients0[0][s] * aux[s];
                }
                break;
            case 1:
                // Compute reference derivatives for dof 1.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients1[0][s] * aux[s];
                }
                break;
            case 2:
                // Compute reference derivatives for dof 2.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients2[0][s] * aux[s];
                }
                break;
            }
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t c = 0; c < num_components[i]; ++c)
                    reference_values[3 * num_derivatives * ip + num_derivatives * i + r + (reference_offset[i] + c)] = derivatives[num_derivatives * c + r];
        }
    }
  }

  void transform_reference_basis_derivatives(double * values,
                                             std::size_t order,
                                             std::size_t num_points,
                                             const double * reference_values,
                                             const double * X,
                                             const double * J,
                                             const double * detJ,
                                             const double * K,
                                             int cell_orientation) const final override
  {
    const std::size_t num_derivatives = std::pow(2, order);
    // Precomputed combinations
    const std::size_t combinations[1][2][1] =
        { { { 0 },
            { 1 } } };
    std::fill_n(values, num_points * 3 * num_derivatives, 0.0);
    const std::size_t reference_offsets[3] = {};
    const std::size_t physical_offsets[3] = {};
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        double transform[2][2];
        for (std::size_t r = 0; r < num_derivatives; ++r)
            for (std::size_t s = 0; s < num_derivatives; ++s)
                transform[r][s] = 1.0;
        for (std::size_t r = 0; r < num_derivatives; ++r)
            for (std::size_t s = 0; s < num_derivatives; ++s)
                for (std::size_t k = 0; k < order; ++k)
                    transform[r][s] *= K[2 * 2 * ip + 2 * combinations[order - 1][s][k] + combinations[order - 1][r][k]];
        for (std::size_t d = 0; d < 3; ++d)
        {
            for (std::size_t s = 0; s < num_derivatives; ++s)
            {
                for (std::size_t i = 0; i < 1; ++i)
                {
                    // Using affine transform to map values back to the physical element.
                    const double mapped_value = reference_values[3 * num_derivatives * ip + num_derivatives * d + s + reference_offsets[d]];
                    // Mapping derivatives back to the physical element
                    for (std::size_t r = 0; r < num_derivatives; ++r)
                        values[3 * num_derivatives * ip + num_derivatives * d + r + (physical_offsets[d] + i)] += transform[r][s] * mapped_value;
                }
            }
        }
    }
  }

  void evaluate_basis(std::size_t i,
                      double * values,
                      const double * x,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::coordinate_mapping * cm=nullptr
                      ) const final override
  {
    double X[2] = {};
    double J[4];
    double detJ;
    double K[4];
    if (cm)
    {
        cm->compute_reference_geometry(X, J, &detJ, K, 1, x, coordinate_dofs, cell_orientation);
    }
    else
    {
        compute_jacobian_triangle_2d(J, coordinate_dofs);
        compute_jacobian_inverse_triangle_2d(K, detJ, J);
        // Compute constants
        const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
        const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
        // Get coordinates and map to the reference (FIAT) element
        double Y[2] = { (J[1] * (C1 - 2.0 * x[1]) + J[3] * (2.0 * x[0] - C0)) / detJ, (J[0] * (2.0 * x[1] - C1) + J[2] * (C0 - 2.0 * x[0])) / detJ };
        // Map to FFC reference coordinate
        for (std::size_t k = 0; k < 2; ++k)
            X[k] = (Y[k] + 1.0) / 2.0;
    }
    // Evaluate basis on reference element
    double ref_values[3];
    evaluate_reference_basis(ref_values, 1, X);
    // Push forward
    double physical_values[3];
    transform_reference_basis_derivatives(physical_values, 0, 1, ref_values, X, J, &detJ, K, cell_orientation);
    for (std::size_t k = 0; k < 1; ++k)
        values[k] = physical_values[i + k];
  }

  void evaluate_basis_all(double * values,
                          const double * x,
                          const double * coordinate_dofs,
                          int cell_orientation,
                          const ufc::coordinate_mapping * cm=nullptr
                          ) const final override
  {
    // Helper variable to hold value of a single dof.
    double dof_values = 0.0;
    // Loop dofs and call evaluate_basis
    for (std::size_t r = 0; r < 3; ++r)
    {
        evaluate_basis(r, &dof_values, x, coordinate_dofs, cell_orientation);
        values[r] = dof_values;
    }
  }

  void evaluate_basis_derivatives(std::size_t i,
                                  std::size_t n,
                                  double * values,
                                  const double * x,
                                  const double * coordinate_dofs,
                                  int cell_orientation,
                                  const ufc::coordinate_mapping * cm=nullptr
                                  ) const final override
  {
    std::size_t num_derivatives = std::pow(2, n);
    std::fill_n(values, num_derivatives, 0.0);
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
        evaluate_basis(i, values, x, coordinate_dofs, cell_orientation);
        return;
    }
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 1)
        return;
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    // Compute Inverse Jacobian and determinant
    double K[4];
    double detJ;
    compute_jacobian_inverse_triangle_2d(K, detJ, J);
    // Compute constants
    const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
    const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
    // Get coordinates and map to the reference (FIAT) element
    double Y[2] = { (J[1] * (C1 - 2.0 * x[1]) + J[3] * (2.0 * x[0] - C0)) / detJ, (J[0] * (2.0 * x[1] - C1) + J[2] * (C0 - 2.0 * x[0])) / detJ };
    // Precomputed combinations
    const std::size_t combinations[1][2][1] =
        { { { 0 },
            { 1 } } };
    // Declare transformation matrix
    double transform[2][2] =
        { { 1.0, 1.0 },
          { 1.0, 1.0 } };
    // Construct transformation matrix
    for (std::size_t row = 0; row < num_derivatives; ++row)
        for (std::size_t col = 0; col < num_derivatives; ++col)
            for (std::size_t k = 0; k < n; ++k)
                transform[row][col] *= K[2 * combinations[n - 1][col][k] + combinations[n - 1][row][k]];
    switch (i)
    {
    case 0:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910316, -0.2886751345948129, -0.16666666666666666 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[r] += transform[r][s] * derivatives[s];
        }
        break;
    case 1:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[r] += transform[r][s] * derivatives[s];
        }
        break;
    case 2:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910316, 0.0, 0.3333333333333333 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[r] += transform[r][s] * derivatives[s];
        }
        break;
    }
  }

  void evaluate_basis_derivatives_all(std::size_t n,
                                      double * values,
                                      const double * x,
                                      const double * coordinate_dofs,
                                      int cell_orientation,
                                      const ufc::coordinate_mapping * cm=nullptr
                                      ) const final override
  {
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
        evaluate_basis_all(values, x, coordinate_dofs, cell_orientation);
        return;
    }
    unsigned int num_derivatives = std::pow(2, n);
    // Set values equal to zero.
    std::fill_n(values, num_derivatives * 3, 0.0);
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 1)
        return;
    // Helper variable to hold values of a single dof.
    double dof_values[2] = {};
    // Loop dofs and call evaluate_basis_derivatives.
    for (std::size_t r = 0; r < 3; ++r)
    {
        evaluate_basis_derivatives(r, n, dof_values, x, coordinate_dofs, cell_orientation);
        for (std::size_t s = 0; s < num_derivatives; ++s)
            values[num_derivatives * r + s] = dof_values[s];
    }
  }

  double evaluate_dof(std::size_t i,
                      const ufc::function& f,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::cell& c,
                      const ufc::coordinate_mapping * cm=nullptr
                      ) const final override
  {
    // Declare variables for result of evaluation
    double vals[1];
    // Declare variable for physical coordinates
    double y[2];
    switch (i)
    {
    case 0:
        {
            y[0] = coordinate_dofs[0];
            y[1] = coordinate_dofs[1];
            f.evaluate(vals, y, c);
            return vals[0];
        }
        break;
    case 1:
        {
            y[0] = coordinate_dofs[2];
            y[1] = coordinate_dofs[3];
            f.evaluate(vals, y, c);
            return vals[0];
        }
        break;
    case 2:
        {
            y[0] = coordinate_dofs[4];
            y[1] = coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return vals[0];
        }
        break;
    }
    return 0.0;
  }

  void evaluate_dofs(double * values,
                             const ufc::function& f,
                             const double * coordinate_dofs,
                             int cell_orientation,
                             const ufc::cell& c,
                             const ufc::coordinate_mapping * cm=nullptr
                             ) const final override
  {
    // Declare variables for result of evaluation
    double vals[1];
    // Declare variable for physical coordinates
    double y[2];
    y[0] = coordinate_dofs[0];
    y[1] = coordinate_dofs[1];
    f.evaluate(vals, y, c);
    values[0] = vals[0];
    y[0] = coordinate_dofs[2];
    y[1] = coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[1] = vals[0];
    y[0] = coordinate_dofs[4];
    y[1] = coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[2] = vals[0];
  }

  void interpolate_vertex_values(double * vertex_values,
                                 const double * dof_values,
                                 const double * coordinate_dofs,
                                 int cell_orientation,
                                 const ufc::coordinate_mapping * cm=nullptr
                                 ) const final override
  {
    // Evaluate function and change variables
    vertex_values[0] = dof_values[0];
    vertex_values[1] = dof_values[1];
    vertex_values[2] = dof_values[2];
  }

  void tabulate_dof_coordinates(double * dof_coordinates,
                                const double * coordinate_dofs,
                                const ufc::coordinate_mapping * cm=nullptr
                                ) const final override
  {
    dof_coordinates[0] = coordinate_dofs[0];
    dof_coordinates[1] = coordinate_dofs[1];
    dof_coordinates[2] = coordinate_dofs[2];
    dof_coordinates[2 + 1] = coordinate_dofs[3];
    dof_coordinates[2 * 2] = coordinate_dofs[4];
    dof_coordinates[2 * 2 + 1] = coordinate_dofs[5];
  }

  void tabulate_reference_dof_coordinates(double * reference_dof_coordinates) const final override
  {
    static const double dof_X[6] = { 0.0, 0.0, 1.0, 0.0, 0.0, 1.0 };
    std::copy_n(dof_X, 6, reference_dof_coordinates);
  }

  std::size_t num_sub_elements() const final override
  {
    return 0;
  }

  ufc::finite_element * create_sub_element(std::size_t i) const final override
  {
    return nullptr;
  }

  ufc::finite_element * create() const final override
  {
    return new forms_finite_element_0();
  }

};


class forms_finite_element_1: public ufc::finite_element
{
public:

  forms_finite_element_1() : ufc::finite_element()
  {
    // Do nothing
  }

  ~forms_finite_element_1() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "VectorElement(FiniteElement('Lagrange', triangle, 1), dim=2)";
  }

  ufc::shape cell_shape() const final override
  {
    return ufc::shape::triangle;
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t geometric_dimension() const final override
  {
    return 2;
  }

  std::size_t space_dimension() const final override
  {
    return 6;
  }

  std::size_t value_rank() const final override
  {
    return 1;
  }

  std::size_t value_dimension(std::size_t i) const final override
  {
    static const int return_values[1] = { 2 };
    if (i >= 1)
        return 1;
    return return_values[i];
  }

  std::size_t value_size() const final override
  {
    return 2;
  }

  std::size_t reference_value_rank() const final override
  {
    return 1;
  }

  std::size_t reference_value_dimension(std::size_t i) const final override
  {
    static const int return_values[1] = { 2 };
    if (i >= 1)
        return 1;
    return return_values[i];
  }

  std::size_t reference_value_size() const final override
  {
    return 2;
  }

  std::size_t degree() const final override
  {
    return 1;
  }

  const char * family() const final override
  {
    return "Lagrange";
  }

  void evaluate_reference_basis(double * reference_values,
                                std::size_t num_points,
                                const double * X) const final override
  {
    static const double coefficients0[1][3] = { { 0.4714045207910316, -0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients1[1][3] = { { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients2[1][3] = { { 0.4714045207910316, 0.0, 0.3333333333333333 } };
    for (std::size_t k = 0; k < num_points * 6 * 2; ++k)
        reference_values[k] = 0.0;
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Map from UFC reference coordinate X to FIAT reference coordinate Y
        const double Y[2] = { 2.0 * X[ip * 2] - 1.0, 2.0 * X[ip * 2 + 1] - 1.0 };
        // Compute basisvalues for each relevant embedded degree
        double basisvalues1[3] = {};
        basisvalues1[0] = 1.0;
        const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
        basisvalues1[1] = tmp1_1;
        basisvalues1[2] = (0.5 + 1.5 * Y[1]) * basisvalues1[0];
        basisvalues1[0] *= std::sqrt(0.5);
        basisvalues1[2] *= std::sqrt(1.0);
        basisvalues1[1] *= std::sqrt(3.0);
        // Accumulate products of coefficients and basisvalues
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[6 * 2 * ip] += coefficients0[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[6 * 2 * ip + 2] += coefficients1[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[6 * 2 * ip + 2 * 2] += coefficients2[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[6 * 2 * ip + 2 * 3 + 1] += coefficients0[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[6 * 2 * ip + 2 * 4 + 1] += coefficients1[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[6 * 2 * ip + 2 * 5 + 1] += coefficients2[0][r] * basisvalues1[r];
    }
  }

  void evaluate_reference_basis_derivatives(double * reference_values,
                                            std::size_t order,
                                            std::size_t num_points,
                                            const double * X) const final override
  {
    if (order == 0)
    {
        evaluate_reference_basis(reference_values, num_points, X);
        return;
    }
    const std::size_t num_derivatives = std::pow(2, order);
    std::fill_n(reference_values, num_points * 6 * num_derivatives * 2, 0.0);
    if (order > 1)
        return;
    // Tables of derivatives of the polynomial base (transpose).
    alignas(32) static const double dmats0[2][3][3] =
        { { { 0.0, 0.0, 0.0 },
            { 4.8989794855663495, 0.0, 0.0 },
            { 0.0, 0.0, 0.0 } },
          { { 0.0, 0.0, 0.0 },
            { 2.449489742783182, 0.0, 0.0 },
            { 4.242640687119285, 0.0, 0.0 } } };
    static const double coefficients0[1][3] = { { 0.4714045207910316, -0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients1[1][3] = { { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients2[1][3] = { { 0.4714045207910316, 0.0, 0.3333333333333333 } };
    const std::size_t reference_offset[6] = { 0, 0, 0, 1, 1, 1 };
    const std::size_t num_components[6] = { 1, 1, 1, 1, 1, 1 };
    // Precomputed combinations
    const std::size_t combinations[1][2][1] =
        { { { 0 },
            { 1 } } };
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Map from UFC reference coordinate X to FIAT reference coordinate Y
        const double Y[2] = { 2.0 * X[ip * 2] - 1.0, 2.0 * X[ip * 2 + 1] - 1.0 };
        // Compute basisvalues for each relevant embedded degree
        double basisvalues1[3] = {};
        basisvalues1[0] = 1.0;
        const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
        basisvalues1[1] = tmp1_1;
        basisvalues1[2] = (0.5 + 1.5 * Y[1]) * basisvalues1[0];
        basisvalues1[0] *= std::sqrt(0.5);
        basisvalues1[2] *= std::sqrt(1.0);
        basisvalues1[1] *= std::sqrt(3.0);
        // Loop over all dofs
        for (std::size_t i = 0; i < 6; ++i)
        {
            double derivatives[2] = {};
            switch (i)
            {
            case 0:
                // Compute reference derivatives for dof 0.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients0[0][s] * aux[s];
                }
                break;
            case 1:
                // Compute reference derivatives for dof 1.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients1[0][s] * aux[s];
                }
                break;
            case 2:
                // Compute reference derivatives for dof 2.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients2[0][s] * aux[s];
                }
                break;
            case 3:
                // Compute reference derivatives for dof 3.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients0[0][s] * aux[s];
                }
                break;
            case 4:
                // Compute reference derivatives for dof 4.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients1[0][s] * aux[s];
                }
                break;
            case 5:
                // Compute reference derivatives for dof 5.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients2[0][s] * aux[s];
                }
                break;
            }
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t c = 0; c < num_components[i]; ++c)
                    reference_values[6 * (num_derivatives * 2) * ip + num_derivatives * 2 * i + 2 * r + (reference_offset[i] + c)] = derivatives[num_derivatives * c + r];
        }
    }
  }

  void transform_reference_basis_derivatives(double * values,
                                             std::size_t order,
                                             std::size_t num_points,
                                             const double * reference_values,
                                             const double * X,
                                             const double * J,
                                             const double * detJ,
                                             const double * K,
                                             int cell_orientation) const final override
  {
    const std::size_t num_derivatives = std::pow(2, order);
    // Precomputed combinations
    const std::size_t combinations[1][2][1] =
        { { { 0 },
            { 1 } } };
    std::fill_n(values, num_points * 6 * num_derivatives * 2, 0.0);
    const std::size_t reference_offsets[6] = { 0, 0, 0, 1, 1, 1 };
    const std::size_t physical_offsets[6] = { 0, 0, 0, 1, 1, 1 };
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        double transform[2][2];
        for (std::size_t r = 0; r < num_derivatives; ++r)
            for (std::size_t s = 0; s < num_derivatives; ++s)
                transform[r][s] = 1.0;
        for (std::size_t r = 0; r < num_derivatives; ++r)
            for (std::size_t s = 0; s < num_derivatives; ++s)
                for (std::size_t k = 0; k < order; ++k)
                    transform[r][s] *= K[2 * 2 * ip + 2 * combinations[order - 1][s][k] + combinations[order - 1][r][k]];
        for (std::size_t d = 0; d < 6; ++d)
        {
            for (std::size_t s = 0; s < num_derivatives; ++s)
            {
                for (std::size_t i = 0; i < 1; ++i)
                {
                    // Using affine transform to map values back to the physical element.
                    const double mapped_value = reference_values[6 * (num_derivatives * 2) * ip + num_derivatives * 2 * d + 2 * s + reference_offsets[d]];
                    // Mapping derivatives back to the physical element
                    for (std::size_t r = 0; r < num_derivatives; ++r)
                        values[6 * (num_derivatives * 2) * ip + num_derivatives * 2 * d + 2 * r + (physical_offsets[d] + i)] += transform[r][s] * mapped_value;
                }
            }
        }
    }
  }

  void evaluate_basis(std::size_t i,
                      double * values,
                      const double * x,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::coordinate_mapping * cm=nullptr
                      ) const final override
  {
    double X[2] = {};
    double J[4];
    double detJ;
    double K[4];
    if (cm)
    {
        cm->compute_reference_geometry(X, J, &detJ, K, 1, x, coordinate_dofs, cell_orientation);
    }
    else
    {
        compute_jacobian_triangle_2d(J, coordinate_dofs);
        compute_jacobian_inverse_triangle_2d(K, detJ, J);
        // Compute constants
        const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
        const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
        // Get coordinates and map to the reference (FIAT) element
        double Y[2] = { (J[1] * (C1 - 2.0 * x[1]) + J[3] * (2.0 * x[0] - C0)) / detJ, (J[0] * (2.0 * x[1] - C1) + J[2] * (C0 - 2.0 * x[0])) / detJ };
        // Map to FFC reference coordinate
        for (std::size_t k = 0; k < 2; ++k)
            X[k] = (Y[k] + 1.0) / 2.0;
    }
    // Evaluate basis on reference element
    double ref_values[12];
    evaluate_reference_basis(ref_values, 1, X);
    // Push forward
    double physical_values[12];
    transform_reference_basis_derivatives(physical_values, 0, 1, ref_values, X, J, &detJ, K, cell_orientation);
    for (std::size_t k = 0; k < 2; ++k)
        values[k] = physical_values[2 * i + k];
  }

  void evaluate_basis_all(double * values,
                          const double * x,
                          const double * coordinate_dofs,
                          int cell_orientation,
                          const ufc::coordinate_mapping * cm=nullptr
                          ) const final override
  {
    // Helper variable to hold values of a single dof.
    double dof_values[2] = {};
    // Loop dofs and call evaluate_basis
    for (std::size_t r = 0; r < 6; ++r)
    {
        evaluate_basis(r, dof_values, x, coordinate_dofs, cell_orientation);
        for (std::size_t s = 0; s < 2; ++s)
            values[r * 2 + s] = dof_values[s];
    }
  }

  void evaluate_basis_derivatives(std::size_t i,
                                  std::size_t n,
                                  double * values,
                                  const double * x,
                                  const double * coordinate_dofs,
                                  int cell_orientation,
                                  const ufc::coordinate_mapping * cm=nullptr
                                  ) const final override
  {
    std::size_t num_derivatives = std::pow(2, n);
    std::fill_n(values, 2 * num_derivatives, 0.0);
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
        evaluate_basis(i, values, x, coordinate_dofs, cell_orientation);
        return;
    }
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 1)
        return;
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    // Compute Inverse Jacobian and determinant
    double K[4];
    double detJ;
    compute_jacobian_inverse_triangle_2d(K, detJ, J);
    // Compute constants
    const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
    const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
    // Get coordinates and map to the reference (FIAT) element
    double Y[2] = { (J[1] * (C1 - 2.0 * x[1]) + J[3] * (2.0 * x[0] - C0)) / detJ, (J[0] * (2.0 * x[1] - C1) + J[2] * (C0 - 2.0 * x[0])) / detJ };
    // Precomputed combinations
    const std::size_t combinations[1][2][1] =
        { { { 0 },
            { 1 } } };
    // Declare transformation matrix
    double transform[2][2] =
        { { 1.0, 1.0 },
          { 1.0, 1.0 } };
    // Construct transformation matrix
    for (std::size_t row = 0; row < num_derivatives; ++row)
        for (std::size_t col = 0; col < num_derivatives; ++col)
            for (std::size_t k = 0; k < n; ++k)
                transform[row][col] *= K[2 * combinations[n - 1][col][k] + combinations[n - 1][row][k]];
    switch (i)
    {
    case 0:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910316, -0.2886751345948129, -0.16666666666666666 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[r] += transform[r][s] * derivatives[s];
        }
        break;
    case 1:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[r] += transform[r][s] * derivatives[s];
        }
        break;
    case 2:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910316, 0.0, 0.3333333333333333 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[r] += transform[r][s] * derivatives[s];
        }
        break;
    case 3:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910316, -0.2886751345948129, -0.16666666666666666 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[num_derivatives + r] += transform[r][s] * derivatives[s];
        }
        break;
    case 4:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[num_derivatives + r] += transform[r][s] * derivatives[s];
        }
        break;
    case 5:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910316, 0.0, 0.3333333333333333 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[num_derivatives + r] += transform[r][s] * derivatives[s];
        }
        break;
    }
  }

  void evaluate_basis_derivatives_all(std::size_t n,
                                      double * values,
                                      const double * x,
                                      const double * coordinate_dofs,
                                      int cell_orientation,
                                      const ufc::coordinate_mapping * cm=nullptr
                                      ) const final override
  {
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
        evaluate_basis_all(values, x, coordinate_dofs, cell_orientation);
        return;
    }
    unsigned int num_derivatives = std::pow(2, n);
    // Set values equal to zero.
    std::fill_n(values, 2 * num_derivatives * 6, 0.0);
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 1)
        return;
    // Helper variable to hold values of a single dof.
    double dof_values[4] = {};
    // Loop dofs and call evaluate_basis_derivatives.
    for (std::size_t r = 0; r < 6; ++r)
    {
        evaluate_basis_derivatives(r, n, dof_values, x, coordinate_dofs, cell_orientation);
        for (std::size_t s = 0; s < 2 * num_derivatives; ++s)
            values[2 * num_derivatives * r + s] = dof_values[s];
    }
  }

  double evaluate_dof(std::size_t i,
                      const ufc::function& f,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::cell& c,
                      const ufc::coordinate_mapping * cm=nullptr
                      ) const final override
  {
    // Declare variables for result of evaluation
    double vals[2];
    // Declare variable for physical coordinates
    double y[2];
    switch (i)
    {
    case 0:
        {
            y[0] = coordinate_dofs[0];
            y[1] = coordinate_dofs[1];
            f.evaluate(vals, y, c);
            return vals[0];
        }
        break;
    case 1:
        {
            y[0] = coordinate_dofs[2];
            y[1] = coordinate_dofs[3];
            f.evaluate(vals, y, c);
            return vals[0];
        }
        break;
    case 2:
        {
            y[0] = coordinate_dofs[4];
            y[1] = coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return vals[0];
        }
        break;
    case 3:
        {
            y[0] = coordinate_dofs[0];
            y[1] = coordinate_dofs[1];
            f.evaluate(vals, y, c);
            return vals[1];
        }
        break;
    case 4:
        {
            y[0] = coordinate_dofs[2];
            y[1] = coordinate_dofs[3];
            f.evaluate(vals, y, c);
            return vals[1];
        }
        break;
    case 5:
        {
            y[0] = coordinate_dofs[4];
            y[1] = coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return vals[1];
        }
        break;
    }
    return 0.0;
  }

  void evaluate_dofs(double * values,
                             const ufc::function& f,
                             const double * coordinate_dofs,
                             int cell_orientation,
                             const ufc::cell& c,
                             const ufc::coordinate_mapping * cm=nullptr
                             ) const final override
  {
    // Declare variables for result of evaluation
    double vals[2];
    // Declare variable for physical coordinates
    double y[2];
    y[0] = coordinate_dofs[0];
    y[1] = coordinate_dofs[1];
    f.evaluate(vals, y, c);
    values[0] = vals[0];
    y[0] = coordinate_dofs[2];
    y[1] = coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[1] = vals[0];
    y[0] = coordinate_dofs[4];
    y[1] = coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[2] = vals[0];
    y[0] = coordinate_dofs[0];
    y[1] = coordinate_dofs[1];
    f.evaluate(vals, y, c);
    values[3] = vals[1];
    y[0] = coordinate_dofs[2];
    y[1] = coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[4] = vals[1];
    y[0] = coordinate_dofs[4];
    y[1] = coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[5] = vals[1];
  }

  void interpolate_vertex_values(double * vertex_values,
                                 const double * dof_values,
                                 const double * coordinate_dofs,
                                 int cell_orientation,
                                 const ufc::coordinate_mapping * cm=nullptr
                                 ) const final override
  {
    // Evaluate function and change variables
    vertex_values[0] = dof_values[0];
    vertex_values[2] = dof_values[1];
    vertex_values[4] = dof_values[2];
    // Evaluate function and change variables
    vertex_values[1] = dof_values[3];
    vertex_values[3] = dof_values[4];
    vertex_values[5] = dof_values[5];
  }

  void tabulate_dof_coordinates(double * dof_coordinates,
                                const double * coordinate_dofs,
                                const ufc::coordinate_mapping * cm=nullptr
                                ) const final override
  {
    dof_coordinates[0] = coordinate_dofs[0];
    dof_coordinates[1] = coordinate_dofs[1];
    dof_coordinates[2] = coordinate_dofs[2];
    dof_coordinates[2 + 1] = coordinate_dofs[3];
    dof_coordinates[2 * 2] = coordinate_dofs[4];
    dof_coordinates[2 * 2 + 1] = coordinate_dofs[5];
    dof_coordinates[2 * 3] = coordinate_dofs[0];
    dof_coordinates[2 * 3 + 1] = coordinate_dofs[1];
    dof_coordinates[2 * 4] = coordinate_dofs[2];
    dof_coordinates[2 * 4 + 1] = coordinate_dofs[3];
    dof_coordinates[2 * 5] = coordinate_dofs[4];
    dof_coordinates[2 * 5 + 1] = coordinate_dofs[5];
  }

  void tabulate_reference_dof_coordinates(double * reference_dof_coordinates) const final override
  {
    static const double dof_X[12] = { 0.0, 0.0, 1.0, 0.0, 0.0, 1.0, 0.0, 0.0, 1.0, 0.0, 0.0, 1.0 };
    std::copy_n(dof_X, 12, reference_dof_coordinates);
  }

  std::size_t num_sub_elements() const final override
  {
    return 2;
  }

  ufc::finite_element * create_sub_element(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
        return new forms_finite_element_0();
    case 1:
        return new forms_finite_element_0();
    default:
        return nullptr;
    }
  }

  ufc::finite_element * create() const final override
  {
    return new forms_finite_element_1();
  }

};


class forms_finite_element_2: public ufc::finite_element
{
public:

  forms_finite_element_2() : ufc::finite_element()
  {
    // Do nothing
  }

  ~forms_finite_element_2() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FiniteElement('Nedelec 1st kind H(curl)', triangle, 3)";
  }

  ufc::shape cell_shape() const final override
  {
    return ufc::shape::triangle;
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t geometric_dimension() const final override
  {
    return 2;
  }

  std::size_t space_dimension() const final override
  {
    return 15;
  }

  std::size_t value_rank() const final override
  {
    return 1;
  }

  std::size_t value_dimension(std::size_t i) const final override
  {
    static const int return_values[1] = { 2 };
    if (i >= 1)
        return 1;
    return return_values[i];
  }

  std::size_t value_size() const final override
  {
    return 2;
  }

  std::size_t reference_value_rank() const final override
  {
    return 1;
  }

  std::size_t reference_value_dimension(std::size_t i) const final override
  {
    static const int return_values[1] = { 2 };
    if (i >= 1)
        return 1;
    return return_values[i];
  }

  std::size_t reference_value_size() const final override
  {
    return 2;
  }

  std::size_t degree() const final override
  {
    return 3;
  }

  const char * family() const final override
  {
    return "Nedelec 1st kind H(curl)";
  }

  void evaluate_reference_basis(double * reference_values,
                                std::size_t num_points,
                                const double * X) const final override
  {
    static const double coefficients0[2][10] =
        { { 0.0, 0.0, 0.0, -0.16953317256112307, 0.08417937871268409, -0.1166423687039609, 0.0, -0.14682003422210352, 0.07290148043997545, -0.101015254455221 },
          { 0.0, 0.0, 0.0, 0.3216783274236693, -0.13468700594029498, 0.09720197391996732, 0.2605797108646139, -0.12987926104263026, 0.0976879837895673, -0.06313453403451333 } };
    static const double coefficients1[2][10] =
        { { 0.0, 0.0, 0.0, 0.07824607964359526, -0.16835875742536813, 0.34992710611188194, 0.0, 0.06776309271789388, -0.14580296087995095, 0.3030457633656627 },
          { 0.0, 0.0, 0.0, -0.16518616813647946, 0.2357022603955164, -0.27216552697590884, -0.1202675588605913, 0.14682003422210396, -0.22453655975512488, 0.17677669529663703 } };
    static const double coefficients2[2][10] =
        { { 0.0, 0.0, 0.0, -0.03912303982179776, -0.08417937871268412, -0.34992710611188216, 0.0, -0.03388154635894711, -0.07290148043997535, -0.30304576336566275 },
          { 0.0, 0.0, 0.0, 0.060858061945018735, 0.0, 0.21384434262392865, 0.06013377943029568, 0.039528470752104444, 0.11226827987756266, -0.13889597487592917 } };
    static const double coefficients3[2][10] =
        { { 0.0, 0.0, 0.0, 0.16953317256112282, 0.08417937871268409, 0.11664236870396072, 0.0, 0.1468200342221034, 0.07290148043997549, 0.10101525445522096 },
          { 0.0, 0.0, 0.0, 0.4912114999847917, 0.21886638465297917, 0.21384434262392815, -0.26057971086461335, 0.016940773179473456, -0.024786503349591718, 0.03788072042070801 } };
    static const double coefficients4[2][10] =
        { { 0.0, 0.0, 0.0, -0.07824607964359549, -0.16835875742536838, -0.3499271061118821, 0.0, -0.06776309271789405, -0.14580296087995095, -0.3030457633656629 },
          { 0.0, 0.0, 0.0, -0.24343224778007372, -0.40406101782088477, -0.6220926330877907, 0.12026755886059089, 0.07905694150420943, 0.07873359887517391, -0.12626906806902663 } };
    static const double coefficients5[2][10] =
        { { 0.0, 0.0, 0.0, 0.03912303982179758, -0.08417937871268408, 0.34992710611188205, 0.0, 0.03388154635894694, -0.0729014804399755, 0.30304576336566263 },
          { 0.0, 0.0, 0.0, 0.09998110176681554, -0.08417937871268362, 0.5637714487358108, -0.06013377943029564, 0.07341001711105215, -0.18516976031753812, 0.16414978848973438 } };
    static const double coefficients6[2][10] =
        { { 0.0, 0.0, 0.0, 0.3825363893686873, 0.3030457633656633, 0.31104631654389586, 0.0, -0.09035079029052527, -0.14580296087995082, -0.2020305089104422 },
          { 0.0, 0.0, 0.0, 0.1695331725611229, 0.08417937871268408, 0.11664236870396132, 0.16035674514745452, 0.06776309271789378, 0.03207665139358949, -0.0757614408414161 } };
    static const double coefficients7[2][10] =
        { { 0.0, 0.0, 0.0, -0.765072778737375, 0.0, -0.15552315827194774, 0.0, 0.1807015805810504, 0.0, 0.10101525445522148 },
          { 0.0, 0.0, 0.0, -0.38253638936868783, 0.06734350297014773, -0.07776157913597416, -0.32071349029490925, 0.0903507902905256, -0.06415330278717872, 0.05050762722761091 } };
    static const double coefficients8[2][10] =
        { { 0.0, 0.0, 0.0, 0.38253638936868767, -0.30304576336566375, 0.3110463165438962, 0.0, -0.0903507902905251, 0.145802960879951, -0.20203050891044222 },
          { 0.0, 0.0, 0.0, 0.2130032168075653, -0.2188663846529795, 0.19440394783993487, 0.16035674514745485, -0.15811388300841958, 0.17787961227354063, -0.12626906806902666 } };
    static const double coefficients9[2][10] =
        { { 4.0, 0.0, 0.0, -0.3688555567816587, -0.4761904761904759, -1.6495721976846462, 0.0, -0.3194382824999704, -0.4123930494211606, 0.5714285714285696 },
          { 0.0, 0.0, 0.0, 0.6147592613027634, 0.4761904761904768, -0.5498573992282151, 0.5669467095138395, 0.15971914124998568, -0.4536323543632773, 0.3571428571428569 } };
    static const double coefficients10[2][10] =
        { { 0.0, 3.999999999999999, 0.0, -0.6776309271789399, 1.8079567149113953, 0.0, 0.0, -0.5868455973269651, -1.2626906806902614, 0.0 },
          { 0.0, 0.0, 0.0, 1.0540925533894574, 1.1664236870396085, -0.33671751485073437, 1.0415476122441185, 0.6846531968814584, -0.5808377131175199, 0.21870444131992534 } };
    static const double coefficients11[2][10] =
        { { 0.0, 0.0, 3.9999999999999987, 0.13041013273932475, -0.84179378712684, 0.9331389496316896, 0.0, 0.11293848786315532, -0.729014804399754, -2.020305089104418 },
          { 0.0, 0.0, 0.0, -0.3477603539715319, 0.3367175148507361, 1.360827634879548, -0.20044593143431677, 0.6211616832473597, 0.5977921396078015, -0.8838834764831853 } };
    static const double coefficients12[2][10] =
        { { 0.0, 0.0, 0.0, 0.0, 0.9523809523809509, 0.0, 0.0, 0.0, 0.8247860988423217, 0.0 },
          { 3.999999999999999, 0.0, 0.0, -1.5983740793871857, 0.4761904761904763, -0.5498573992282167, 0.0, -0.6388765649999416, 0.41239304942116045, -0.14285714285714188 } };
    static const double coefficients13[2][10] =
        { { 0.0, 0.0, 0.0, 1.3552618543578774, 0.0, 0.0, 0.0, 1.1736911946539281, 0.0, 0.0 },
          { 0.0, 3.999999999999998, 0.0, 0.6776309271789369, -0.5248906591678232, 0.0, -2.0830952244882384, 0.5868455973269647, -0.10101525445522135, 0.0 } };
    static const double coefficients14[2][10] =
        { { 0.0, 0.0, 0.0, 0.0, 1.6835875742536806, 0.0, 0.0, 0.0, 1.4580296087995086, 0.0 },
          { 0.0, 0.0, 3.9999999999999987, 0.8259308406823964, 0.8417937871268396, -1.788516320127402, 0.0, -1.1293848786315668, 0.7290148043997551, -0.2525381361380525 } };
    for (std::size_t k = 0; k < num_points * 15 * 2; ++k)
        reference_values[k] = 0.0;
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Map from UFC reference coordinate X to FIAT reference coordinate Y
        const double Y[2] = { 2.0 * X[ip * 2] - 1.0, 2.0 * X[ip * 2 + 1] - 1.0 };
        // Compute basisvalues for each relevant embedded degree
        double basisvalues3[10] = {};
        basisvalues3[0] = 1.0;
        const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
        basisvalues3[1] = tmp1_3;
        const double tmp2_3 = (1.0 - Y[1]) / 2.0;
        const double tmp3_3 = tmp2_3 * tmp2_3;
        basisvalues3[3] = 1.5 * tmp1_3 * basisvalues3[1] - 0.5 * tmp3_3 * basisvalues3[0];
        basisvalues3[6] = 1.6666666666666667 * tmp1_3 * basisvalues3[3] - 0.6666666666666666 * tmp3_3 * basisvalues3[1];
        basisvalues3[2] = (0.5 + 1.5 * Y[1]) * basisvalues3[0];
        basisvalues3[4] = (1.5 + 2.5 * Y[1]) * basisvalues3[1];
        basisvalues3[7] = (2.5 + 3.5 * Y[1]) * basisvalues3[3];
        basisvalues3[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues3[2] - 0.5555555555555556 * basisvalues3[0];
        basisvalues3[9] = (0.05 + 1.75 * Y[1]) * basisvalues3[5] - 0.7 * basisvalues3[2];
        basisvalues3[8] = (0.54 + 2.1 * Y[1]) * basisvalues3[4] - 0.56 * basisvalues3[1];
        basisvalues3[0] *= std::sqrt(0.5);
        basisvalues3[2] *= std::sqrt(1.0);
        basisvalues3[5] *= std::sqrt(1.5);
        basisvalues3[9] *= std::sqrt(2.0);
        basisvalues3[1] *= std::sqrt(3.0);
        basisvalues3[4] *= std::sqrt(4.5);
        basisvalues3[8] *= std::sqrt(6.0);
        basisvalues3[3] *= std::sqrt(7.5);
        basisvalues3[7] *= std::sqrt(10.0);
        basisvalues3[6] *= std::sqrt(14.0);
        // Accumulate products of coefficients and basisvalues
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + c] += coefficients0[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 + c] += coefficients1[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 2 + c] += coefficients2[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 3 + c] += coefficients3[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 4 + c] += coefficients4[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 5 + c] += coefficients5[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 6 + c] += coefficients6[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 7 + c] += coefficients7[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 8 + c] += coefficients8[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 9 + c] += coefficients9[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 10 + c] += coefficients10[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 11 + c] += coefficients11[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 12 + c] += coefficients12[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 13 + c] += coefficients13[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 14 + c] += coefficients14[c][r] * basisvalues3[r];
    }
  }

  void evaluate_reference_basis_derivatives(double * reference_values,
                                            std::size_t order,
                                            std::size_t num_points,
                                            const double * X) const final override
  {
    if (order == 0)
    {
        evaluate_reference_basis(reference_values, num_points, X);
        return;
    }
    const std::size_t num_derivatives = std::pow(2, order);
    std::fill_n(reference_values, num_points * 15 * num_derivatives * 2, 0.0);
    if (order > 3)
        return;
    // Tables of derivatives of the polynomial base (transpose).
    alignas(32) static const double dmats0[2][10][10] =
        { { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 4.898979485566348, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 3.9999999999999982, 0.0, 7.07106781186547, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 5.291502622129197, 0.0, -2.9933259094191635, 13.66260102127946, 0.0, 0.6110100926607809, 0.0, 0.0, 0.0, 0.0 },
            { 0.0, 4.381780460041333, 0.0, 0.0, 12.52198067399882, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 3.464101615137761, 0.0, 7.83836717690618, 0.0, 0.0, 8.400000000000007, 0.0, 0.0, 0.0, 0.0 },
            { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } },
          { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 2.4494897427831814, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 4.242640687119283, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 2.581988897471622, 4.743416490252575, -0.9128709291752798, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 1.9999999999999196, 6.12372435695794, 3.535533905932734, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { -2.309401076758484, 0.0, 8.16496580927727, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 2.6457513110645765, 5.1845925587262585, -1.4966629547095691, 6.8313005106397275, -1.0583005244258326, 0.3055050463303891, 0.0, 0.0, 0.0, 0.0 },
            { 2.2360679774998298, 2.190890230020675, 2.5298221281346795, 8.082903768654777, 6.260990336999407, -1.807392228230123, 0.0, 0.0, 0.0, 0.0 },
            { 1.7320508075688756, -5.0911688245431455, 3.9191835884531003, 0.0, 9.699484522385692, 4.200000000000009, 0.0, 0.0, 0.0, 0.0 },
            { 5.0000000000000195, 0.0, -2.828427124746231, 0.0, 0.0, 12.124355652982162, 0.0, 0.0, 0.0, 0.0 } } };
    static const double coefficients0[2][10] =
        { { 0.0, 0.0, 0.0, -0.16953317256112307, 0.08417937871268409, -0.1166423687039609, 0.0, -0.14682003422210352, 0.07290148043997545, -0.101015254455221 },
          { 0.0, 0.0, 0.0, 0.3216783274236693, -0.13468700594029498, 0.09720197391996732, 0.2605797108646139, -0.12987926104263026, 0.0976879837895673, -0.06313453403451333 } };
    static const double coefficients1[2][10] =
        { { 0.0, 0.0, 0.0, 0.07824607964359526, -0.16835875742536813, 0.34992710611188194, 0.0, 0.06776309271789388, -0.14580296087995095, 0.3030457633656627 },
          { 0.0, 0.0, 0.0, -0.16518616813647946, 0.2357022603955164, -0.27216552697590884, -0.1202675588605913, 0.14682003422210396, -0.22453655975512488, 0.17677669529663703 } };
    static const double coefficients2[2][10] =
        { { 0.0, 0.0, 0.0, -0.03912303982179776, -0.08417937871268412, -0.34992710611188216, 0.0, -0.03388154635894711, -0.07290148043997535, -0.30304576336566275 },
          { 0.0, 0.0, 0.0, 0.060858061945018735, 0.0, 0.21384434262392865, 0.06013377943029568, 0.039528470752104444, 0.11226827987756266, -0.13889597487592917 } };
    static const double coefficients3[2][10] =
        { { 0.0, 0.0, 0.0, 0.16953317256112282, 0.08417937871268409, 0.11664236870396072, 0.0, 0.1468200342221034, 0.07290148043997549, 0.10101525445522096 },
          { 0.0, 0.0, 0.0, 0.4912114999847917, 0.21886638465297917, 0.21384434262392815, -0.26057971086461335, 0.016940773179473456, -0.024786503349591718, 0.03788072042070801 } };
    static const double coefficients4[2][10] =
        { { 0.0, 0.0, 0.0, -0.07824607964359549, -0.16835875742536838, -0.3499271061118821, 0.0, -0.06776309271789405, -0.14580296087995095, -0.3030457633656629 },
          { 0.0, 0.0, 0.0, -0.24343224778007372, -0.40406101782088477, -0.6220926330877907, 0.12026755886059089, 0.07905694150420943, 0.07873359887517391, -0.12626906806902663 } };
    static const double coefficients5[2][10] =
        { { 0.0, 0.0, 0.0, 0.03912303982179758, -0.08417937871268408, 0.34992710611188205, 0.0, 0.03388154635894694, -0.0729014804399755, 0.30304576336566263 },
          { 0.0, 0.0, 0.0, 0.09998110176681554, -0.08417937871268362, 0.5637714487358108, -0.06013377943029564, 0.07341001711105215, -0.18516976031753812, 0.16414978848973438 } };
    static const double coefficients6[2][10] =
        { { 0.0, 0.0, 0.0, 0.3825363893686873, 0.3030457633656633, 0.31104631654389586, 0.0, -0.09035079029052527, -0.14580296087995082, -0.2020305089104422 },
          { 0.0, 0.0, 0.0, 0.1695331725611229, 0.08417937871268408, 0.11664236870396132, 0.16035674514745452, 0.06776309271789378, 0.03207665139358949, -0.0757614408414161 } };
    static const double coefficients7[2][10] =
        { { 0.0, 0.0, 0.0, -0.765072778737375, 0.0, -0.15552315827194774, 0.0, 0.1807015805810504, 0.0, 0.10101525445522148 },
          { 0.0, 0.0, 0.0, -0.38253638936868783, 0.06734350297014773, -0.07776157913597416, -0.32071349029490925, 0.0903507902905256, -0.06415330278717872, 0.05050762722761091 } };
    static const double coefficients8[2][10] =
        { { 0.0, 0.0, 0.0, 0.38253638936868767, -0.30304576336566375, 0.3110463165438962, 0.0, -0.0903507902905251, 0.145802960879951, -0.20203050891044222 },
          { 0.0, 0.0, 0.0, 0.2130032168075653, -0.2188663846529795, 0.19440394783993487, 0.16035674514745485, -0.15811388300841958, 0.17787961227354063, -0.12626906806902666 } };
    static const double coefficients9[2][10] =
        { { 4.0, 0.0, 0.0, -0.3688555567816587, -0.4761904761904759, -1.6495721976846462, 0.0, -0.3194382824999704, -0.4123930494211606, 0.5714285714285696 },
          { 0.0, 0.0, 0.0, 0.6147592613027634, 0.4761904761904768, -0.5498573992282151, 0.5669467095138395, 0.15971914124998568, -0.4536323543632773, 0.3571428571428569 } };
    static const double coefficients10[2][10] =
        { { 0.0, 3.999999999999999, 0.0, -0.6776309271789399, 1.8079567149113953, 0.0, 0.0, -0.5868455973269651, -1.2626906806902614, 0.0 },
          { 0.0, 0.0, 0.0, 1.0540925533894574, 1.1664236870396085, -0.33671751485073437, 1.0415476122441185, 0.6846531968814584, -0.5808377131175199, 0.21870444131992534 } };
    static const double coefficients11[2][10] =
        { { 0.0, 0.0, 3.9999999999999987, 0.13041013273932475, -0.84179378712684, 0.9331389496316896, 0.0, 0.11293848786315532, -0.729014804399754, -2.020305089104418 },
          { 0.0, 0.0, 0.0, -0.3477603539715319, 0.3367175148507361, 1.360827634879548, -0.20044593143431677, 0.6211616832473597, 0.5977921396078015, -0.8838834764831853 } };
    static const double coefficients12[2][10] =
        { { 0.0, 0.0, 0.0, 0.0, 0.9523809523809509, 0.0, 0.0, 0.0, 0.8247860988423217, 0.0 },
          { 3.999999999999999, 0.0, 0.0, -1.5983740793871857, 0.4761904761904763, -0.5498573992282167, 0.0, -0.6388765649999416, 0.41239304942116045, -0.14285714285714188 } };
    static const double coefficients13[2][10] =
        { { 0.0, 0.0, 0.0, 1.3552618543578774, 0.0, 0.0, 0.0, 1.1736911946539281, 0.0, 0.0 },
          { 0.0, 3.999999999999998, 0.0, 0.6776309271789369, -0.5248906591678232, 0.0, -2.0830952244882384, 0.5868455973269647, -0.10101525445522135, 0.0 } };
    static const double coefficients14[2][10] =
        { { 0.0, 0.0, 0.0, 0.0, 1.6835875742536806, 0.0, 0.0, 0.0, 1.4580296087995086, 0.0 },
          { 0.0, 0.0, 3.9999999999999987, 0.8259308406823964, 0.8417937871268396, -1.788516320127402, 0.0, -1.1293848786315668, 0.7290148043997551, -0.2525381361380525 } };
    const std::size_t reference_offset[15] = {};
    const std::size_t num_components[15] = { 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2 };
    // Precomputed combinations
    const std::size_t combinations[3][8][3] =
        { { { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 } },
          { { 0, 0, 0 },
            { 0, 1, 0 },
            { 1, 0, 0 },
            { 1, 1, 0 },
            { 0, 0, 0 },
            { 0, 1, 0 },
            { 1, 0, 0 },
            { 1, 1, 0 } },
          { { 0, 0, 0 },
            { 0, 0, 1 },
            { 0, 1, 0 },
            { 0, 1, 1 },
            { 1, 0, 0 },
            { 1, 0, 1 },
            { 1, 1, 0 },
            { 1, 1, 1 } } };
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Map from UFC reference coordinate X to FIAT reference coordinate Y
        const double Y[2] = { 2.0 * X[ip * 2] - 1.0, 2.0 * X[ip * 2 + 1] - 1.0 };
        // Compute basisvalues for each relevant embedded degree
        double basisvalues3[10] = {};
        basisvalues3[0] = 1.0;
        const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
        basisvalues3[1] = tmp1_3;
        const double tmp2_3 = (1.0 - Y[1]) / 2.0;
        const double tmp3_3 = tmp2_3 * tmp2_3;
        basisvalues3[3] = 1.5 * tmp1_3 * basisvalues3[1] - 0.5 * tmp3_3 * basisvalues3[0];
        basisvalues3[6] = 1.6666666666666667 * tmp1_3 * basisvalues3[3] - 0.6666666666666666 * tmp3_3 * basisvalues3[1];
        basisvalues3[2] = (0.5 + 1.5 * Y[1]) * basisvalues3[0];
        basisvalues3[4] = (1.5 + 2.5 * Y[1]) * basisvalues3[1];
        basisvalues3[7] = (2.5 + 3.5 * Y[1]) * basisvalues3[3];
        basisvalues3[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues3[2] - 0.5555555555555556 * basisvalues3[0];
        basisvalues3[9] = (0.05 + 1.75 * Y[1]) * basisvalues3[5] - 0.7 * basisvalues3[2];
        basisvalues3[8] = (0.54 + 2.1 * Y[1]) * basisvalues3[4] - 0.56 * basisvalues3[1];
        basisvalues3[0] *= std::sqrt(0.5);
        basisvalues3[2] *= std::sqrt(1.0);
        basisvalues3[5] *= std::sqrt(1.5);
        basisvalues3[9] *= std::sqrt(2.0);
        basisvalues3[1] *= std::sqrt(3.0);
        basisvalues3[4] *= std::sqrt(4.5);
        basisvalues3[8] *= std::sqrt(6.0);
        basisvalues3[3] *= std::sqrt(7.5);
        basisvalues3[7] *= std::sqrt(10.0);
        basisvalues3[6] *= std::sqrt(14.0);
        // Loop over all dofs
        for (std::size_t i = 0; i < 15; ++i)
        {
            double derivatives[16] = {};
            switch (i)
            {
            case 0:
                // Compute reference derivatives for dof 0.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients0[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients0[1][s] * aux[s];
                    }
                }
                break;
            case 1:
                // Compute reference derivatives for dof 1.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients1[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients1[1][s] * aux[s];
                    }
                }
                break;
            case 2:
                // Compute reference derivatives for dof 2.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients2[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients2[1][s] * aux[s];
                    }
                }
                break;
            case 3:
                // Compute reference derivatives for dof 3.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients3[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients3[1][s] * aux[s];
                    }
                }
                break;
            case 4:
                // Compute reference derivatives for dof 4.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients4[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients4[1][s] * aux[s];
                    }
                }
                break;
            case 5:
                // Compute reference derivatives for dof 5.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients5[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients5[1][s] * aux[s];
                    }
                }
                break;
            case 6:
                // Compute reference derivatives for dof 6.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients6[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients6[1][s] * aux[s];
                    }
                }
                break;
            case 7:
                // Compute reference derivatives for dof 7.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients7[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients7[1][s] * aux[s];
                    }
                }
                break;
            case 8:
                // Compute reference derivatives for dof 8.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients8[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients8[1][s] * aux[s];
                    }
                }
                break;
            case 9:
                // Compute reference derivatives for dof 9.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients9[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients9[1][s] * aux[s];
                    }
                }
                break;
            case 10:
                // Compute reference derivatives for dof 10.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients10[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients10[1][s] * aux[s];
                    }
                }
                break;
            case 11:
                // Compute reference derivatives for dof 11.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients11[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients11[1][s] * aux[s];
                    }
                }
                break;
            case 12:
                // Compute reference derivatives for dof 12.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients12[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients12[1][s] * aux[s];
                    }
                }
                break;
            case 13:
                // Compute reference derivatives for dof 13.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients13[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients13[1][s] * aux[s];
                    }
                }
                break;
            case 14:
                // Compute reference derivatives for dof 14.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients14[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients14[1][s] * aux[s];
                    }
                }
                break;
            }
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t c = 0; c < num_components[i]; ++c)
                    reference_values[15 * (num_derivatives * 2) * ip + num_derivatives * 2 * i + 2 * r + (reference_offset[i] + c)] = derivatives[num_derivatives * c + r];
        }
    }
  }

  void transform_reference_basis_derivatives(double * values,
                                             std::size_t order,
                                             std::size_t num_points,
                                             const double * reference_values,
                                             const double * X,
                                             const double * J,
                                             const double * detJ,
                                             const double * K,
                                             int cell_orientation) const final override
  {
    const std::size_t num_derivatives = std::pow(2, order);
    // Precomputed combinations
    const std::size_t combinations[3][8][3] =
        { { { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 } },
          { { 0, 0, 0 },
            { 0, 1, 0 },
            { 1, 0, 0 },
            { 1, 1, 0 },
            { 0, 0, 0 },
            { 0, 1, 0 },
            { 1, 0, 0 },
            { 1, 1, 0 } },
          { { 0, 0, 0 },
            { 0, 0, 1 },
            { 0, 1, 0 },
            { 0, 1, 1 },
            { 1, 0, 0 },
            { 1, 0, 1 },
            { 1, 1, 0 },
            { 1, 1, 1 } } };
    std::fill_n(values, num_points * 15 * num_derivatives * 2, 0.0);
    const std::size_t reference_offsets[15] = {};
    const std::size_t physical_offsets[15] = {};
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        double transform[8][8];
        for (std::size_t r = 0; r < num_derivatives; ++r)
            for (std::size_t s = 0; s < num_derivatives; ++s)
                transform[r][s] = 1.0;
        for (std::size_t r = 0; r < num_derivatives; ++r)
            for (std::size_t s = 0; s < num_derivatives; ++s)
                for (std::size_t k = 0; k < order; ++k)
                    transform[r][s] *= K[2 * 2 * ip + 2 * combinations[order - 1][s][k] + combinations[order - 1][r][k]];
        for (std::size_t d = 0; d < 15; ++d)
        {
            for (std::size_t s = 0; s < num_derivatives; ++s)
            {
                for (std::size_t i = 0; i < 2; ++i)
                {
                    // Using covariant Piola transform to map values back to the physical element.
                    const double mapped_value = K[2 * 2 * ip + i] * reference_values[15 * (num_derivatives * 2) * ip + num_derivatives * 2 * d + 2 * s + reference_offsets[d]] + K[2 * 2 * ip + 2 + i] * reference_values[15 * (num_derivatives * 2) * ip + num_derivatives * 2 * d + 2 * s + (reference_offsets[d] + 1)];
                    // Mapping derivatives back to the physical element
                    for (std::size_t r = 0; r < num_derivatives; ++r)
                        values[15 * (num_derivatives * 2) * ip + num_derivatives * 2 * d + 2 * r + (physical_offsets[d] + i)] += transform[r][s] * mapped_value;
                }
            }
        }
    }
  }

  void evaluate_basis(std::size_t i,
                      double * values,
                      const double * x,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::coordinate_mapping * cm=nullptr
                      ) const final override
  {
    double X[2] = {};
    double J[4];
    double detJ;
    double K[4];
    if (cm)
    {
        cm->compute_reference_geometry(X, J, &detJ, K, 1, x, coordinate_dofs, cell_orientation);
    }
    else
    {
        compute_jacobian_triangle_2d(J, coordinate_dofs);
        compute_jacobian_inverse_triangle_2d(K, detJ, J);
        // Compute constants
        const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
        const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
        // Get coordinates and map to the reference (FIAT) element
        double Y[2] = { (J[1] * (C1 - 2.0 * x[1]) + J[3] * (2.0 * x[0] - C0)) / detJ, (J[0] * (2.0 * x[1] - C1) + J[2] * (C0 - 2.0 * x[0])) / detJ };
        // Map to FFC reference coordinate
        for (std::size_t k = 0; k < 2; ++k)
            X[k] = (Y[k] + 1.0) / 2.0;
    }
    // Evaluate basis on reference element
    double ref_values[30];
    evaluate_reference_basis(ref_values, 1, X);
    // Push forward
    double physical_values[30];
    transform_reference_basis_derivatives(physical_values, 0, 1, ref_values, X, J, &detJ, K, cell_orientation);
    for (std::size_t k = 0; k < 2; ++k)
        values[k] = physical_values[2 * i + k];
  }

  void evaluate_basis_all(double * values,
                          const double * x,
                          const double * coordinate_dofs,
                          int cell_orientation,
                          const ufc::coordinate_mapping * cm=nullptr
                          ) const final override
  {
    // Helper variable to hold values of a single dof.
    double dof_values[2] = {};
    // Loop dofs and call evaluate_basis
    for (std::size_t r = 0; r < 15; ++r)
    {
        evaluate_basis(r, dof_values, x, coordinate_dofs, cell_orientation);
        for (std::size_t s = 0; s < 2; ++s)
            values[r * 2 + s] = dof_values[s];
    }
  }

  void evaluate_basis_derivatives(std::size_t i,
                                  std::size_t n,
                                  double * values,
                                  const double * x,
                                  const double * coordinate_dofs,
                                  int cell_orientation,
                                  const ufc::coordinate_mapping * cm=nullptr
                                  ) const final override
  {
    std::size_t num_derivatives = std::pow(2, n);
    std::fill_n(values, 2 * num_derivatives, 0.0);
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
        evaluate_basis(i, values, x, coordinate_dofs, cell_orientation);
        return;
    }
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 3)
        return;
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    // Compute Inverse Jacobian and determinant
    double K[4];
    double detJ;
    compute_jacobian_inverse_triangle_2d(K, detJ, J);
    // Compute constants
    const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
    const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
    // Get coordinates and map to the reference (FIAT) element
    double Y[2] = { (J[1] * (C1 - 2.0 * x[1]) + J[3] * (2.0 * x[0] - C0)) / detJ, (J[0] * (2.0 * x[1] - C1) + J[2] * (C0 - 2.0 * x[0])) / detJ };
    // Precomputed combinations
    const std::size_t combinations[3][8][3] =
        { { { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 } },
          { { 0, 0, 0 },
            { 0, 1, 0 },
            { 1, 0, 0 },
            { 1, 1, 0 },
            { 0, 0, 0 },
            { 0, 1, 0 },
            { 1, 0, 0 },
            { 1, 1, 0 } },
          { { 0, 0, 0 },
            { 0, 0, 1 },
            { 0, 1, 0 },
            { 0, 1, 1 },
            { 1, 0, 0 },
            { 1, 0, 1 },
            { 1, 1, 0 },
            { 1, 1, 1 } } };
    // Declare transformation matrix
    double transform[8][8] =
        { { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 } };
    // Construct transformation matrix
    for (std::size_t row = 0; row < num_derivatives; ++row)
        for (std::size_t col = 0; col < num_derivatives; ++col)
            for (std::size_t k = 0; k < n; ++k)
                transform[row][col] *= K[2 * combinations[n - 1][col][k] + combinations[n - 1][row][k]];
    switch (i)
    {
    case 0:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, -0.16953317256112307, 0.08417937871268409, -0.1166423687039609, 0.0, -0.14682003422210352, 0.07290148043997545, -0.101015254455221 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.3216783274236693, -0.13468700594029498, 0.09720197391996732, 0.2605797108646139, -0.12987926104263026, 0.0976879837895673, -0.06313453403451333 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566348, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999982, 0.0, 7.07106781186547, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129197, -3.9866085479535534e-14, -2.9933259094191635, 13.66260102127946, 0.0, 0.6110100926607809, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041333, 0.0, 0.0, 12.52198067399882, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137761, 0.0, 7.83836717690618, 0.0, 0.0, 8.400000000000007, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831814, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119283, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471622, 4.743416490252575, -0.9128709291752798, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999196, 6.12372435695794, 3.535533905932734, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.309401076758484, 0.0, 8.16496580927727, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645765, 5.1845925587262585, -1.4966629547095691, 6.8313005106397275, -1.0583005244258326, 0.3055050463303891, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998298, 2.190890230020675, 2.5298221281346795, 8.082903768654777, 6.260990336999407, -1.807392228230123, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688756, -5.0911688245431455, 3.9191835884531003, 0.0, 9.699484522385692, 4.200000000000009, 0.0, 0.0, 0.0, 1.0874388786809513e-14 },
                  { 5.0000000000000195, 0.0, -2.828427124746231, 0.0, 0.0, 12.124355652982162, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 1:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.07824607964359526, -0.16835875742536813, 0.34992710611188194, 0.0, 0.06776309271789388, -0.14580296087995095, 0.3030457633656627 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, -0.16518616813647946, 0.2357022603955164, -0.27216552697590884, -0.1202675588605913, 0.14682003422210396, -0.22453655975512488, 0.17677669529663703 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566348, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999982, 0.0, 7.07106781186547, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129197, -3.9866085479535534e-14, -2.9933259094191635, 13.66260102127946, 0.0, 0.6110100926607809, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041333, 0.0, 0.0, 12.52198067399882, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137761, 0.0, 7.83836717690618, 0.0, 0.0, 8.400000000000007, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831814, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119283, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471622, 4.743416490252575, -0.9128709291752798, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999196, 6.12372435695794, 3.535533905932734, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.309401076758484, 0.0, 8.16496580927727, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645765, 5.1845925587262585, -1.4966629547095691, 6.8313005106397275, -1.0583005244258326, 0.3055050463303891, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998298, 2.190890230020675, 2.5298221281346795, 8.082903768654777, 6.260990336999407, -1.807392228230123, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688756, -5.0911688245431455, 3.9191835884531003, 0.0, 9.699484522385692, 4.200000000000009, 0.0, 0.0, 0.0, 1.0874388786809513e-14 },
                  { 5.0000000000000195, 0.0, -2.828427124746231, 0.0, 0.0, 12.124355652982162, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 2:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, -0.03912303982179776, -0.08417937871268412, -0.34992710611188216, 0.0, -0.03388154635894711, -0.07290148043997535, -0.30304576336566275 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.060858061945018735, 0.0, 0.21384434262392865, 0.06013377943029568, 0.039528470752104444, 0.11226827987756266, -0.13889597487592917 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566348, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999982, 0.0, 7.07106781186547, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129197, -3.9866085479535534e-14, -2.9933259094191635, 13.66260102127946, 0.0, 0.6110100926607809, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041333, 0.0, 0.0, 12.52198067399882, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137761, 0.0, 7.83836717690618, 0.0, 0.0, 8.400000000000007, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831814, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119283, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471622, 4.743416490252575, -0.9128709291752798, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999196, 6.12372435695794, 3.535533905932734, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.309401076758484, 0.0, 8.16496580927727, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645765, 5.1845925587262585, -1.4966629547095691, 6.8313005106397275, -1.0583005244258326, 0.3055050463303891, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998298, 2.190890230020675, 2.5298221281346795, 8.082903768654777, 6.260990336999407, -1.807392228230123, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688756, -5.0911688245431455, 3.9191835884531003, 0.0, 9.699484522385692, 4.200000000000009, 0.0, 0.0, 0.0, 1.0874388786809513e-14 },
                  { 5.0000000000000195, 0.0, -2.828427124746231, 0.0, 0.0, 12.124355652982162, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 3:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.16953317256112282, 0.08417937871268409, 0.11664236870396072, 0.0, 0.1468200342221034, 0.07290148043997549, 0.10101525445522096 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.4912114999847917, 0.21886638465297917, 0.21384434262392815, -0.26057971086461335, 0.016940773179473456, -0.024786503349591718, 0.03788072042070801 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566348, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999982, 0.0, 7.07106781186547, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129197, -3.9866085479535534e-14, -2.9933259094191635, 13.66260102127946, 0.0, 0.6110100926607809, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041333, 0.0, 0.0, 12.52198067399882, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137761, 0.0, 7.83836717690618, 0.0, 0.0, 8.400000000000007, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831814, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119283, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471622, 4.743416490252575, -0.9128709291752798, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999196, 6.12372435695794, 3.535533905932734, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.309401076758484, 0.0, 8.16496580927727, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645765, 5.1845925587262585, -1.4966629547095691, 6.8313005106397275, -1.0583005244258326, 0.3055050463303891, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998298, 2.190890230020675, 2.5298221281346795, 8.082903768654777, 6.260990336999407, -1.807392228230123, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688756, -5.0911688245431455, 3.9191835884531003, 0.0, 9.699484522385692, 4.200000000000009, 0.0, 0.0, 0.0, 1.0874388786809513e-14 },
                  { 5.0000000000000195, 0.0, -2.828427124746231, 0.0, 0.0, 12.124355652982162, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 4:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, -0.07824607964359549, -0.16835875742536838, -0.3499271061118821, 0.0, -0.06776309271789405, -0.14580296087995095, -0.3030457633656629 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, -0.24343224778007372, -0.40406101782088477, -0.6220926330877907, 0.12026755886059089, 0.07905694150420943, 0.07873359887517391, -0.12626906806902663 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566348, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999982, 0.0, 7.07106781186547, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129197, -3.9866085479535534e-14, -2.9933259094191635, 13.66260102127946, 0.0, 0.6110100926607809, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041333, 0.0, 0.0, 12.52198067399882, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137761, 0.0, 7.83836717690618, 0.0, 0.0, 8.400000000000007, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831814, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119283, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471622, 4.743416490252575, -0.9128709291752798, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999196, 6.12372435695794, 3.535533905932734, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.309401076758484, 0.0, 8.16496580927727, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645765, 5.1845925587262585, -1.4966629547095691, 6.8313005106397275, -1.0583005244258326, 0.3055050463303891, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998298, 2.190890230020675, 2.5298221281346795, 8.082903768654777, 6.260990336999407, -1.807392228230123, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688756, -5.0911688245431455, 3.9191835884531003, 0.0, 9.699484522385692, 4.200000000000009, 0.0, 0.0, 0.0, 1.0874388786809513e-14 },
                  { 5.0000000000000195, 0.0, -2.828427124746231, 0.0, 0.0, 12.124355652982162, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 5:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.03912303982179758, -0.08417937871268408, 0.34992710611188205, 0.0, 0.03388154635894694, -0.0729014804399755, 0.30304576336566263 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.09998110176681554, -0.08417937871268362, 0.5637714487358108, -0.06013377943029564, 0.07341001711105215, -0.18516976031753812, 0.16414978848973438 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566348, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999982, 0.0, 7.07106781186547, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129197, -3.9866085479535534e-14, -2.9933259094191635, 13.66260102127946, 0.0, 0.6110100926607809, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041333, 0.0, 0.0, 12.52198067399882, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137761, 0.0, 7.83836717690618, 0.0, 0.0, 8.400000000000007, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831814, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119283, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471622, 4.743416490252575, -0.9128709291752798, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999196, 6.12372435695794, 3.535533905932734, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.309401076758484, 0.0, 8.16496580927727, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645765, 5.1845925587262585, -1.4966629547095691, 6.8313005106397275, -1.0583005244258326, 0.3055050463303891, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998298, 2.190890230020675, 2.5298221281346795, 8.082903768654777, 6.260990336999407, -1.807392228230123, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688756, -5.0911688245431455, 3.9191835884531003, 0.0, 9.699484522385692, 4.200000000000009, 0.0, 0.0, 0.0, 1.0874388786809513e-14 },
                  { 5.0000000000000195, 0.0, -2.828427124746231, 0.0, 0.0, 12.124355652982162, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 6:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.3825363893686873, 0.3030457633656633, 0.31104631654389586, 0.0, -0.09035079029052527, -0.14580296087995082, -0.2020305089104422 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.1695331725611229, 0.08417937871268408, 0.11664236870396132, 0.16035674514745452, 0.06776309271789378, 0.03207665139358949, -0.0757614408414161 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566348, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999982, 0.0, 7.07106781186547, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129197, -3.9866085479535534e-14, -2.9933259094191635, 13.66260102127946, 0.0, 0.6110100926607809, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041333, 0.0, 0.0, 12.52198067399882, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137761, 0.0, 7.83836717690618, 0.0, 0.0, 8.400000000000007, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831814, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119283, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471622, 4.743416490252575, -0.9128709291752798, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999196, 6.12372435695794, 3.535533905932734, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.309401076758484, 0.0, 8.16496580927727, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645765, 5.1845925587262585, -1.4966629547095691, 6.8313005106397275, -1.0583005244258326, 0.3055050463303891, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998298, 2.190890230020675, 2.5298221281346795, 8.082903768654777, 6.260990336999407, -1.807392228230123, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688756, -5.0911688245431455, 3.9191835884531003, 0.0, 9.699484522385692, 4.200000000000009, 0.0, 0.0, 0.0, 1.0874388786809513e-14 },
                  { 5.0000000000000195, 0.0, -2.828427124746231, 0.0, 0.0, 12.124355652982162, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 7:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, -0.765072778737375, 0.0, -0.15552315827194774, 0.0, 0.1807015805810504, 0.0, 0.10101525445522148 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, -0.38253638936868783, 0.06734350297014773, -0.07776157913597416, -0.32071349029490925, 0.0903507902905256, -0.06415330278717872, 0.05050762722761091 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566348, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999982, 0.0, 7.07106781186547, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129197, -3.9866085479535534e-14, -2.9933259094191635, 13.66260102127946, 0.0, 0.6110100926607809, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041333, 0.0, 0.0, 12.52198067399882, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137761, 0.0, 7.83836717690618, 0.0, 0.0, 8.400000000000007, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831814, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119283, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471622, 4.743416490252575, -0.9128709291752798, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999196, 6.12372435695794, 3.535533905932734, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.309401076758484, 0.0, 8.16496580927727, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645765, 5.1845925587262585, -1.4966629547095691, 6.8313005106397275, -1.0583005244258326, 0.3055050463303891, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998298, 2.190890230020675, 2.5298221281346795, 8.082903768654777, 6.260990336999407, -1.807392228230123, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688756, -5.0911688245431455, 3.9191835884531003, 0.0, 9.699484522385692, 4.200000000000009, 0.0, 0.0, 0.0, 1.0874388786809513e-14 },
                  { 5.0000000000000195, 0.0, -2.828427124746231, 0.0, 0.0, 12.124355652982162, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 8:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.38253638936868767, -0.30304576336566375, 0.3110463165438962, 0.0, -0.0903507902905251, 0.145802960879951, -0.20203050891044222 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.2130032168075653, -0.2188663846529795, 0.19440394783993487, 0.16035674514745485, -0.15811388300841958, 0.17787961227354063, -0.12626906806902666 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566348, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999982, 0.0, 7.07106781186547, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129197, -3.9866085479535534e-14, -2.9933259094191635, 13.66260102127946, 0.0, 0.6110100926607809, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041333, 0.0, 0.0, 12.52198067399882, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137761, 0.0, 7.83836717690618, 0.0, 0.0, 8.400000000000007, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831814, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119283, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471622, 4.743416490252575, -0.9128709291752798, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999196, 6.12372435695794, 3.535533905932734, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.309401076758484, 0.0, 8.16496580927727, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645765, 5.1845925587262585, -1.4966629547095691, 6.8313005106397275, -1.0583005244258326, 0.3055050463303891, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998298, 2.190890230020675, 2.5298221281346795, 8.082903768654777, 6.260990336999407, -1.807392228230123, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688756, -5.0911688245431455, 3.9191835884531003, 0.0, 9.699484522385692, 4.200000000000009, 0.0, 0.0, 0.0, 1.0874388786809513e-14 },
                  { 5.0000000000000195, 0.0, -2.828427124746231, 0.0, 0.0, 12.124355652982162, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 9:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 4.0, 0.0, 0.0, -0.3688555567816587, -0.4761904761904759, -1.6495721976846462, 0.0, -0.3194382824999704, -0.4123930494211606, 0.5714285714285696 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.6147592613027634, 0.4761904761904768, -0.5498573992282151, 0.5669467095138395, 0.15971914124998568, -0.4536323543632773, 0.3571428571428569 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566348, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999982, 0.0, 7.07106781186547, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129197, -3.9866085479535534e-14, -2.9933259094191635, 13.66260102127946, 0.0, 0.6110100926607809, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041333, 0.0, 0.0, 12.52198067399882, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137761, 0.0, 7.83836717690618, 0.0, 0.0, 8.400000000000007, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831814, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119283, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471622, 4.743416490252575, -0.9128709291752798, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999196, 6.12372435695794, 3.535533905932734, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.309401076758484, 0.0, 8.16496580927727, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645765, 5.1845925587262585, -1.4966629547095691, 6.8313005106397275, -1.0583005244258326, 0.3055050463303891, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998298, 2.190890230020675, 2.5298221281346795, 8.082903768654777, 6.260990336999407, -1.807392228230123, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688756, -5.0911688245431455, 3.9191835884531003, 0.0, 9.699484522385692, 4.200000000000009, 0.0, 0.0, 0.0, 1.0874388786809513e-14 },
                  { 5.0000000000000195, 0.0, -2.828427124746231, 0.0, 0.0, 12.124355652982162, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 10:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 3.999999999999999, 0.0, -0.6776309271789399, 1.8079567149113953, 0.0, 0.0, -0.5868455973269651, -1.2626906806902614, 0.0 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 1.0540925533894574, 1.1664236870396085, -0.33671751485073437, 1.0415476122441185, 0.6846531968814584, -0.5808377131175199, 0.21870444131992534 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566348, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999982, 0.0, 7.07106781186547, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129197, -3.9866085479535534e-14, -2.9933259094191635, 13.66260102127946, 0.0, 0.6110100926607809, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041333, 0.0, 0.0, 12.52198067399882, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137761, 0.0, 7.83836717690618, 0.0, 0.0, 8.400000000000007, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831814, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119283, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471622, 4.743416490252575, -0.9128709291752798, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999196, 6.12372435695794, 3.535533905932734, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.309401076758484, 0.0, 8.16496580927727, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645765, 5.1845925587262585, -1.4966629547095691, 6.8313005106397275, -1.0583005244258326, 0.3055050463303891, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998298, 2.190890230020675, 2.5298221281346795, 8.082903768654777, 6.260990336999407, -1.807392228230123, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688756, -5.0911688245431455, 3.9191835884531003, 0.0, 9.699484522385692, 4.200000000000009, 0.0, 0.0, 0.0, 1.0874388786809513e-14 },
                  { 5.0000000000000195, 0.0, -2.828427124746231, 0.0, 0.0, 12.124355652982162, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 11:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 3.9999999999999987, 0.13041013273932475, -0.84179378712684, 0.9331389496316896, 0.0, 0.11293848786315532, -0.729014804399754, -2.020305089104418 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, -0.3477603539715319, 0.3367175148507361, 1.360827634879548, -0.20044593143431677, 0.6211616832473597, 0.5977921396078015, -0.8838834764831853 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566348, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999982, 0.0, 7.07106781186547, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129197, -3.9866085479535534e-14, -2.9933259094191635, 13.66260102127946, 0.0, 0.6110100926607809, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041333, 0.0, 0.0, 12.52198067399882, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137761, 0.0, 7.83836717690618, 0.0, 0.0, 8.400000000000007, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831814, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119283, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471622, 4.743416490252575, -0.9128709291752798, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999196, 6.12372435695794, 3.535533905932734, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.309401076758484, 0.0, 8.16496580927727, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645765, 5.1845925587262585, -1.4966629547095691, 6.8313005106397275, -1.0583005244258326, 0.3055050463303891, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998298, 2.190890230020675, 2.5298221281346795, 8.082903768654777, 6.260990336999407, -1.807392228230123, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688756, -5.0911688245431455, 3.9191835884531003, 0.0, 9.699484522385692, 4.200000000000009, 0.0, 0.0, 0.0, 1.0874388786809513e-14 },
                  { 5.0000000000000195, 0.0, -2.828427124746231, 0.0, 0.0, 12.124355652982162, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 12:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.0, 0.9523809523809509, 0.0, 0.0, 0.0, 0.8247860988423217, 0.0 };
            static const double coefficients1[10] = { 3.999999999999999, 0.0, 0.0, -1.5983740793871857, 0.4761904761904763, -0.5498573992282167, 0.0, -0.6388765649999416, 0.41239304942116045, -0.14285714285714188 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566348, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999982, 0.0, 7.07106781186547, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129197, -3.9866085479535534e-14, -2.9933259094191635, 13.66260102127946, 0.0, 0.6110100926607809, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041333, 0.0, 0.0, 12.52198067399882, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137761, 0.0, 7.83836717690618, 0.0, 0.0, 8.400000000000007, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831814, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119283, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471622, 4.743416490252575, -0.9128709291752798, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999196, 6.12372435695794, 3.535533905932734, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.309401076758484, 0.0, 8.16496580927727, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645765, 5.1845925587262585, -1.4966629547095691, 6.8313005106397275, -1.0583005244258326, 0.3055050463303891, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998298, 2.190890230020675, 2.5298221281346795, 8.082903768654777, 6.260990336999407, -1.807392228230123, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688756, -5.0911688245431455, 3.9191835884531003, 0.0, 9.699484522385692, 4.200000000000009, 0.0, 0.0, 0.0, 1.0874388786809513e-14 },
                  { 5.0000000000000195, 0.0, -2.828427124746231, 0.0, 0.0, 12.124355652982162, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 13:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 1.3552618543578774, 0.0, 0.0, 0.0, 1.1736911946539281, 0.0, 0.0 };
            static const double coefficients1[10] = { 0.0, 3.999999999999998, 0.0, 0.6776309271789369, -0.5248906591678232, 0.0, -2.0830952244882384, 0.5868455973269647, -0.10101525445522135, 0.0 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566348, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999982, 0.0, 7.07106781186547, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129197, -3.9866085479535534e-14, -2.9933259094191635, 13.66260102127946, 0.0, 0.6110100926607809, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041333, 0.0, 0.0, 12.52198067399882, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137761, 0.0, 7.83836717690618, 0.0, 0.0, 8.400000000000007, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831814, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119283, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471622, 4.743416490252575, -0.9128709291752798, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999196, 6.12372435695794, 3.535533905932734, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.309401076758484, 0.0, 8.16496580927727, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645765, 5.1845925587262585, -1.4966629547095691, 6.8313005106397275, -1.0583005244258326, 0.3055050463303891, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998298, 2.190890230020675, 2.5298221281346795, 8.082903768654777, 6.260990336999407, -1.807392228230123, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688756, -5.0911688245431455, 3.9191835884531003, 0.0, 9.699484522385692, 4.200000000000009, 0.0, 0.0, 0.0, 1.0874388786809513e-14 },
                  { 5.0000000000000195, 0.0, -2.828427124746231, 0.0, 0.0, 12.124355652982162, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 14:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.0, 1.6835875742536806, 0.0, 0.0, 0.0, 1.4580296087995086, 0.0 };
            static const double coefficients1[10] = { 0.0, 0.0, 3.9999999999999987, 0.8259308406823964, 0.8417937871268396, -1.788516320127402, 0.0, -1.1293848786315668, 0.7290148043997551, -0.2525381361380525 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566348, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999982, 0.0, 7.07106781186547, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129197, -3.9866085479535534e-14, -2.9933259094191635, 13.66260102127946, 0.0, 0.6110100926607809, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041333, 0.0, 0.0, 12.52198067399882, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137761, 0.0, 7.83836717690618, 0.0, 0.0, 8.400000000000007, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831814, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119283, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471622, 4.743416490252575, -0.9128709291752798, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999196, 6.12372435695794, 3.535533905932734, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.309401076758484, 0.0, 8.16496580927727, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645765, 5.1845925587262585, -1.4966629547095691, 6.8313005106397275, -1.0583005244258326, 0.3055050463303891, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998298, 2.190890230020675, 2.5298221281346795, 8.082903768654777, 6.260990336999407, -1.807392228230123, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688756, -5.0911688245431455, 3.9191835884531003, 0.0, 9.699484522385692, 4.200000000000009, 0.0, 0.0, 0.0, 1.0874388786809513e-14 },
                  { 5.0000000000000195, 0.0, -2.828427124746231, 0.0, 0.0, 12.124355652982162, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    }
  }

  void evaluate_basis_derivatives_all(std::size_t n,
                                      double * values,
                                      const double * x,
                                      const double * coordinate_dofs,
                                      int cell_orientation,
                                      const ufc::coordinate_mapping * cm=nullptr
                                      ) const final override
  {
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
        evaluate_basis_all(values, x, coordinate_dofs, cell_orientation);
        return;
    }
    unsigned int num_derivatives = std::pow(2, n);
    // Set values equal to zero.
    std::fill_n(values, 2 * num_derivatives * 15, 0.0);
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 3)
        return;
    // Helper variable to hold values of a single dof.
    double dof_values[16] = {};
    // Loop dofs and call evaluate_basis_derivatives.
    for (std::size_t r = 0; r < 15; ++r)
    {
        evaluate_basis_derivatives(r, n, dof_values, x, coordinate_dofs, cell_orientation);
        for (std::size_t s = 0; s < 2 * num_derivatives; ++s)
            values[2 * num_derivatives * r + s] = dof_values[s];
    }
  }

  double evaluate_dof(std::size_t i,
                      const ufc::function& f,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::cell& c,
                      const ufc::coordinate_mapping * cm=nullptr
                      ) const final override
  {
    // Declare variables for result of evaluation
    double vals[2];
    // Declare variable for physical coordinates
    double y[2];
    double result;
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    switch (i)
    {
    case 0:
        {
            y[0] = 0.75 * coordinate_dofs[2] + 0.25 * coordinate_dofs[4];
            y[1] = 0.75 * coordinate_dofs[3] + 0.25 * coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return -(vals[0] * J[0] + vals[1] * J[2]) + (vals[0] * J[1] + vals[1] * J[2 + 1]);
        }
        break;
    case 1:
        {
            y[0] = 0.5 * coordinate_dofs[2] + 0.5 * coordinate_dofs[4];
            y[1] = 0.5 * coordinate_dofs[3] + 0.5 * coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return -(vals[0] * J[0] + vals[1] * J[2]) + (vals[0] * J[1] + vals[1] * J[2 + 1]);
        }
        break;
    case 2:
        {
            y[0] = 0.25 * coordinate_dofs[2] + 0.75 * coordinate_dofs[4];
            y[1] = 0.25 * coordinate_dofs[3] + 0.75 * coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return -(vals[0] * J[0] + vals[1] * J[2]) + (vals[0] * J[1] + vals[1] * J[2 + 1]);
        }
        break;
    case 3:
        {
            y[0] = 0.75 * coordinate_dofs[0] + 0.25 * coordinate_dofs[4];
            y[1] = 0.75 * coordinate_dofs[1] + 0.25 * coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return vals[0] * J[1] + vals[1] * J[2 + 1];
        }
        break;
    case 4:
        {
            y[0] = 0.5 * coordinate_dofs[0] + 0.5 * coordinate_dofs[4];
            y[1] = 0.5 * coordinate_dofs[1] + 0.5 * coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return vals[0] * J[1] + vals[1] * J[2 + 1];
        }
        break;
    case 5:
        {
            y[0] = 0.25 * coordinate_dofs[0] + 0.75 * coordinate_dofs[4];
            y[1] = 0.25 * coordinate_dofs[1] + 0.75 * coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return vals[0] * J[1] + vals[1] * J[2 + 1];
        }
        break;
    case 6:
        {
            y[0] = 0.75 * coordinate_dofs[0] + 0.25 * coordinate_dofs[2];
            y[1] = 0.75 * coordinate_dofs[1] + 0.25 * coordinate_dofs[3];
            f.evaluate(vals, y, c);
            return vals[0] * J[0] + vals[1] * J[2];
        }
        break;
    case 7:
        {
            y[0] = 0.5 * coordinate_dofs[0] + 0.5 * coordinate_dofs[2];
            y[1] = 0.5 * coordinate_dofs[1] + 0.5 * coordinate_dofs[3];
            f.evaluate(vals, y, c);
            return vals[0] * J[0] + vals[1] * J[2];
        }
        break;
    case 8:
        {
            y[0] = 0.25 * coordinate_dofs[0] + 0.75 * coordinate_dofs[2];
            y[1] = 0.25 * coordinate_dofs[1] + 0.75 * coordinate_dofs[3];
            f.evaluate(vals, y, c);
            return vals[0] * J[0] + vals[1] * J[2];
        }
        break;
    case 9:
        {
            result = 0.0;
            double X_9[36][2] =
                { { 0.0327753666144599, 0.029316427159784886 },
                  { 0.028765333012559124, 0.1480785996684843 },
                  { 0.022386872978030603, 0.3369846902811543 },
                  { 0.014901563366671144, 0.5586715187715502 },
                  { 0.00779187470128645, 0.7692338620300545 },
                  { 0.0024666971526702275, 0.926945671319741 },
                  { 0.1644292415948274, 0.029316427159784886 },
                  { 0.14431148695041662, 0.1480785996684843 },
                  { 0.11231168178095369, 0.3369846902811543 },
                  { 0.07475897346264909, 0.5586715187715502 },
                  { 0.039090700732824224, 0.7692338620300545 },
                  { 0.01237506041744002, 0.926945671319741 },
                  { 0.36952992437237664, 0.029316427159784886 },
                  { 0.324318304588776, 0.1480785996684843 },
                  { 0.252403568076518, 0.3369846902811543 },
                  { 0.16800951912119183, 0.5586715187715502 },
                  { 0.0878504549759972, 0.7692338620300545 },
                  { 0.027811082115360597, 0.926945671319741 },
                  { 0.6011536484678385, 0.029316427159784886 },
                  { 0.5276030957427397, 0.1480785996684843 },
                  { 0.4106117416423277, 0.3369846902811543 },
                  { 0.27331896210725803, 0.5586715187715502 },
                  { 0.1429156829939483, 0.7692338620300545 },
                  { 0.04524324656489831, 0.926945671319741 },
                  { 0.8062543312453878, 0.029316427159784886 },
                  { 0.7076099133810991, 0.1480785996684843 },
                  { 0.5507036279378921, 0.3369846902811543 },
                  { 0.36656950776580083, 0.5586715187715502 },
                  { 0.19167543723712127, 0.7692338620300545 },
                  { 0.060679268262818886, 0.926945671319741 },
                  { 0.9379082062257551, 0.029316427159784886 },
                  { 0.8231560673189564, 0.1480785996684843 },
                  { 0.640628436740815, 0.3369846902811543 },
                  { 0.42642691786177866, 0.5586715187715502 },
                  { 0.22297426326865905, 0.7692338620300545 },
                  { 0.07058763152758862, 0.926945671319741 } };
            int D_9[36][1] = {};
            double W_9[36][1] =
                { { 0.004380007035333952 },
                  { 0.00821012828325171 },
                  { 0.008528136573677752 },
                  { 0.0059761382734593235 },
                  { 0.002662467899383865 },
                  { 0.0005292995210569465 },
                  { 0.009223072580491742 },
                  { 0.017288239137681006 },
                  { 0.017957875857470856 },
                  { 0.012584079569399019 },
                  { 0.005606414437499757 },
                  { 0.001114557090923834 },
                  { 0.011962482987098903 },
                  { 0.022423142044750127 },
                  { 0.023291672330955 },
                  { 0.016321766574367406 },
                  { 0.0072716154775874856 },
                  { 0.001445599622248223 },
                  { 0.011962482987098896 },
                  { 0.022423142044750117 },
                  { 0.023291672330954985 },
                  { 0.016321766574367395 },
                  { 0.007271615477587481 },
                  { 0.0014455996222482222 },
                  { 0.009223072580491742 },
                  { 0.01728823913768101 },
                  { 0.017957875857470856 },
                  { 0.012584079569399019 },
                  { 0.005606414437499757 },
                  { 0.001114557090923834 },
                  { 0.004380007035333964 },
                  { 0.008210128283251733 },
                  { 0.008528136573677774 },
                  { 0.005976138273459339 },
                  { 0.0026624678993838725 },
                  { 0.000529299521056948 } };
            double copy_9[2];
            // Loop over points
            for (std::size_t r = 0; r < 36; ++r)
            {
                // Evaluate basis functions for affine mapping
                const double w0 = 1 - X_9[r][0] - X_9[r][1];
                const double w1 = X_9[r][0];
                const double w2 = X_9[r][1];
                // Compute affine mapping y = F(X)
                y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
                y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
                // Evaluate function at physical point
                f.evaluate(vals, y, c);
                // Map function to reference element
                copy_9[0] = vals[0] * J[0] + vals[1] * J[2];
                copy_9[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
                // Loop over directions
                for (std::size_t s = 0; s < 1; ++s)
                    result += copy_9[D_9[r][s]] * W_9[r][s];
            }
            return result;
        }
        break;
    case 10:
        {
            result = 0.0;
            double X_10[36][2] =
                { { 0.0327753666144599, 0.029316427159784886 },
                  { 0.028765333012559124, 0.1480785996684843 },
                  { 0.022386872978030603, 0.3369846902811543 },
                  { 0.014901563366671144, 0.5586715187715502 },
                  { 0.00779187470128645, 0.7692338620300545 },
                  { 0.0024666971526702275, 0.926945671319741 },
                  { 0.1644292415948274, 0.029316427159784886 },
                  { 0.14431148695041662, 0.1480785996684843 },
                  { 0.11231168178095369, 0.3369846902811543 },
                  { 0.07475897346264909, 0.5586715187715502 },
                  { 0.039090700732824224, 0.7692338620300545 },
                  { 0.01237506041744002, 0.926945671319741 },
                  { 0.36952992437237664, 0.029316427159784886 },
                  { 0.324318304588776, 0.1480785996684843 },
                  { 0.252403568076518, 0.3369846902811543 },
                  { 0.16800951912119183, 0.5586715187715502 },
                  { 0.0878504549759972, 0.7692338620300545 },
                  { 0.027811082115360597, 0.926945671319741 },
                  { 0.6011536484678385, 0.029316427159784886 },
                  { 0.5276030957427397, 0.1480785996684843 },
                  { 0.4106117416423277, 0.3369846902811543 },
                  { 0.27331896210725803, 0.5586715187715502 },
                  { 0.1429156829939483, 0.7692338620300545 },
                  { 0.04524324656489831, 0.926945671319741 },
                  { 0.8062543312453878, 0.029316427159784886 },
                  { 0.7076099133810991, 0.1480785996684843 },
                  { 0.5507036279378921, 0.3369846902811543 },
                  { 0.36656950776580083, 0.5586715187715502 },
                  { 0.19167543723712127, 0.7692338620300545 },
                  { 0.060679268262818886, 0.926945671319741 },
                  { 0.9379082062257551, 0.029316427159784886 },
                  { 0.8231560673189564, 0.1480785996684843 },
                  { 0.640628436740815, 0.3369846902811543 },
                  { 0.42642691786177866, 0.5586715187715502 },
                  { 0.22297426326865905, 0.7692338620300545 },
                  { 0.07058763152758862, 0.926945671319741 } };
            int D_10[36][1] = {};
            double W_10[36][1] =
                { { -0.009710973194534896 },
                  { -0.015975694174423887 },
                  { -0.012914808498775162 },
                  { -0.006024109540551331 },
                  { -0.0014033523604530267 },
                  { -8.831972792250468e-5 },
                  { -0.01449999797697064 },
                  { -0.023854203751711895 },
                  { -0.019283823912786737 },
                  { -0.00899493535830189 },
                  { -0.00209542400951097 },
                  { -0.00013187513244538945 },
                  { -0.006787033586233021 },
                  { -0.011165469284399073 },
                  { -0.009026205436370045 },
                  { -0.0042102715103650165 },
                  { -0.0009808079389071213 },
                  { -6.172697089456968e-5 },
                  { 0.006787033586233017 },
                  { 0.011165469284399062 },
                  { 0.00902620543637004 },
                  { 0.004210271510365018 },
                  { 0.0009808079389071207 },
                  { 6.172697089456923e-5 },
                  { 0.014499997976970646 },
                  { 0.023854203751711905 },
                  { 0.01928382391278674 },
                  { 0.008994935358301898 },
                  { 0.00209542400951097 },
                  { 0.00013187513244538915 },
                  { 0.00971097319453492 },
                  { 0.015975694174423925 },
                  { 0.012914808498775193 },
                  { 0.006024109540551347 },
                  { 0.0014033523604530306 },
                  { 8.831972792250464e-5 } };
            double copy_10[2];
            // Loop over points
            for (std::size_t r = 0; r < 36; ++r)
            {
                // Evaluate basis functions for affine mapping
                const double w0 = 1 - X_10[r][0] - X_10[r][1];
                const double w1 = X_10[r][0];
                const double w2 = X_10[r][1];
                // Compute affine mapping y = F(X)
                y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
                y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
                // Evaluate function at physical point
                f.evaluate(vals, y, c);
                // Map function to reference element
                copy_10[0] = vals[0] * J[0] + vals[1] * J[2];
                copy_10[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
                // Loop over directions
                for (std::size_t s = 0; s < 1; ++s)
                    result += copy_10[D_10[r][s]] * W_10[r][s];
            }
            return result;
        }
        break;
    case 11:
        {
            result = 0.0;
            double X_11[36][2] =
                { { 0.0327753666144599, 0.029316427159784886 },
                  { 0.028765333012559124, 0.1480785996684843 },
                  { 0.022386872978030603, 0.3369846902811543 },
                  { 0.014901563366671144, 0.5586715187715502 },
                  { 0.00779187470128645, 0.7692338620300545 },
                  { 0.0024666971526702275, 0.926945671319741 },
                  { 0.1644292415948274, 0.029316427159784886 },
                  { 0.14431148695041662, 0.1480785996684843 },
                  { 0.11231168178095369, 0.3369846902811543 },
                  { 0.07475897346264909, 0.5586715187715502 },
                  { 0.039090700732824224, 0.7692338620300545 },
                  { 0.01237506041744002, 0.926945671319741 },
                  { 0.36952992437237664, 0.029316427159784886 },
                  { 0.324318304588776, 0.1480785996684843 },
                  { 0.252403568076518, 0.3369846902811543 },
                  { 0.16800951912119183, 0.5586715187715502 },
                  { 0.0878504549759972, 0.7692338620300545 },
                  { 0.027811082115360597, 0.926945671319741 },
                  { 0.6011536484678385, 0.029316427159784886 },
                  { 0.5276030957427397, 0.1480785996684843 },
                  { 0.4106117416423277, 0.3369846902811543 },
                  { 0.27331896210725803, 0.5586715187715502 },
                  { 0.1429156829939483, 0.7692338620300545 },
                  { 0.04524324656489831, 0.926945671319741 },
                  { 0.8062543312453878, 0.029316427159784886 },
                  { 0.7076099133810991, 0.1480785996684843 },
                  { 0.5507036279378921, 0.3369846902811543 },
                  { 0.36656950776580083, 0.5586715187715502 },
                  { 0.19167543723712127, 0.7692338620300545 },
                  { 0.060679268262818886, 0.926945671319741 },
                  { 0.9379082062257551, 0.029316427159784886 },
                  { 0.8231560673189564, 0.1480785996684843 },
                  { 0.640628436740815, 0.3369846902811543 },
                  { 0.42642691786177866, 0.5586715187715502 },
                  { 0.22297426326865905, 0.7692338620300545 },
                  { 0.07058763152758862, 0.926945671319741 } };
            int D_11[36][1] = {};
            double W_11[36][1] =
                { { -0.00564948416560004 },
                  { -0.006452908537728117 },
                  { 0.0001321127369674421 },
                  { 0.005713361221947881 },
                  { 0.00492388644483935 },
                  { 0.0013330322995734722 },
                  { -0.011896237170700168 },
                  { -0.013588024703755641 },
                  { 0.000278192558146252 },
                  { 0.012030744426549674 },
                  { 0.010368330847986927 },
                  { 0.002806994041772937 },
                  { -0.015429623211032667 },
                  { -0.017623900595856532 },
                  { 0.0003608205091003015 },
                  { 0.015604081423921987 },
                  { 0.013447902560801864 },
                  { 0.0036407193130650224 },
                  { -0.015429623211032657 },
                  { -0.017623900595856525 },
                  { 0.00036082050910030123 },
                  { 0.015604081423921978 },
                  { 0.013447902560801856 },
                  { 0.0036407193130650202 },
                  { -0.011896237170700168 },
                  { -0.013588024703755645 },
                  { 0.000278192558146252 },
                  { 0.012030744426549674 },
                  { 0.010368330847986927 },
                  { 0.002806994041772937 },
                  { -0.005649484165600055 },
                  { -0.006452908537728134 },
                  { 0.00013211273696744246 },
                  { 0.005713361221947897 },
                  { 0.004923886444839364 },
                  { 0.0013330322995734759 } };
            double copy_11[2];
            // Loop over points
            for (std::size_t r = 0; r < 36; ++r)
            {
                // Evaluate basis functions for affine mapping
                const double w0 = 1 - X_11[r][0] - X_11[r][1];
                const double w1 = X_11[r][0];
                const double w2 = X_11[r][1];
                // Compute affine mapping y = F(X)
                y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
                y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
                // Evaluate function at physical point
                f.evaluate(vals, y, c);
                // Map function to reference element
                copy_11[0] = vals[0] * J[0] + vals[1] * J[2];
                copy_11[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
                // Loop over directions
                for (std::size_t s = 0; s < 1; ++s)
                    result += copy_11[D_11[r][s]] * W_11[r][s];
            }
            return result;
        }
        break;
    case 12:
        {
            result = 0.0;
            double X_12[36][2] =
                { { 0.0327753666144599, 0.029316427159784886 },
                  { 0.028765333012559124, 0.1480785996684843 },
                  { 0.022386872978030603, 0.3369846902811543 },
                  { 0.014901563366671144, 0.5586715187715502 },
                  { 0.00779187470128645, 0.7692338620300545 },
                  { 0.0024666971526702275, 0.926945671319741 },
                  { 0.1644292415948274, 0.029316427159784886 },
                  { 0.14431148695041662, 0.1480785996684843 },
                  { 0.11231168178095369, 0.3369846902811543 },
                  { 0.07475897346264909, 0.5586715187715502 },
                  { 0.039090700732824224, 0.7692338620300545 },
                  { 0.01237506041744002, 0.926945671319741 },
                  { 0.36952992437237664, 0.029316427159784886 },
                  { 0.324318304588776, 0.1480785996684843 },
                  { 0.252403568076518, 0.3369846902811543 },
                  { 0.16800951912119183, 0.5586715187715502 },
                  { 0.0878504549759972, 0.7692338620300545 },
                  { 0.027811082115360597, 0.926945671319741 },
                  { 0.6011536484678385, 0.029316427159784886 },
                  { 0.5276030957427397, 0.1480785996684843 },
                  { 0.4106117416423277, 0.3369846902811543 },
                  { 0.27331896210725803, 0.5586715187715502 },
                  { 0.1429156829939483, 0.7692338620300545 },
                  { 0.04524324656489831, 0.926945671319741 },
                  { 0.8062543312453878, 0.029316427159784886 },
                  { 0.7076099133810991, 0.1480785996684843 },
                  { 0.5507036279378921, 0.3369846902811543 },
                  { 0.36656950776580083, 0.5586715187715502 },
                  { 0.19167543723712127, 0.7692338620300545 },
                  { 0.060679268262818886, 0.926945671319741 },
                  { 0.9379082062257551, 0.029316427159784886 },
                  { 0.8231560673189564, 0.1480785996684843 },
                  { 0.640628436740815, 0.3369846902811543 },
                  { 0.42642691786177866, 0.5586715187715502 },
                  { 0.22297426326865905, 0.7692338620300545 },
                  { 0.07058763152758862, 0.926945671319741 } };
            int D_12[36][1] =
                { { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 } };
            double W_12[36][1] =
                { { 0.004380007035333952 },
                  { 0.00821012828325171 },
                  { 0.008528136573677752 },
                  { 0.0059761382734593235 },
                  { 0.002662467899383865 },
                  { 0.0005292995210569465 },
                  { 0.009223072580491742 },
                  { 0.017288239137681006 },
                  { 0.017957875857470856 },
                  { 0.012584079569399019 },
                  { 0.005606414437499757 },
                  { 0.001114557090923834 },
                  { 0.011962482987098903 },
                  { 0.022423142044750127 },
                  { 0.023291672330955 },
                  { 0.016321766574367406 },
                  { 0.0072716154775874856 },
                  { 0.001445599622248223 },
                  { 0.011962482987098896 },
                  { 0.022423142044750117 },
                  { 0.023291672330954985 },
                  { 0.016321766574367395 },
                  { 0.007271615477587481 },
                  { 0.0014455996222482222 },
                  { 0.009223072580491742 },
                  { 0.01728823913768101 },
                  { 0.017957875857470856 },
                  { 0.012584079569399019 },
                  { 0.005606414437499757 },
                  { 0.001114557090923834 },
                  { 0.004380007035333964 },
                  { 0.008210128283251733 },
                  { 0.008528136573677774 },
                  { 0.005976138273459339 },
                  { 0.0026624678993838725 },
                  { 0.000529299521056948 } };
            double copy_12[2];
            // Loop over points
            for (std::size_t r = 0; r < 36; ++r)
            {
                // Evaluate basis functions for affine mapping
                const double w0 = 1 - X_12[r][0] - X_12[r][1];
                const double w1 = X_12[r][0];
                const double w2 = X_12[r][1];
                // Compute affine mapping y = F(X)
                y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
                y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
                // Evaluate function at physical point
                f.evaluate(vals, y, c);
                // Map function to reference element
                copy_12[0] = vals[0] * J[0] + vals[1] * J[2];
                copy_12[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
                // Loop over directions
                for (std::size_t s = 0; s < 1; ++s)
                    result += copy_12[D_12[r][s]] * W_12[r][s];
            }
            return result;
        }
        break;
    case 13:
        {
            result = 0.0;
            double X_13[36][2] =
                { { 0.0327753666144599, 0.029316427159784886 },
                  { 0.028765333012559124, 0.1480785996684843 },
                  { 0.022386872978030603, 0.3369846902811543 },
                  { 0.014901563366671144, 0.5586715187715502 },
                  { 0.00779187470128645, 0.7692338620300545 },
                  { 0.0024666971526702275, 0.926945671319741 },
                  { 0.1644292415948274, 0.029316427159784886 },
                  { 0.14431148695041662, 0.1480785996684843 },
                  { 0.11231168178095369, 0.3369846902811543 },
                  { 0.07475897346264909, 0.5586715187715502 },
                  { 0.039090700732824224, 0.7692338620300545 },
                  { 0.01237506041744002, 0.926945671319741 },
                  { 0.36952992437237664, 0.029316427159784886 },
                  { 0.324318304588776, 0.1480785996684843 },
                  { 0.252403568076518, 0.3369846902811543 },
                  { 0.16800951912119183, 0.5586715187715502 },
                  { 0.0878504549759972, 0.7692338620300545 },
                  { 0.027811082115360597, 0.926945671319741 },
                  { 0.6011536484678385, 0.029316427159784886 },
                  { 0.5276030957427397, 0.1480785996684843 },
                  { 0.4106117416423277, 0.3369846902811543 },
                  { 0.27331896210725803, 0.5586715187715502 },
                  { 0.1429156829939483, 0.7692338620300545 },
                  { 0.04524324656489831, 0.926945671319741 },
                  { 0.8062543312453878, 0.029316427159784886 },
                  { 0.7076099133810991, 0.1480785996684843 },
                  { 0.5507036279378921, 0.3369846902811543 },
                  { 0.36656950776580083, 0.5586715187715502 },
                  { 0.19167543723712127, 0.7692338620300545 },
                  { 0.060679268262818886, 0.926945671319741 },
                  { 0.9379082062257551, 0.029316427159784886 },
                  { 0.8231560673189564, 0.1480785996684843 },
                  { 0.640628436740815, 0.3369846902811543 },
                  { 0.42642691786177866, 0.5586715187715502 },
                  { 0.22297426326865905, 0.7692338620300545 },
                  { 0.07058763152758862, 0.926945671319741 } };
            int D_13[36][1] =
                { { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 } };
            double W_13[36][1] =
                { { -0.009710973194534896 },
                  { -0.015975694174423887 },
                  { -0.012914808498775162 },
                  { -0.006024109540551331 },
                  { -0.0014033523604530267 },
                  { -8.831972792250468e-5 },
                  { -0.01449999797697064 },
                  { -0.023854203751711895 },
                  { -0.019283823912786737 },
                  { -0.00899493535830189 },
                  { -0.00209542400951097 },
                  { -0.00013187513244538945 },
                  { -0.006787033586233021 },
                  { -0.011165469284399073 },
                  { -0.009026205436370045 },
                  { -0.0042102715103650165 },
                  { -0.0009808079389071213 },
                  { -6.172697089456968e-5 },
                  { 0.006787033586233017 },
                  { 0.011165469284399062 },
                  { 0.00902620543637004 },
                  { 0.004210271510365018 },
                  { 0.0009808079389071207 },
                  { 6.172697089456923e-5 },
                  { 0.014499997976970646 },
                  { 0.023854203751711905 },
                  { 0.01928382391278674 },
                  { 0.008994935358301898 },
                  { 0.00209542400951097 },
                  { 0.00013187513244538915 },
                  { 0.00971097319453492 },
                  { 0.015975694174423925 },
                  { 0.012914808498775193 },
                  { 0.006024109540551347 },
                  { 0.0014033523604530306 },
                  { 8.831972792250464e-5 } };
            double copy_13[2];
            // Loop over points
            for (std::size_t r = 0; r < 36; ++r)
            {
                // Evaluate basis functions for affine mapping
                const double w0 = 1 - X_13[r][0] - X_13[r][1];
                const double w1 = X_13[r][0];
                const double w2 = X_13[r][1];
                // Compute affine mapping y = F(X)
                y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
                y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
                // Evaluate function at physical point
                f.evaluate(vals, y, c);
                // Map function to reference element
                copy_13[0] = vals[0] * J[0] + vals[1] * J[2];
                copy_13[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
                // Loop over directions
                for (std::size_t s = 0; s < 1; ++s)
                    result += copy_13[D_13[r][s]] * W_13[r][s];
            }
            return result;
        }
        break;
    case 14:
        {
            result = 0.0;
            double X_14[36][2] =
                { { 0.0327753666144599, 0.029316427159784886 },
                  { 0.028765333012559124, 0.1480785996684843 },
                  { 0.022386872978030603, 0.3369846902811543 },
                  { 0.014901563366671144, 0.5586715187715502 },
                  { 0.00779187470128645, 0.7692338620300545 },
                  { 0.0024666971526702275, 0.926945671319741 },
                  { 0.1644292415948274, 0.029316427159784886 },
                  { 0.14431148695041662, 0.1480785996684843 },
                  { 0.11231168178095369, 0.3369846902811543 },
                  { 0.07475897346264909, 0.5586715187715502 },
                  { 0.039090700732824224, 0.7692338620300545 },
                  { 0.01237506041744002, 0.926945671319741 },
                  { 0.36952992437237664, 0.029316427159784886 },
                  { 0.324318304588776, 0.1480785996684843 },
                  { 0.252403568076518, 0.3369846902811543 },
                  { 0.16800951912119183, 0.5586715187715502 },
                  { 0.0878504549759972, 0.7692338620300545 },
                  { 0.027811082115360597, 0.926945671319741 },
                  { 0.6011536484678385, 0.029316427159784886 },
                  { 0.5276030957427397, 0.1480785996684843 },
                  { 0.4106117416423277, 0.3369846902811543 },
                  { 0.27331896210725803, 0.5586715187715502 },
                  { 0.1429156829939483, 0.7692338620300545 },
                  { 0.04524324656489831, 0.926945671319741 },
                  { 0.8062543312453878, 0.029316427159784886 },
                  { 0.7076099133810991, 0.1480785996684843 },
                  { 0.5507036279378921, 0.3369846902811543 },
                  { 0.36656950776580083, 0.5586715187715502 },
                  { 0.19167543723712127, 0.7692338620300545 },
                  { 0.060679268262818886, 0.926945671319741 },
                  { 0.9379082062257551, 0.029316427159784886 },
                  { 0.8231560673189564, 0.1480785996684843 },
                  { 0.640628436740815, 0.3369846902811543 },
                  { 0.42642691786177866, 0.5586715187715502 },
                  { 0.22297426326865905, 0.7692338620300545 },
                  { 0.07058763152758862, 0.926945671319741 } };
            int D_14[36][1] =
                { { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 } };
            double W_14[36][1] =
                { { -0.00564948416560004 },
                  { -0.006452908537728117 },
                  { 0.0001321127369674421 },
                  { 0.005713361221947881 },
                  { 0.00492388644483935 },
                  { 0.0013330322995734722 },
                  { -0.011896237170700168 },
                  { -0.013588024703755641 },
                  { 0.000278192558146252 },
                  { 0.012030744426549674 },
                  { 0.010368330847986927 },
                  { 0.002806994041772937 },
                  { -0.015429623211032667 },
                  { -0.017623900595856532 },
                  { 0.0003608205091003015 },
                  { 0.015604081423921987 },
                  { 0.013447902560801864 },
                  { 0.0036407193130650224 },
                  { -0.015429623211032657 },
                  { -0.017623900595856525 },
                  { 0.00036082050910030123 },
                  { 0.015604081423921978 },
                  { 0.013447902560801856 },
                  { 0.0036407193130650202 },
                  { -0.011896237170700168 },
                  { -0.013588024703755645 },
                  { 0.000278192558146252 },
                  { 0.012030744426549674 },
                  { 0.010368330847986927 },
                  { 0.002806994041772937 },
                  { -0.005649484165600055 },
                  { -0.006452908537728134 },
                  { 0.00013211273696744246 },
                  { 0.005713361221947897 },
                  { 0.004923886444839364 },
                  { 0.0013330322995734759 } };
            double copy_14[2];
            // Loop over points
            for (std::size_t r = 0; r < 36; ++r)
            {
                // Evaluate basis functions for affine mapping
                const double w0 = 1 - X_14[r][0] - X_14[r][1];
                const double w1 = X_14[r][0];
                const double w2 = X_14[r][1];
                // Compute affine mapping y = F(X)
                y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
                y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
                // Evaluate function at physical point
                f.evaluate(vals, y, c);
                // Map function to reference element
                copy_14[0] = vals[0] * J[0] + vals[1] * J[2];
                copy_14[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
                // Loop over directions
                for (std::size_t s = 0; s < 1; ++s)
                    result += copy_14[D_14[r][s]] * W_14[r][s];
            }
            return result;
        }
        break;
    }
    return 0.0;
  }

  void evaluate_dofs(double * values,
                             const ufc::function& f,
                             const double * coordinate_dofs,
                             int cell_orientation,
                             const ufc::cell& c,
                             const ufc::coordinate_mapping * cm=nullptr
                             ) const final override
  {
    // Declare variables for result of evaluation
    double vals[2];
    // Declare variable for physical coordinates
    double y[2];
    double result;
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    y[0] = 0.75 * coordinate_dofs[2] + 0.25 * coordinate_dofs[4];
    y[1] = 0.75 * coordinate_dofs[3] + 0.25 * coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[0] = -(vals[0] * J[0] + vals[1] * J[2]) + (vals[0] * J[1] + vals[1] * J[2 + 1]);
    y[0] = 0.5 * coordinate_dofs[2] + 0.5 * coordinate_dofs[4];
    y[1] = 0.5 * coordinate_dofs[3] + 0.5 * coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[1] = -(vals[0] * J[0] + vals[1] * J[2]) + (vals[0] * J[1] + vals[1] * J[2 + 1]);
    y[0] = 0.25 * coordinate_dofs[2] + 0.75 * coordinate_dofs[4];
    y[1] = 0.25 * coordinate_dofs[3] + 0.75 * coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[2] = -(vals[0] * J[0] + vals[1] * J[2]) + (vals[0] * J[1] + vals[1] * J[2 + 1]);
    y[0] = 0.75 * coordinate_dofs[0] + 0.25 * coordinate_dofs[4];
    y[1] = 0.75 * coordinate_dofs[1] + 0.25 * coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[3] = vals[0] * J[1] + vals[1] * J[2 + 1];
    y[0] = 0.5 * coordinate_dofs[0] + 0.5 * coordinate_dofs[4];
    y[1] = 0.5 * coordinate_dofs[1] + 0.5 * coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[4] = vals[0] * J[1] + vals[1] * J[2 + 1];
    y[0] = 0.25 * coordinate_dofs[0] + 0.75 * coordinate_dofs[4];
    y[1] = 0.25 * coordinate_dofs[1] + 0.75 * coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[5] = vals[0] * J[1] + vals[1] * J[2 + 1];
    y[0] = 0.75 * coordinate_dofs[0] + 0.25 * coordinate_dofs[2];
    y[1] = 0.75 * coordinate_dofs[1] + 0.25 * coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[6] = vals[0] * J[0] + vals[1] * J[2];
    y[0] = 0.5 * coordinate_dofs[0] + 0.5 * coordinate_dofs[2];
    y[1] = 0.5 * coordinate_dofs[1] + 0.5 * coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[7] = vals[0] * J[0] + vals[1] * J[2];
    y[0] = 0.25 * coordinate_dofs[0] + 0.75 * coordinate_dofs[2];
    y[1] = 0.25 * coordinate_dofs[1] + 0.75 * coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[8] = vals[0] * J[0] + vals[1] * J[2];
    result = 0.0;
    double X_9[36][2] =
        { { 0.0327753666144599, 0.029316427159784886 },
          { 0.028765333012559124, 0.1480785996684843 },
          { 0.022386872978030603, 0.3369846902811543 },
          { 0.014901563366671144, 0.5586715187715502 },
          { 0.00779187470128645, 0.7692338620300545 },
          { 0.0024666971526702275, 0.926945671319741 },
          { 0.1644292415948274, 0.029316427159784886 },
          { 0.14431148695041662, 0.1480785996684843 },
          { 0.11231168178095369, 0.3369846902811543 },
          { 0.07475897346264909, 0.5586715187715502 },
          { 0.039090700732824224, 0.7692338620300545 },
          { 0.01237506041744002, 0.926945671319741 },
          { 0.36952992437237664, 0.029316427159784886 },
          { 0.324318304588776, 0.1480785996684843 },
          { 0.252403568076518, 0.3369846902811543 },
          { 0.16800951912119183, 0.5586715187715502 },
          { 0.0878504549759972, 0.7692338620300545 },
          { 0.027811082115360597, 0.926945671319741 },
          { 0.6011536484678385, 0.029316427159784886 },
          { 0.5276030957427397, 0.1480785996684843 },
          { 0.4106117416423277, 0.3369846902811543 },
          { 0.27331896210725803, 0.5586715187715502 },
          { 0.1429156829939483, 0.7692338620300545 },
          { 0.04524324656489831, 0.926945671319741 },
          { 0.8062543312453878, 0.029316427159784886 },
          { 0.7076099133810991, 0.1480785996684843 },
          { 0.5507036279378921, 0.3369846902811543 },
          { 0.36656950776580083, 0.5586715187715502 },
          { 0.19167543723712127, 0.7692338620300545 },
          { 0.060679268262818886, 0.926945671319741 },
          { 0.9379082062257551, 0.029316427159784886 },
          { 0.8231560673189564, 0.1480785996684843 },
          { 0.640628436740815, 0.3369846902811543 },
          { 0.42642691786177866, 0.5586715187715502 },
          { 0.22297426326865905, 0.7692338620300545 },
          { 0.07058763152758862, 0.926945671319741 } };
    int D_9[36][1] = {};
    double W_9[36][1] =
        { { 0.004380007035333952 },
          { 0.00821012828325171 },
          { 0.008528136573677752 },
          { 0.0059761382734593235 },
          { 0.002662467899383865 },
          { 0.0005292995210569465 },
          { 0.009223072580491742 },
          { 0.017288239137681006 },
          { 0.017957875857470856 },
          { 0.012584079569399019 },
          { 0.005606414437499757 },
          { 0.001114557090923834 },
          { 0.011962482987098903 },
          { 0.022423142044750127 },
          { 0.023291672330955 },
          { 0.016321766574367406 },
          { 0.0072716154775874856 },
          { 0.001445599622248223 },
          { 0.011962482987098896 },
          { 0.022423142044750117 },
          { 0.023291672330954985 },
          { 0.016321766574367395 },
          { 0.007271615477587481 },
          { 0.0014455996222482222 },
          { 0.009223072580491742 },
          { 0.01728823913768101 },
          { 0.017957875857470856 },
          { 0.012584079569399019 },
          { 0.005606414437499757 },
          { 0.001114557090923834 },
          { 0.004380007035333964 },
          { 0.008210128283251733 },
          { 0.008528136573677774 },
          { 0.005976138273459339 },
          { 0.0026624678993838725 },
          { 0.000529299521056948 } };
    double copy_9[2];
    // Loop over points
    for (std::size_t r = 0; r < 36; ++r)
    {
        // Evaluate basis functions for affine mapping
        const double w0 = 1 - X_9[r][0] - X_9[r][1];
        const double w1 = X_9[r][0];
        const double w2 = X_9[r][1];
        // Compute affine mapping y = F(X)
        y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
        y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_9[0] = vals[0] * J[0] + vals[1] * J[2];
        copy_9[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
        // Loop over directions
        for (std::size_t s = 0; s < 1; ++s)
            result += copy_9[D_9[r][s]] * W_9[r][s];
    }
    values[9] = result;
    result = 0.0;
    double X_10[36][2] =
        { { 0.0327753666144599, 0.029316427159784886 },
          { 0.028765333012559124, 0.1480785996684843 },
          { 0.022386872978030603, 0.3369846902811543 },
          { 0.014901563366671144, 0.5586715187715502 },
          { 0.00779187470128645, 0.7692338620300545 },
          { 0.0024666971526702275, 0.926945671319741 },
          { 0.1644292415948274, 0.029316427159784886 },
          { 0.14431148695041662, 0.1480785996684843 },
          { 0.11231168178095369, 0.3369846902811543 },
          { 0.07475897346264909, 0.5586715187715502 },
          { 0.039090700732824224, 0.7692338620300545 },
          { 0.01237506041744002, 0.926945671319741 },
          { 0.36952992437237664, 0.029316427159784886 },
          { 0.324318304588776, 0.1480785996684843 },
          { 0.252403568076518, 0.3369846902811543 },
          { 0.16800951912119183, 0.5586715187715502 },
          { 0.0878504549759972, 0.7692338620300545 },
          { 0.027811082115360597, 0.926945671319741 },
          { 0.6011536484678385, 0.029316427159784886 },
          { 0.5276030957427397, 0.1480785996684843 },
          { 0.4106117416423277, 0.3369846902811543 },
          { 0.27331896210725803, 0.5586715187715502 },
          { 0.1429156829939483, 0.7692338620300545 },
          { 0.04524324656489831, 0.926945671319741 },
          { 0.8062543312453878, 0.029316427159784886 },
          { 0.7076099133810991, 0.1480785996684843 },
          { 0.5507036279378921, 0.3369846902811543 },
          { 0.36656950776580083, 0.5586715187715502 },
          { 0.19167543723712127, 0.7692338620300545 },
          { 0.060679268262818886, 0.926945671319741 },
          { 0.9379082062257551, 0.029316427159784886 },
          { 0.8231560673189564, 0.1480785996684843 },
          { 0.640628436740815, 0.3369846902811543 },
          { 0.42642691786177866, 0.5586715187715502 },
          { 0.22297426326865905, 0.7692338620300545 },
          { 0.07058763152758862, 0.926945671319741 } };
    int D_10[36][1] = {};
    double W_10[36][1] =
        { { -0.009710973194534896 },
          { -0.015975694174423887 },
          { -0.012914808498775162 },
          { -0.006024109540551331 },
          { -0.0014033523604530267 },
          { -8.831972792250468e-5 },
          { -0.01449999797697064 },
          { -0.023854203751711895 },
          { -0.019283823912786737 },
          { -0.00899493535830189 },
          { -0.00209542400951097 },
          { -0.00013187513244538945 },
          { -0.006787033586233021 },
          { -0.011165469284399073 },
          { -0.009026205436370045 },
          { -0.0042102715103650165 },
          { -0.0009808079389071213 },
          { -6.172697089456968e-5 },
          { 0.006787033586233017 },
          { 0.011165469284399062 },
          { 0.00902620543637004 },
          { 0.004210271510365018 },
          { 0.0009808079389071207 },
          { 6.172697089456923e-5 },
          { 0.014499997976970646 },
          { 0.023854203751711905 },
          { 0.01928382391278674 },
          { 0.008994935358301898 },
          { 0.00209542400951097 },
          { 0.00013187513244538915 },
          { 0.00971097319453492 },
          { 0.015975694174423925 },
          { 0.012914808498775193 },
          { 0.006024109540551347 },
          { 0.0014033523604530306 },
          { 8.831972792250464e-5 } };
    double copy_10[2];
    // Loop over points
    for (std::size_t r = 0; r < 36; ++r)
    {
        // Evaluate basis functions for affine mapping
        const double w0 = 1 - X_10[r][0] - X_10[r][1];
        const double w1 = X_10[r][0];
        const double w2 = X_10[r][1];
        // Compute affine mapping y = F(X)
        y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
        y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_10[0] = vals[0] * J[0] + vals[1] * J[2];
        copy_10[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
        // Loop over directions
        for (std::size_t s = 0; s < 1; ++s)
            result += copy_10[D_10[r][s]] * W_10[r][s];
    }
    values[10] = result;
    result = 0.0;
    double X_11[36][2] =
        { { 0.0327753666144599, 0.029316427159784886 },
          { 0.028765333012559124, 0.1480785996684843 },
          { 0.022386872978030603, 0.3369846902811543 },
          { 0.014901563366671144, 0.5586715187715502 },
          { 0.00779187470128645, 0.7692338620300545 },
          { 0.0024666971526702275, 0.926945671319741 },
          { 0.1644292415948274, 0.029316427159784886 },
          { 0.14431148695041662, 0.1480785996684843 },
          { 0.11231168178095369, 0.3369846902811543 },
          { 0.07475897346264909, 0.5586715187715502 },
          { 0.039090700732824224, 0.7692338620300545 },
          { 0.01237506041744002, 0.926945671319741 },
          { 0.36952992437237664, 0.029316427159784886 },
          { 0.324318304588776, 0.1480785996684843 },
          { 0.252403568076518, 0.3369846902811543 },
          { 0.16800951912119183, 0.5586715187715502 },
          { 0.0878504549759972, 0.7692338620300545 },
          { 0.027811082115360597, 0.926945671319741 },
          { 0.6011536484678385, 0.029316427159784886 },
          { 0.5276030957427397, 0.1480785996684843 },
          { 0.4106117416423277, 0.3369846902811543 },
          { 0.27331896210725803, 0.5586715187715502 },
          { 0.1429156829939483, 0.7692338620300545 },
          { 0.04524324656489831, 0.926945671319741 },
          { 0.8062543312453878, 0.029316427159784886 },
          { 0.7076099133810991, 0.1480785996684843 },
          { 0.5507036279378921, 0.3369846902811543 },
          { 0.36656950776580083, 0.5586715187715502 },
          { 0.19167543723712127, 0.7692338620300545 },
          { 0.060679268262818886, 0.926945671319741 },
          { 0.9379082062257551, 0.029316427159784886 },
          { 0.8231560673189564, 0.1480785996684843 },
          { 0.640628436740815, 0.3369846902811543 },
          { 0.42642691786177866, 0.5586715187715502 },
          { 0.22297426326865905, 0.7692338620300545 },
          { 0.07058763152758862, 0.926945671319741 } };
    int D_11[36][1] = {};
    double W_11[36][1] =
        { { -0.00564948416560004 },
          { -0.006452908537728117 },
          { 0.0001321127369674421 },
          { 0.005713361221947881 },
          { 0.00492388644483935 },
          { 0.0013330322995734722 },
          { -0.011896237170700168 },
          { -0.013588024703755641 },
          { 0.000278192558146252 },
          { 0.012030744426549674 },
          { 0.010368330847986927 },
          { 0.002806994041772937 },
          { -0.015429623211032667 },
          { -0.017623900595856532 },
          { 0.0003608205091003015 },
          { 0.015604081423921987 },
          { 0.013447902560801864 },
          { 0.0036407193130650224 },
          { -0.015429623211032657 },
          { -0.017623900595856525 },
          { 0.00036082050910030123 },
          { 0.015604081423921978 },
          { 0.013447902560801856 },
          { 0.0036407193130650202 },
          { -0.011896237170700168 },
          { -0.013588024703755645 },
          { 0.000278192558146252 },
          { 0.012030744426549674 },
          { 0.010368330847986927 },
          { 0.002806994041772937 },
          { -0.005649484165600055 },
          { -0.006452908537728134 },
          { 0.00013211273696744246 },
          { 0.005713361221947897 },
          { 0.004923886444839364 },
          { 0.0013330322995734759 } };
    double copy_11[2];
    // Loop over points
    for (std::size_t r = 0; r < 36; ++r)
    {
        // Evaluate basis functions for affine mapping
        const double w0 = 1 - X_11[r][0] - X_11[r][1];
        const double w1 = X_11[r][0];
        const double w2 = X_11[r][1];
        // Compute affine mapping y = F(X)
        y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
        y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_11[0] = vals[0] * J[0] + vals[1] * J[2];
        copy_11[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
        // Loop over directions
        for (std::size_t s = 0; s < 1; ++s)
            result += copy_11[D_11[r][s]] * W_11[r][s];
    }
    values[11] = result;
    result = 0.0;
    double X_12[36][2] =
        { { 0.0327753666144599, 0.029316427159784886 },
          { 0.028765333012559124, 0.1480785996684843 },
          { 0.022386872978030603, 0.3369846902811543 },
          { 0.014901563366671144, 0.5586715187715502 },
          { 0.00779187470128645, 0.7692338620300545 },
          { 0.0024666971526702275, 0.926945671319741 },
          { 0.1644292415948274, 0.029316427159784886 },
          { 0.14431148695041662, 0.1480785996684843 },
          { 0.11231168178095369, 0.3369846902811543 },
          { 0.07475897346264909, 0.5586715187715502 },
          { 0.039090700732824224, 0.7692338620300545 },
          { 0.01237506041744002, 0.926945671319741 },
          { 0.36952992437237664, 0.029316427159784886 },
          { 0.324318304588776, 0.1480785996684843 },
          { 0.252403568076518, 0.3369846902811543 },
          { 0.16800951912119183, 0.5586715187715502 },
          { 0.0878504549759972, 0.7692338620300545 },
          { 0.027811082115360597, 0.926945671319741 },
          { 0.6011536484678385, 0.029316427159784886 },
          { 0.5276030957427397, 0.1480785996684843 },
          { 0.4106117416423277, 0.3369846902811543 },
          { 0.27331896210725803, 0.5586715187715502 },
          { 0.1429156829939483, 0.7692338620300545 },
          { 0.04524324656489831, 0.926945671319741 },
          { 0.8062543312453878, 0.029316427159784886 },
          { 0.7076099133810991, 0.1480785996684843 },
          { 0.5507036279378921, 0.3369846902811543 },
          { 0.36656950776580083, 0.5586715187715502 },
          { 0.19167543723712127, 0.7692338620300545 },
          { 0.060679268262818886, 0.926945671319741 },
          { 0.9379082062257551, 0.029316427159784886 },
          { 0.8231560673189564, 0.1480785996684843 },
          { 0.640628436740815, 0.3369846902811543 },
          { 0.42642691786177866, 0.5586715187715502 },
          { 0.22297426326865905, 0.7692338620300545 },
          { 0.07058763152758862, 0.926945671319741 } };
    int D_12[36][1] =
        { { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 } };
    double W_12[36][1] =
        { { 0.004380007035333952 },
          { 0.00821012828325171 },
          { 0.008528136573677752 },
          { 0.0059761382734593235 },
          { 0.002662467899383865 },
          { 0.0005292995210569465 },
          { 0.009223072580491742 },
          { 0.017288239137681006 },
          { 0.017957875857470856 },
          { 0.012584079569399019 },
          { 0.005606414437499757 },
          { 0.001114557090923834 },
          { 0.011962482987098903 },
          { 0.022423142044750127 },
          { 0.023291672330955 },
          { 0.016321766574367406 },
          { 0.0072716154775874856 },
          { 0.001445599622248223 },
          { 0.011962482987098896 },
          { 0.022423142044750117 },
          { 0.023291672330954985 },
          { 0.016321766574367395 },
          { 0.007271615477587481 },
          { 0.0014455996222482222 },
          { 0.009223072580491742 },
          { 0.01728823913768101 },
          { 0.017957875857470856 },
          { 0.012584079569399019 },
          { 0.005606414437499757 },
          { 0.001114557090923834 },
          { 0.004380007035333964 },
          { 0.008210128283251733 },
          { 0.008528136573677774 },
          { 0.005976138273459339 },
          { 0.0026624678993838725 },
          { 0.000529299521056948 } };
    double copy_12[2];
    // Loop over points
    for (std::size_t r = 0; r < 36; ++r)
    {
        // Evaluate basis functions for affine mapping
        const double w0 = 1 - X_12[r][0] - X_12[r][1];
        const double w1 = X_12[r][0];
        const double w2 = X_12[r][1];
        // Compute affine mapping y = F(X)
        y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
        y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_12[0] = vals[0] * J[0] + vals[1] * J[2];
        copy_12[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
        // Loop over directions
        for (std::size_t s = 0; s < 1; ++s)
            result += copy_12[D_12[r][s]] * W_12[r][s];
    }
    values[12] = result;
    result = 0.0;
    double X_13[36][2] =
        { { 0.0327753666144599, 0.029316427159784886 },
          { 0.028765333012559124, 0.1480785996684843 },
          { 0.022386872978030603, 0.3369846902811543 },
          { 0.014901563366671144, 0.5586715187715502 },
          { 0.00779187470128645, 0.7692338620300545 },
          { 0.0024666971526702275, 0.926945671319741 },
          { 0.1644292415948274, 0.029316427159784886 },
          { 0.14431148695041662, 0.1480785996684843 },
          { 0.11231168178095369, 0.3369846902811543 },
          { 0.07475897346264909, 0.5586715187715502 },
          { 0.039090700732824224, 0.7692338620300545 },
          { 0.01237506041744002, 0.926945671319741 },
          { 0.36952992437237664, 0.029316427159784886 },
          { 0.324318304588776, 0.1480785996684843 },
          { 0.252403568076518, 0.3369846902811543 },
          { 0.16800951912119183, 0.5586715187715502 },
          { 0.0878504549759972, 0.7692338620300545 },
          { 0.027811082115360597, 0.926945671319741 },
          { 0.6011536484678385, 0.029316427159784886 },
          { 0.5276030957427397, 0.1480785996684843 },
          { 0.4106117416423277, 0.3369846902811543 },
          { 0.27331896210725803, 0.5586715187715502 },
          { 0.1429156829939483, 0.7692338620300545 },
          { 0.04524324656489831, 0.926945671319741 },
          { 0.8062543312453878, 0.029316427159784886 },
          { 0.7076099133810991, 0.1480785996684843 },
          { 0.5507036279378921, 0.3369846902811543 },
          { 0.36656950776580083, 0.5586715187715502 },
          { 0.19167543723712127, 0.7692338620300545 },
          { 0.060679268262818886, 0.926945671319741 },
          { 0.9379082062257551, 0.029316427159784886 },
          { 0.8231560673189564, 0.1480785996684843 },
          { 0.640628436740815, 0.3369846902811543 },
          { 0.42642691786177866, 0.5586715187715502 },
          { 0.22297426326865905, 0.7692338620300545 },
          { 0.07058763152758862, 0.926945671319741 } };
    int D_13[36][1] =
        { { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 } };
    double W_13[36][1] =
        { { -0.009710973194534896 },
          { -0.015975694174423887 },
          { -0.012914808498775162 },
          { -0.006024109540551331 },
          { -0.0014033523604530267 },
          { -8.831972792250468e-5 },
          { -0.01449999797697064 },
          { -0.023854203751711895 },
          { -0.019283823912786737 },
          { -0.00899493535830189 },
          { -0.00209542400951097 },
          { -0.00013187513244538945 },
          { -0.006787033586233021 },
          { -0.011165469284399073 },
          { -0.009026205436370045 },
          { -0.0042102715103650165 },
          { -0.0009808079389071213 },
          { -6.172697089456968e-5 },
          { 0.006787033586233017 },
          { 0.011165469284399062 },
          { 0.00902620543637004 },
          { 0.004210271510365018 },
          { 0.0009808079389071207 },
          { 6.172697089456923e-5 },
          { 0.014499997976970646 },
          { 0.023854203751711905 },
          { 0.01928382391278674 },
          { 0.008994935358301898 },
          { 0.00209542400951097 },
          { 0.00013187513244538915 },
          { 0.00971097319453492 },
          { 0.015975694174423925 },
          { 0.012914808498775193 },
          { 0.006024109540551347 },
          { 0.0014033523604530306 },
          { 8.831972792250464e-5 } };
    double copy_13[2];
    // Loop over points
    for (std::size_t r = 0; r < 36; ++r)
    {
        // Evaluate basis functions for affine mapping
        const double w0 = 1 - X_13[r][0] - X_13[r][1];
        const double w1 = X_13[r][0];
        const double w2 = X_13[r][1];
        // Compute affine mapping y = F(X)
        y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
        y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_13[0] = vals[0] * J[0] + vals[1] * J[2];
        copy_13[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
        // Loop over directions
        for (std::size_t s = 0; s < 1; ++s)
            result += copy_13[D_13[r][s]] * W_13[r][s];
    }
    values[13] = result;
    result = 0.0;
    double X_14[36][2] =
        { { 0.0327753666144599, 0.029316427159784886 },
          { 0.028765333012559124, 0.1480785996684843 },
          { 0.022386872978030603, 0.3369846902811543 },
          { 0.014901563366671144, 0.5586715187715502 },
          { 0.00779187470128645, 0.7692338620300545 },
          { 0.0024666971526702275, 0.926945671319741 },
          { 0.1644292415948274, 0.029316427159784886 },
          { 0.14431148695041662, 0.1480785996684843 },
          { 0.11231168178095369, 0.3369846902811543 },
          { 0.07475897346264909, 0.5586715187715502 },
          { 0.039090700732824224, 0.7692338620300545 },
          { 0.01237506041744002, 0.926945671319741 },
          { 0.36952992437237664, 0.029316427159784886 },
          { 0.324318304588776, 0.1480785996684843 },
          { 0.252403568076518, 0.3369846902811543 },
          { 0.16800951912119183, 0.5586715187715502 },
          { 0.0878504549759972, 0.7692338620300545 },
          { 0.027811082115360597, 0.926945671319741 },
          { 0.6011536484678385, 0.029316427159784886 },
          { 0.5276030957427397, 0.1480785996684843 },
          { 0.4106117416423277, 0.3369846902811543 },
          { 0.27331896210725803, 0.5586715187715502 },
          { 0.1429156829939483, 0.7692338620300545 },
          { 0.04524324656489831, 0.926945671319741 },
          { 0.8062543312453878, 0.029316427159784886 },
          { 0.7076099133810991, 0.1480785996684843 },
          { 0.5507036279378921, 0.3369846902811543 },
          { 0.36656950776580083, 0.5586715187715502 },
          { 0.19167543723712127, 0.7692338620300545 },
          { 0.060679268262818886, 0.926945671319741 },
          { 0.9379082062257551, 0.029316427159784886 },
          { 0.8231560673189564, 0.1480785996684843 },
          { 0.640628436740815, 0.3369846902811543 },
          { 0.42642691786177866, 0.5586715187715502 },
          { 0.22297426326865905, 0.7692338620300545 },
          { 0.07058763152758862, 0.926945671319741 } };
    int D_14[36][1] =
        { { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 } };
    double W_14[36][1] =
        { { -0.00564948416560004 },
          { -0.006452908537728117 },
          { 0.0001321127369674421 },
          { 0.005713361221947881 },
          { 0.00492388644483935 },
          { 0.0013330322995734722 },
          { -0.011896237170700168 },
          { -0.013588024703755641 },
          { 0.000278192558146252 },
          { 0.012030744426549674 },
          { 0.010368330847986927 },
          { 0.002806994041772937 },
          { -0.015429623211032667 },
          { -0.017623900595856532 },
          { 0.0003608205091003015 },
          { 0.015604081423921987 },
          { 0.013447902560801864 },
          { 0.0036407193130650224 },
          { -0.015429623211032657 },
          { -0.017623900595856525 },
          { 0.00036082050910030123 },
          { 0.015604081423921978 },
          { 0.013447902560801856 },
          { 0.0036407193130650202 },
          { -0.011896237170700168 },
          { -0.013588024703755645 },
          { 0.000278192558146252 },
          { 0.012030744426549674 },
          { 0.010368330847986927 },
          { 0.002806994041772937 },
          { -0.005649484165600055 },
          { -0.006452908537728134 },
          { 0.00013211273696744246 },
          { 0.005713361221947897 },
          { 0.004923886444839364 },
          { 0.0013330322995734759 } };
    double copy_14[2];
    // Loop over points
    for (std::size_t r = 0; r < 36; ++r)
    {
        // Evaluate basis functions for affine mapping
        const double w0 = 1 - X_14[r][0] - X_14[r][1];
        const double w1 = X_14[r][0];
        const double w2 = X_14[r][1];
        // Compute affine mapping y = F(X)
        y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
        y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_14[0] = vals[0] * J[0] + vals[1] * J[2];
        copy_14[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
        // Loop over directions
        for (std::size_t s = 0; s < 1; ++s)
            result += copy_14[D_14[r][s]] * W_14[r][s];
    }
    values[14] = result;
  }

  void interpolate_vertex_values(double * vertex_values,
                                 const double * dof_values,
                                 const double * coordinate_dofs,
                                 int cell_orientation,
                                 const ufc::coordinate_mapping * cm=nullptr
                                 ) const final override
  {
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    // Compute Inverse Jacobian and determinant
    double K[4];
    double detJ;
    compute_jacobian_inverse_triangle_2d(K, detJ, J);
    // Evaluate function and change variables
    vertex_values[0] = dof_values[3] * (K[2] * 2.999999999999999) + dof_values[4] * (K[2] * -3.0) + dof_values[5] * K[2] + dof_values[6] * (K[0] * 2.9999999999999996) + dof_values[7] * (K[0] * -3.0000000000000004) + dof_values[8] * K[0];
    vertex_values[2] = dof_values[0] * (K[2] * 3.0000000000000027) + dof_values[1] * (K[2] * -3.000000000000007) + dof_values[2] * K[2] + dof_values[6] * (K[0] + K[2]) + dof_values[7] * (K[0] * -3.0000000000000018 + K[2] * -3.0000000000000036) + dof_values[8] * (K[0] * 3.0000000000000018 + K[2] * 3.0000000000000067);
    vertex_values[4] = dof_values[0] * -K[0] + dof_values[1] * (K[0] * 2.999999999999994) + dof_values[2] * (K[0] * -2.9999999999999956) + dof_values[3] * (K[0] + K[2]) + dof_values[4] * (K[0] * -2.9999999999999964 + K[2] * -3.0) + dof_values[5] * (K[0] * 2.9999999999999947 + K[2] * 3.0000000000000004);
    vertex_values[1] = dof_values[3] * (K[2 + 1] * 2.999999999999999) + dof_values[4] * (K[2 + 1] * -3.0) + dof_values[5] * K[2 + 1] + dof_values[6] * (K[1] * 2.9999999999999996) + dof_values[7] * (K[1] * -3.0000000000000004) + dof_values[8] * K[1];
    vertex_values[3] = dof_values[0] * (K[2 + 1] * 3.0000000000000027) + dof_values[1] * (K[2 + 1] * -3.000000000000007) + dof_values[2] * K[2 + 1] + dof_values[6] * (K[1] + K[2 + 1]) + dof_values[7] * (K[1] * -3.0000000000000018 + K[2 + 1] * -3.0000000000000036) + dof_values[8] * (K[1] * 3.0000000000000018 + K[2 + 1] * 3.0000000000000067);
    vertex_values[5] = dof_values[0] * -K[1] + dof_values[1] * (K[1] * 2.999999999999994) + dof_values[2] * (K[1] * -2.9999999999999956) + dof_values[3] * (K[1] + K[2 + 1]) + dof_values[4] * (K[1] * -2.9999999999999964 + K[2 + 1] * -3.0) + dof_values[5] * (K[1] * 2.9999999999999947 + K[2 + 1] * 3.0000000000000004);
  }

  void tabulate_dof_coordinates(double * dof_coordinates,
                                const double * coordinate_dofs,
                                const ufc::coordinate_mapping * cm=nullptr
                                ) const final override
  {
    throw std::runtime_error("tabulate_dof_coordinates is not defined for this element");
  }

  void tabulate_reference_dof_coordinates(double * reference_dof_coordinates) const final override
  {
    throw std::runtime_error("tabulate_reference_dof_coordinates is not defined for this element");
  }

  std::size_t num_sub_elements() const final override
  {
    return 0;
  }

  ufc::finite_element * create_sub_element(std::size_t i) const final override
  {
    return nullptr;
  }

  ufc::finite_element * create() const final override
  {
    return new forms_finite_element_2();
  }

};


class forms_dofmap_0: public ufc::dofmap
{
public:

  forms_dofmap_0() : ufc::dofmap()
  {
    // Do nothing
  }

  ~forms_dofmap_0() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FFC dofmap for FiniteElement('Lagrange', triangle, 1)";
  }

  bool needs_mesh_entities(std::size_t d) const final override
  {
    static const bool return_values[3] = { true, false, false };
    if (d >= 3)
        return false;
    return return_values[d];
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t global_dimension(const std::vector<std::size_t>&
                               num_global_entities) const final override
  {
    return num_global_entities[0];
  }

  std::size_t num_global_support_dofs() const final override
  {
    return 0;
  }

  std::size_t num_element_support_dofs() const final override
  {
    return 3;
  }

  std::size_t num_element_dofs() const final override
  {
    return 3;
  }

  std::size_t num_facet_dofs() const final override
  {
    return 2;
  }

  std::size_t num_entity_dofs(std::size_t d) const final override
  {
    static const std::size_t return_values[3] = { 1, 0, 0 };
    if (d >= 3)
        return 0;
    return return_values[d];
  }

  std::size_t num_entity_closure_dofs(std::size_t d) const final override
  {
    static const std::size_t return_values[3] = { 1, 2, 3 };
    if (d >= 3)
        return 0;
    return return_values[d];
  }

  void tabulate_dofs(std::size_t * dofs,
                     const std::vector<std::size_t>& num_global_entities,
                     const std::vector<std::vector<std::size_t>>& entity_indices) const final override
  {
    dofs[0] = entity_indices[0][0];
    dofs[1] = entity_indices[0][1];
    dofs[2] = entity_indices[0][2];
  }

  void tabulate_facet_dofs(std::size_t * dofs,
                           std::size_t facet) const final override
  {
    switch (facet)
    {
    case 0:
        dofs[0] = 1;
        dofs[1] = 2;
        break;
    case 1:
        dofs[0] = 0;
        dofs[1] = 2;
        break;
    case 2:
        dofs[0] = 0;
        dofs[1] = 1;
        break;
    }
  }

  void tabulate_entity_dofs(std::size_t * dofs,
                            std::size_t d, std::size_t i) const final override
  {
    switch (d)
    {
    case 0:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            break;
        case 1:
            dofs[0] = 1;
            break;
        case 2:
            dofs[0] = 2;
            break;
        }
        break;
    }
  }

  void tabulate_entity_closure_dofs(std::size_t * dofs,
                                    std::size_t d, std::size_t i) const final override
  {
    switch (d)
    {
    case 0:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            break;
        case 1:
            dofs[0] = 1;
            break;
        case 2:
            dofs[0] = 2;
            break;
        }
        break;
    case 1:
        switch (i)
        {
        case 0:
            dofs[0] = 1;
            dofs[1] = 2;
            break;
        case 1:
            dofs[0] = 0;
            dofs[1] = 2;
            break;
        case 2:
            dofs[0] = 0;
            dofs[1] = 1;
            break;
        }
        break;
    case 2:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 1;
            dofs[2] = 2;
            break;
        }
        break;
    }
  }


  std::size_t num_sub_dofmaps() const final override
  {
    return 0;
  }

  ufc::dofmap * create_sub_dofmap(std::size_t i) const final override
  {
    return nullptr;
  }

  ufc::dofmap * create() const final override
  {
    return new forms_dofmap_0();
  }

};


class forms_dofmap_1: public ufc::dofmap
{
public:

  forms_dofmap_1() : ufc::dofmap()
  {
    // Do nothing
  }

  ~forms_dofmap_1() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FFC dofmap for VectorElement(FiniteElement('Lagrange', triangle, 1), dim=2)";
  }

  bool needs_mesh_entities(std::size_t d) const final override
  {
    static const bool return_values[3] = { true, false, false };
    if (d >= 3)
        return false;
    return return_values[d];
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t global_dimension(const std::vector<std::size_t>&
                               num_global_entities) const final override
  {
    return 2 * num_global_entities[0];
  }

  std::size_t num_global_support_dofs() const final override
  {
    return 0;
  }

  std::size_t num_element_support_dofs() const final override
  {
    return 6;
  }

  std::size_t num_element_dofs() const final override
  {
    return 6;
  }

  std::size_t num_facet_dofs() const final override
  {
    return 4;
  }

  std::size_t num_entity_dofs(std::size_t d) const final override
  {
    static const std::size_t return_values[3] = { 2, 0, 0 };
    if (d >= 3)
        return 0;
    return return_values[d];
  }

  std::size_t num_entity_closure_dofs(std::size_t d) const final override
  {
    static const std::size_t return_values[3] = { 2, 4, 6 };
    if (d >= 3)
        return 0;
    return return_values[d];
  }

  void tabulate_dofs(std::size_t * dofs,
                     const std::vector<std::size_t>& num_global_entities,
                     const std::vector<std::vector<std::size_t>>& entity_indices) const final override
  {
    std::size_t offset = 0;
    dofs[0] = offset + entity_indices[0][0];
    dofs[1] = offset + entity_indices[0][1];
    dofs[2] = offset + entity_indices[0][2];
    offset += num_global_entities[0];
    dofs[3] = offset + entity_indices[0][0];
    dofs[4] = offset + entity_indices[0][1];
    dofs[5] = offset + entity_indices[0][2];
    offset += num_global_entities[0];
  }

  void tabulate_facet_dofs(std::size_t * dofs,
                           std::size_t facet) const final override
  {
    switch (facet)
    {
    case 0:
        dofs[0] = 1;
        dofs[1] = 2;
        dofs[2] = 4;
        dofs[3] = 5;
        break;
    case 1:
        dofs[0] = 0;
        dofs[1] = 2;
        dofs[2] = 3;
        dofs[3] = 5;
        break;
    case 2:
        dofs[0] = 0;
        dofs[1] = 1;
        dofs[2] = 3;
        dofs[3] = 4;
        break;
    }
  }

  void tabulate_entity_dofs(std::size_t * dofs,
                            std::size_t d, std::size_t i) const final override
  {
    switch (d)
    {
    case 0:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 3;
            break;
        case 1:
            dofs[0] = 1;
            dofs[1] = 4;
            break;
        case 2:
            dofs[0] = 2;
            dofs[1] = 5;
            break;
        }
        break;
    }
  }

  void tabulate_entity_closure_dofs(std::size_t * dofs,
                                    std::size_t d, std::size_t i) const final override
  {
    switch (d)
    {
    case 0:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 3;
            break;
        case 1:
            dofs[0] = 1;
            dofs[1] = 4;
            break;
        case 2:
            dofs[0] = 2;
            dofs[1] = 5;
            break;
        }
        break;
    case 1:
        switch (i)
        {
        case 0:
            dofs[0] = 1;
            dofs[1] = 2;
            dofs[2] = 4;
            dofs[3] = 5;
            break;
        case 1:
            dofs[0] = 0;
            dofs[1] = 2;
            dofs[2] = 3;
            dofs[3] = 5;
            break;
        case 2:
            dofs[0] = 0;
            dofs[1] = 1;
            dofs[2] = 3;
            dofs[3] = 4;
            break;
        }
        break;
    case 2:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 1;
            dofs[2] = 2;
            dofs[3] = 3;
            dofs[4] = 4;
            dofs[5] = 5;
            break;
        }
        break;
    }
  }


  std::size_t num_sub_dofmaps() const final override
  {
    return 2;
  }

  ufc::dofmap * create_sub_dofmap(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
        return new forms_dofmap_0();
    case 1:
        return new forms_dofmap_0();
    default:
        return nullptr;
    }
  }

  ufc::dofmap * create() const final override
  {
    return new forms_dofmap_1();
  }

};


class forms_dofmap_2: public ufc::dofmap
{
public:

  forms_dofmap_2() : ufc::dofmap()
  {
    // Do nothing
  }

  ~forms_dofmap_2() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FFC dofmap for FiniteElement('Nedelec 1st kind H(curl)', triangle, 3)";
  }

  bool needs_mesh_entities(std::size_t d) const final override
  {
    static const bool return_values[3] = { false, true, true };
    if (d >= 3)
        return false;
    return return_values[d];
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t global_dimension(const std::vector<std::size_t>&
                               num_global_entities) const final override
  {
    return 3 * num_global_entities[1] + 6 * num_global_entities[2];
  }

  std::size_t num_global_support_dofs() const final override
  {
    return 0;
  }

  std::size_t num_element_support_dofs() const final override
  {
    return 15;
  }

  std::size_t num_element_dofs() const final override
  {
    return 15;
  }

  std::size_t num_facet_dofs() const final override
  {
    return 3;
  }

  std::size_t num_entity_dofs(std::size_t d) const final override
  {
    static const std::size_t return_values[3] = { 0, 3, 6 };
    if (d >= 3)
        return 0;
    return return_values[d];
  }

  std::size_t num_entity_closure_dofs(std::size_t d) const final override
  {
    static const std::size_t return_values[3] = { 0, 3, 15 };
    if (d >= 3)
        return 0;
    return return_values[d];
  }

  void tabulate_dofs(std::size_t * dofs,
                     const std::vector<std::size_t>& num_global_entities,
                     const std::vector<std::vector<std::size_t>>& entity_indices) const final override
  {
    std::size_t offset = 0;
    dofs[0] = offset + 3 * entity_indices[1][0];
    dofs[1] = offset + 3 * entity_indices[1][0] + 1;
    dofs[2] = offset + 3 * entity_indices[1][0] + 2;
    dofs[3] = offset + 3 * entity_indices[1][1];
    dofs[4] = offset + 3 * entity_indices[1][1] + 1;
    dofs[5] = offset + 3 * entity_indices[1][1] + 2;
    dofs[6] = offset + 3 * entity_indices[1][2];
    dofs[7] = offset + 3 * entity_indices[1][2] + 1;
    dofs[8] = offset + 3 * entity_indices[1][2] + 2;
    offset += 3 * num_global_entities[1];
    dofs[9] = offset + 6 * entity_indices[2][0];
    dofs[10] = offset + 6 * entity_indices[2][0] + 1;
    dofs[11] = offset + 6 * entity_indices[2][0] + 2;
    dofs[12] = offset + 6 * entity_indices[2][0] + 3;
    dofs[13] = offset + 6 * entity_indices[2][0] + 4;
    dofs[14] = offset + 6 * entity_indices[2][0] + 5;
    offset += 6 * num_global_entities[2];
  }

  void tabulate_facet_dofs(std::size_t * dofs,
                           std::size_t facet) const final override
  {
    switch (facet)
    {
    case 0:
        dofs[0] = 0;
        dofs[1] = 1;
        dofs[2] = 2;
        break;
    case 1:
        dofs[0] = 3;
        dofs[1] = 4;
        dofs[2] = 5;
        break;
    case 2:
        dofs[0] = 6;
        dofs[1] = 7;
        dofs[2] = 8;
        break;
    }
  }

  void tabulate_entity_dofs(std::size_t * dofs,
                            std::size_t d, std::size_t i) const final override
  {
    switch (d)
    {
    case 1:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 1;
            dofs[2] = 2;
            break;
        case 1:
            dofs[0] = 3;
            dofs[1] = 4;
            dofs[2] = 5;
            break;
        case 2:
            dofs[0] = 6;
            dofs[1] = 7;
            dofs[2] = 8;
            break;
        }
        break;
    case 2:
        switch (i)
        {
        case 0:
            dofs[0] = 9;
            dofs[1] = 10;
            dofs[2] = 11;
            dofs[3] = 12;
            dofs[4] = 13;
            dofs[5] = 14;
            break;
        }
        break;
    }
  }

  void tabulate_entity_closure_dofs(std::size_t * dofs,
                                    std::size_t d, std::size_t i) const final override
  {
    switch (d)
    {
    case 0:
        switch (i)
        {
        case 0:
            break;
        case 1:
            break;
        case 2:
            break;
        }
        break;
    case 1:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 1;
            dofs[2] = 2;
            break;
        case 1:
            dofs[0] = 3;
            dofs[1] = 4;
            dofs[2] = 5;
            break;
        case 2:
            dofs[0] = 6;
            dofs[1] = 7;
            dofs[2] = 8;
            break;
        }
        break;
    case 2:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 1;
            dofs[2] = 2;
            dofs[3] = 3;
            dofs[4] = 4;
            dofs[5] = 5;
            dofs[6] = 6;
            dofs[7] = 7;
            dofs[8] = 8;
            dofs[9] = 9;
            dofs[10] = 10;
            dofs[11] = 11;
            dofs[12] = 12;
            dofs[13] = 13;
            dofs[14] = 14;
            break;
        }
        break;
    }
  }


  std::size_t num_sub_dofmaps() const final override
  {
    return 0;
  }

  ufc::dofmap * create_sub_dofmap(std::size_t i) const final override
  {
    return nullptr;
  }

  ufc::dofmap * create() const final override
  {
    return new forms_dofmap_2();
  }

};


class forms_coordinate_mapping_1: public ufc::coordinate_mapping
{
public:

  forms_coordinate_mapping_1() : ufc::coordinate_mapping()
  {
    // Do nothing
  }

  ~forms_coordinate_mapping_1() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FFC coordinate_mapping from VectorElement(FiniteElement('Lagrange', triangle, 1), dim=2)";
  }

  ufc::coordinate_mapping * create() const final override
  {
    return new forms_coordinate_mapping_1();
  }

  std::size_t geometric_dimension() const final override
  {
    return 2;
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  ufc::shape cell_shape() const final override
  {
    return ufc::shape::triangle;
  }

  ufc::finite_element * create_coordinate_finite_element() const final override
  {
    return new forms_finite_element_1();
  }

  ufc::dofmap * create_coordinate_dofmap() const final override
  {
    return new forms_dofmap_1();
  }

  void compute_physical_coordinates(
      double * x, std::size_t num_points,
      const double * X,
      const double * coordinate_dofs) const final override
  {
    forms_finite_element_0 xelement;
    double phi[3];
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Compute basis values of coordinate element
        xelement.evaluate_reference_basis(phi, 1, &X[2 * ip]);
        // Compute x
        for (std::size_t i = 0; i < 2; ++i)
            for (std::size_t d = 0; d < 3; ++d)
                x[2 * ip + i] += coordinate_dofs[2 * d + i] * phi[d];
    }
  }

  void compute_reference_coordinates(
      double * X, std::size_t num_points,
      const double * x,
      const double * coordinate_dofs, int cell_orientation) const final override
  {
    const double phi_X0[3] = { 1.0, 0.0, 0.0 };
    const double dphi_X0[2][3] =
        { { -1.0, 1.0, 0.0 },
          { -1.0, 0.0, 1.0 } };
    double J[4];
    double detJ[1];
    double K[4];
    double x0[2] = {};
    for (std::size_t i = 0; i < 2; ++i)
        for (std::size_t k = 0; k < 3; ++k)
            x0[i] += coordinate_dofs[2 * k + i] * phi_X0[k];
    for (std::size_t i = 0; i < 2; ++i)
    {
        for (std::size_t j = 0; j < 2; ++j)
        {
            J[2 * i + j] = 0.0;
            for (std::size_t k = 0; k < 3; ++k)
                J[2 * i + j] += coordinate_dofs[2 * k + i] * dphi_X0[j][k];
        }
    }
    compute_jacobian_determinants(detJ, 1, J, cell_orientation);
    compute_jacobian_inverses(K, 1, J, detJ);
    for (std::size_t ip = 0; ip < num_points; ++ip)
        for (std::size_t j = 0; j < 2; ++j)
            for (std::size_t i = 0; i < 2; ++i)
                X[2 * ip + j] += K[2 * j + i] * (x[2 * ip + i] - x0[i]);
  }

  void compute_reference_geometry(
      double * X, double * J, double * detJ, double * K, std::size_t num_points,
      const double * x,
      const double * coordinate_dofs, int cell_orientation) const final override
  {
    const double phi_X0[3] = { 1.0, 0.0, 0.0 };
    const double dphi_X0[2][3] =
        { { -1.0, 1.0, 0.0 },
          { -1.0, 0.0, 1.0 } };
    double x0[2] = {};
    for (std::size_t i = 0; i < 2; ++i)
        for (std::size_t k = 0; k < 3; ++k)
            x0[i] += coordinate_dofs[2 * k + i] * phi_X0[k];
    for (std::size_t i = 0; i < 2; ++i)
    {
        for (std::size_t j = 0; j < 2; ++j)
        {
            J[2 * i + j] = 0.0;
            for (std::size_t k = 0; k < 3; ++k)
                J[2 * i + j] += coordinate_dofs[2 * k + i] * dphi_X0[j][k];
        }
    }
    compute_jacobian_determinants(detJ, 1, J, cell_orientation);
    compute_jacobian_inverses(K, 1, J, detJ);
    for (std::size_t ip = 0; ip < num_points; ++ip)
        for (std::size_t j = 0; j < 2; ++j)
            for (std::size_t i = 0; i < 2; ++i)
                X[2 * ip + j] += K[2 * j + i] * (x[2 * ip + i] - x0[i]);
  }

  void compute_jacobians(
      double * J, std::size_t num_points,
      const double * X,
      const double * coordinate_dofs) const final override
  {
    forms_finite_element_0 xelement;
    double dphi[6];
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Compute basis derivatives of coordinate element
        xelement.evaluate_reference_basis_derivatives(dphi, 1, 1, &X[2 * ip]);
        // Compute J
        for (std::size_t i = 0; i < 2; ++i)
            for (std::size_t j = 0; j < 2; ++j)
                for (std::size_t d = 0; d < 3; ++d)
                    J[2 * 2 * ip + 2 * i + j] += coordinate_dofs[2 * d + i] * dphi[2 * d + j];
    }
  }

  void compute_jacobian_determinants(
      double * detJ, std::size_t num_points,
      const double * J,
      int cell_orientation) const final override
  {
    for (std::size_t ip = 0; ip < num_points; ++ip)
        detJ[ip] = J[2 * 2 * ip] * J[2 * 2 * ip + 2 + 1] - J[2 * 2 * ip + 1] * J[2 * 2 * ip + 2];
  }

  void compute_jacobian_inverses(
      double * K, std::size_t num_points,
      const double * J, const double * detJ) const final override
  {
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        K[2 * 2 * ip] = J[2 * 2 * ip + 2 + 1] / detJ[ip];
        K[2 * 2 * ip + 1] = -J[2 * 2 * ip + 1] / detJ[ip];
        K[2 * 2 * ip + 2] = -J[2 * 2 * ip + 2] / detJ[ip];
        K[2 * 2 * ip + 2 + 1] = J[2 * 2 * ip] / detJ[ip];
    }
  }

  void compute_geometry(
      double * x, double * J, double * detJ, double * K, std::size_t num_points,
      const double * X,
      const double * coordinate_dofs, int cell_orientation) const final override
  {
    compute_physical_coordinates(x, num_points, X, coordinate_dofs);
    compute_jacobians(J, num_points, X, coordinate_dofs);
    compute_jacobian_determinants(detJ, num_points, J, cell_orientation);
    compute_jacobian_inverses(K, num_points, J, detJ);
  }

  void compute_midpoint_geometry(
      double * x, double * J,
      const double * coordinate_dofs) const final override
  {
    const double phi_Xm[3] = { 0.3333333333333333, 0.3333333333333333, 0.3333333333333333 };
    const double dphi_Xm[2][3] =
        { { -1.0, 1.0, 0.0 },
          { -1.0, 0.0, 1.0 } };
    // Compute x
    for (std::size_t i = 0; i < 2; ++i)
        for (std::size_t d = 0; d < 3; ++d)
            x[i] += coordinate_dofs[2 * d + i] * phi_Xm[d];
    // Compute J
    for (std::size_t i = 0; i < 2; ++i)
        for (std::size_t j = 0; j < 2; ++j)
            for (std::size_t d = 0; d < 3; ++d)
                J[2 * i + j] += coordinate_dofs[2 * d + i] * dphi_Xm[j][d];
  }

};


class forms_cell_integral_0_otherwise: public ufc::cell_integral
{
public:

  forms_cell_integral_0_otherwise() : ufc::cell_integral()
  {

  }

  ~forms_cell_integral_0_otherwise() override
  {

  }

  const std::vector<bool> & enabled_coefficients() const final override
  {
static const std::vector<bool> enabled({});
return enabled;
  }

  void tabulate_tensor(double * A,
                       const double * const * w,
                       const double * coordinate_dofs,
                       int cell_orientation) const final override
  {
    // This function was generated using 'uflacs' representation
    // with the following integrals metadata:
    // 
    // num_cells:         None
    // optimize:          True
    // precision:         16
    // quadrature_degree: 4
    // quadrature_rule:   'default'
    // representation:    'uflacs'
    // 
    // and the following integral 0 metadata:
    // 
    // estimated_polynomial_degree: 4
    // optimize:                    True
    // precision:                   16
    // quadrature_degree:           4
    // quadrature_rule:             'default'
    // representation:              'uflacs'
    // Precomputed values of basis functions and precomputations
    // FE* dimensions: [entities][points][dofs]
    // PI* dimensions: [entities][dofs][dofs] or [entities][dofs]
    // PM* dimensions: [entities][dofs][dofs]
    alignas(32) static const double FE3_C0_D01_Q6[1][1][2] = { { { -1.0, 1.0 } } };
    // Unstructured piecewise computations
    const double J_c3 = coordinate_dofs[1] * FE3_C0_D01_Q6[0][0][0] + coordinate_dofs[5] * FE3_C0_D01_Q6[0][0][1];
    const double J_c0 = coordinate_dofs[0] * FE3_C0_D01_Q6[0][0][0] + coordinate_dofs[2] * FE3_C0_D01_Q6[0][0][1];
    const double J_c1 = coordinate_dofs[0] * FE3_C0_D01_Q6[0][0][0] + coordinate_dofs[4] * FE3_C0_D01_Q6[0][0][1];
    const double J_c2 = coordinate_dofs[1] * FE3_C0_D01_Q6[0][0][0] + coordinate_dofs[3] * FE3_C0_D01_Q6[0][0][1];
    alignas(32) double sp[36];
    sp[0] = J_c0 * J_c3;
    sp[1] = J_c1 * J_c2;
    sp[2] = sp[0] + -1 * sp[1];
    sp[3] = J_c3 / sp[2];
    sp[4] = -1 * J_c2 / sp[2];
    sp[5] = J_c0 / sp[2];
    sp[6] = sp[5] * sp[3];
    sp[7] = sp[5] * sp[4];
    sp[8] = -1 * J_c1 / sp[2];
    sp[9] = sp[3] * sp[8];
    sp[10] = sp[8] * sp[4];
    sp[11] = -1 * sp[10] + sp[6];
    sp[12] = -1 * sp[7] + sp[7];
    sp[13] = -1 * sp[9] + sp[9];
    sp[14] = -1 * sp[6] + sp[10];
    sp[15] = sp[11] * sp[11];
    sp[16] = sp[11] * sp[12];
    sp[17] = sp[11] * sp[13];
    sp[18] = sp[11] * sp[14];
    sp[19] = sp[12] * sp[12];
    sp[20] = sp[13] * sp[12];
    sp[21] = sp[12] * sp[14];
    sp[22] = sp[13] * sp[13];
    sp[23] = sp[13] * sp[14];
    sp[24] = sp[14] * sp[14];
    sp[25] = std::abs(sp[2]);
    sp[26] = sp[15] * sp[25];
    sp[27] = sp[16] * sp[25];
    sp[28] = sp[17] * sp[25];
    sp[29] = sp[18] * sp[25];
    sp[30] = sp[19] * sp[25];
    sp[31] = sp[20] * sp[25];
    sp[32] = sp[21] * sp[25];
    sp[33] = sp[22] * sp[25];
    sp[34] = sp[23] * sp[25];
    sp[35] = sp[24] * sp[25];
    A[0] = 2.633333333333337 * sp[33] + 0.3583333333333402 * sp[34] + -0.6083333333333366 * sp[28] + -0.6083333333333287 * sp[31] + 0.3583333333333402 * sp[34] + 0.8583333333333493 * sp[35] + -1.875000000000024 * sp[29] + -0.6083333333333399 * sp[32] + -0.6083333333333366 * sp[28] + -1.875000000000024 * sp[29] + 6.191666666666706 * sp[26] + 1.691666666666668 * sp[27] + -0.6083333333333287 * sp[31] + -0.6083333333333399 * sp[32] + 1.691666666666668 * sp[27] + 0.6333333333333311 * sp[30];
    A[1] = -2.016666666666664 * sp[33] + 1.116666666666659 * sp[34] + -0.6166666666666653 * sp[28] + -0.6166666666666822 * sp[31] + 0.283333333333335 * sp[34] + -0.8000000000000113 * sp[35] + sp[29] + -0.6166666666666818 * sp[32] + 0.2166666666666669 * sp[28] + 1.666666666666685 * sp[29] + -3.466666666666695 * sp[26] + 2.783333333333358 * sp[27] + 0.21666666666666 * sp[31] + 0.2166666666666749 * sp[32] + -0.7166666666666701 * sp[27] + 0.8166666666666667 * sp[30];
    A[2] = -0.03333333333332766 * sp[33] + -0.8916666666666592 * sp[34] + -0.1916666666666671 * sp[28] + -0.191666666666662 * sp[31] + 0.441666666666672 * sp[34] + 1.275000000000012 * sp[35] + -0.7916666666666772 * sp[29] + -0.1916666666666619 * sp[32] + -0.1916666666666677 * sp[28] + -0.7916666666666728 * sp[29] + 1.275000000000011 * sp[26] + -0.8916666666666777 * sp[27] + -0.1916666666666696 * sp[31] + -0.1916666666666728 * sp[32] + 0.4416666666666689 * sp[27] + -0.03333333333333222 * sp[30];
    A[3] = -1.591666666666673 * sp[33] + -0.6500000000000064 * sp[34] + -2.283333333333345 * sp[28] + -0.6500000000000122 * sp[31] + -0.9416666666666786 * sp[34] + -1.29583333333335 * sp[35] + -0.1125000000000057 * sp[29] + -0.4666666666666764 * sp[32] + 0.6916666666666695 * sp[28] + 1.520833333333349 * sp[29] + -1.095833333333332 * sp[26] + -0.2666666666666581 * sp[27] + 0.691666666666667 * sp[31] + 0.6916666666666711 * sp[32] + 0.6916666666666694 * sp[27] + 0.50833333333334 * sp[30];
    A[4] = -0.0666666666666581 * sp[33] + -0.5333333333333246 * sp[34] + -0.09999999999999065 * sp[28] + -0.5333333333333253 * sp[31] + 0.8833333333333449 * sp[34] + 1.675000000000017 * sp[35] + 0.1416666666666708 * sp[29] + 0.933333333333333 * sp[32] + -0.383333333333337 * sp[28] + -0.9583333333333421 * sp[29] + 0.4416666666666644 * sp[26] + -0.1333333333333292 * sp[27] + -0.3833333333333393 * sp[31] + -0.3833333333333402 * sp[32] + -0.3833333333333403 * sp[27] + -0.6000000000000064 * sp[30];
    A[5] = -1.008333333333332 * sp[33] + 1.183333333333327 * sp[34] + -2.116666666666667 * sp[28] + 1.183333333333326 * sp[31] + 0.1416666666666676 * sp[34] + -0.8375000000000088 * sp[35] + 0.5125000000000058 * sp[29] + -0.4666666666666696 * sp[32] + 0.1083333333333334 * sp[28] + 1.145833333333344 * sp[29] + -0.6375000000000102 * sp[26] + 0.4000000000000128 * sp[27] + 0.1083333333333299 * sp[31] + 0.1083333333333401 * sp[32] + 0.1083333333333257 * sp[27] + 0.09166666666667787 * sp[30];
    A[6] = -1.091666666666673 * sp[33] + -1.108333333333343 * sp[34] + -1.108333333333336 * sp[28] + -1.108333333333336 * sp[31] + -0.7333333333333457 * sp[34] + -0.362499999999996 * sp[35] + -1.479166666666685 * sp[29] + -1.108333333333343 * sp[32] + 2.133333333333352 * sp[28] + 1.154166666666658 * sp[29] + 3.170833333333351 * sp[26] + 2.191666666666671 * sp[27] + 1.150000000000003 * sp[31] + 1.116666666666665 * sp[32] + 1.150000000000001 * sp[27] + 1.008333333333332 * sp[30];
    A[7] = 2.600000000000015 * sp[33] + 1.216666666666671 * sp[34] + 1.216666666666671 * sp[28] + 1.216666666666665 * sp[31] + 1.466666666666688 * sp[34] + 0.3083333333333402 * sp[35] + 2.37500000000003 * sp[29] + 1.21666666666668 * sp[32] + -4.933333333333367 * sp[28] + -1.058333333333332 * sp[29] + -7.25833333333338 * sp[26] + -3.383333333333339 * sp[27] + -2.133333333333334 * sp[31] + -0.899999999999999 * sp[32] + -2.133333333333334 * sp[27] + -1.266666666666663 * sp[30];
    A[8] = -1.508333333333342 * sp[33] + 0.3083333333333466 * sp[34] + 0.3083333333333321 * sp[28] + 0.3083333333333459 * sp[31] + -0.7333333333333423 * sp[34] + 0.7625000000000113 * sp[35] + -1.187500000000015 * sp[29] + 0.3083333333333424 * sp[32] + 2.800000000000017 * sp[28] + -2.887500000000016 * sp[29] + 4.295833333333365 * sp[26] + -1.391666666666686 * sp[27] + 0.9833333333333307 * sp[31] + -0.7166666666666628 * sp[32] + 0.9833333333333359 * sp[27] + -0.408333333333335 * sp[30];
    A[9] = 1.649915822768633 * sp[33] + 0.4714045207910269 * sp[34] + -5.185449728701357 * sp[28] + -5.185449728701387 * sp[31] + 3.064129385141745 * sp[34] + 1.767766952966353 * sp[35] + -3.889087296526059 * sp[29] + -5.185449728701428 * sp[32] + -1.649915822768623 * sp[28] + 5.067598598503618 * sp[29] + 10.72445284799601 * sp[26] + 17.44196726926826 * sp[27] + -1.649915822768624 * sp[31] + -0.2357022603955377 * sp[32] + 4.00693842672376 * sp[27] + 5.892556509887884 * sp[30];
    A[10] = 10.9696551146029 * sp[33] + 0.7216878364869659 * sp[34] + -10.53664241271068 * sp[28] + -10.53664241271073 * sp[31] + 0.1443375672973251 * sp[34] + -1.732050807568899 * sp[35] + -8.660254037844496 * sp[29] + -10.5366424127108 * sp[32] + 0.7216878364870946 * sp[28] + 11.5470053837925 * sp[29] + 18.4752086140681 * sp[26] + 29.30052616137363 * sp[27] + 0.7216878364870842 * sp[31] + 5.05181485540921 * sp[32] + 7.649891066762531 * sp[27] + 10.96965511460287 * sp[30];
    A[11] = -6.833333333333296 * sp[33] + 1.583333333333356 * sp[34] + 0.08333333333332993 * sp[28] + 0.08333333333335347 * sp[31] + 2.416666666666688 * sp[34] + 3.75 * sp[35] + -1.250000000000026 * sp[29] + 0.08333333333337967 * sp[32] + 0.08333333333333626 * sp[28] + -4.916666666666648 * sp[29] + -5.916666666666671 * sp[26] + -10.91666666666674 * sp[27] + 0.08333333333330165 * sp[31] + 0.5833333333333746 * sp[32] + -0.9166666666666471 * sp[27] + -1.833333333333316 * sp[30];
    A[12] = 5.892556509887858 * sp[33] + -1.649915822768615 * sp[34] + 16.73486048808165 * sp[28] + 4.006938426723795 * sp[31] + -3.299831645537259 * sp[34] + -2.474873734152936 * sp[35] + 3.18198051533951 * sp[29] + 4.006938426723844 * sp[32] + 0.4714045207910408 * sp[28] + -2.003469213361904 * sp[29] + -7.660323462854283 * sp[26] + -10.13519719700728 * sp[27] + 0.4714045207910679 * sp[31] + 0.4714045207910286 * sp[32] + -5.185449728701313 * sp[27] + -4.00693842672379 * sp[30];
    A[13] = -16.88749537379661 * sp[33] + -7.361215932167767 * sp[34] + -7.361215932167767 * sp[28] + 3.897114317029962 * sp[31] + -5.19615242270669 * sp[34] + -6.27868417743729 * sp[35] + 4.979646071760497 * sp[29] + 3.897114317029931 * sp[32] + 5.196152422706653 * sp[28] + 11.90784930203618 * sp[29] + -21.86714144555715 * sp[26] + -15.15544456622761 * sp[27] + 5.196152422706613 * sp[31] + 5.19615242270666 * sp[32] + -1.732050807568863 * sp[27] + -3.897114317029907 * sp[30];
    A[14] = 10.4166666666666 * sp[33] + -2.91666666666667 * sp[34] + 10.0833333333333 * sp[28] + -1.416666666666679 * sp[31] + -5.833333333333393 * sp[34] + -4.375000000000025 * sp[35] + -2.87500000000004 * sp[29] + -1.416666666666768 * sp[32] + 0.8333333333333518 * sp[28] + -3.541666666666715 * sp[29] + 7.95833333333344 * sp[26] + 3.583333333333344 * sp[27] + 0.8333333333333967 * sp[31] + 0.8333333333333248 * sp[32] + 1.833333333333387 * sp[27] + 2.916666666666655 * sp[30];
    A[15] = -2.016666666666664 * sp[33] + 0.283333333333335 * sp[34] + 0.2166666666666669 * sp[28] + 0.21666666666666 * sp[31] + 1.116666666666659 * sp[34] + -0.8000000000000113 * sp[35] + 1.666666666666685 * sp[29] + 0.2166666666666749 * sp[32] + -0.6166666666666653 * sp[28] + sp[29] + -3.466666666666695 * sp[26] + -0.7166666666666701 * sp[27] + -0.6166666666666822 * sp[31] + -0.6166666666666818 * sp[32] + 2.783333333333358 * sp[27] + 0.8166666666666667 * sp[30];
    A[16] = 2.533333333333333 * sp[33] + -1.733333333333335 * sp[34] + 0.7333333333333353 * sp[28] + 0.7333333333333509 * sp[31] + -1.733333333333335 * sp[34] + 2.766666666666669 * sp[35] + -2.166666666666677 * sp[29] + 0.7333333333333448 * sp[32] + 0.7333333333333353 * sp[28] + -2.166666666666677 * sp[29] + 2.766666666666688 * sp[26] + -1.733333333333347 * sp[27] + 0.7333333333333509 * sp[31] + 0.7333333333333448 * sp[32] + -1.733333333333347 * sp[27] + 2.533333333333349 * sp[30];
    A[17] = 0.8166666666666665 * sp[33] + 2.78333333333334 * sp[34] + -0.6166666666666727 * sp[28] + -0.6166666666666754 * sp[31] + -0.7166666666666719 * sp[34] + -3.466666666666681 * sp[35] + sp[29] + -0.6166666666666727 * sp[32] + 0.2166666666666679 * sp[28] + 1.666666666666675 * sp[29] + -0.8000000000000108 * sp[26] + 1.116666666666672 * sp[27] + 0.2166666666666715 * sp[31] + 0.2166666666666718 * sp[32] + 0.2833333333333362 * sp[27] + -2.016666666666678 * sp[30];
    A[18] = -0.06666666666667112 * sp[33] + -0.9500000000000035 * sp[34] + 0.316666666666669 * sp[28] + -0.9499999999999953 * sp[31] + 0.4666666666666823 * sp[34] + 1.258333333333353 * sp[35] + -0.1083333333333291 * sp[29] + 0.6833333333333438 * sp[32] + 0.03333333333332877 * sp[28] + -0.7083333333333459 * sp[29] + 0.858333333333331 * sp[26] + 0.1166666666666591 * sp[27] + 0.03333333333333394 * sp[31] + 0.03333333333333871 * sp[32] + 0.03333333333332605 * sp[27] + -0.1833333333333399 * sp[30];
    A[19] = 1.633333333333337 * sp[33] + 3.066666666666674 * sp[34] + 1.199999999999993 * sp[28] + 3.066666666666666 * sp[31] + -1.433333333333346 * sp[34] + -3.683333333333357 * sp[35] + -0.2833333333333329 * sp[29] + -2.53333333333333 * sp[32] + 0.4333333333333379 * sp[28] + 1.583333333333346 * sp[29] + -0.2166666666666652 * sp[26] + 0.9333333333333391 * sp[27] + 0.4333333333333431 * sp[31] + 0.4333333333333395 * sp[32] + 0.4333333333333484 * sp[27] + 1.200000000000024 * sp[30];
    A[20] = 1.266666666666667 * sp[33] + -2.11666666666667 * sp[34] + 2.483333333333337 * sp[28] + -2.11666666666667 * sp[31] + -0.8666666666666678 * sp[34] + 3.008333333333337 * sp[35] + -2.025000000000009 * sp[29] + 1.84999999999999 * sp[32] + 0.3666666666666678 * sp[28] + -1.958333333333341 * sp[29] + 1.27500000000001 * sp[26] + -1.050000000000007 * sp[27] + 0.3666666666666754 * sp[31] + 0.3666666666666703 * sp[32] + 0.3666666666666761 * sp[27] + -1.016666666666666 * sp[30];
    A[21] = 0.1833333333333381 * sp[33] + -0.03333333333332197 * sp[34] + -0.03333333333333802 * sp[28] + -0.03333333333333549 * sp[31] + -0.1166666666666571 * sp[34] + -0.858333333333349 * sp[35] + 0.7083333333333554 * sp[29] + -0.033333333333327 * sp[32] + -0.6833333333333466 * sp[28] + 0.1083333333333369 * sp[29] + -1.258333333333348 * sp[26] + -0.4666666666666713 * sp[27] + 0.9500000000000035 * sp[31] + -0.3166666666666877 * sp[32] + 0.9500000000000105 * sp[27] + 0.06666666666666252 * sp[30];
    A[22] = -1.200000000000008 * sp[33] + -0.4333333333333363 * sp[34] + -0.4333333333333325 * sp[28] + -0.433333333333329 * sp[31] + -0.9333333333333453 * sp[34] + 0.2166666666666629 * sp[35] + -1.58333333333336 * sp[29] + -0.4333333333333471 * sp[32] + 2.533333333333359 * sp[28] + 0.2833333333333328 * sp[29] + 3.683333333333367 * sp[26] + 1.433333333333341 * sp[27] + -3.066666666666689 * sp[31] + -1.199999999999991 * sp[32] + -3.066666666666698 * sp[27] + -1.633333333333334 * sp[30];
    A[23] = 1.016666666666669 * sp[33] + -0.3666666666666838 * sp[34] + -0.3666666666666683 * sp[28] + -0.3666666666666808 * sp[31] + 1.050000000000002 * sp[34] + -1.275000000000013 * sp[35] + 1.958333333333345 * sp[29] + -0.3666666666666727 * sp[32] + -1.850000000000012 * sp[28] + 2.025000000000012 * sp[29] + -3.008333333333358 * sp[26] + 0.8666666666666769 * sp[27] + 2.116666666666684 * sp[31] + -2.483333333333346 * sp[32] + 2.116666666666685 * sp[27] + -1.266666666666679 * sp[30];
    A[24] = 3.771236166328266 * sp[33] + 6.128258770283447 * sp[34] + 3.299831645537224 * sp[28] + 3.299831645537258 * sp[31] + -3.771236166328299 * sp[34] + 1.1785113019776 * sp[35] + -1.649915822768566 * sp[29] + 3.299831645537295 * sp[32] + 0.9428090415820787 * sp[28] + -5.421151989096865 * sp[29] + -2.592724864350703 * sp[26] + -8.956685895029661 * sp[27] + 0.9428090415820845 * sp[31] + 12.25651754056688 * sp[32] + 3.7712361663283 * sp[27] + 11.78511301977584 * sp[30];
    A[25] = -8.94892917243917 * sp[33] + -1.443375672973958 * sp[34] + 3.75277674973255 * sp[28] + 3.752776749732613 * sp[31] + -3.175426480542795 * sp[34] + 2.020725942163689 * sp[35] + -1.443375672973936 * sp[29] + 3.752776749732678 * sp[32] + 1.443375672974017 * sp[28] + -7.21687836487032 * sp[29] + -3.752776749732634 * sp[26] + -12.41303078757705 * sp[27] + 1.443375672973939 * sp[31] + 10.10362971081835 * sp[32] + 4.907477288111886 * sp[27] + 14.14508159514587 * sp[30];
    A[26] = 11.16666666666665 * sp[33] + 1.833333333333331 * sp[34] + -5.16666666666671 * sp[28] + -5.166666666666719 * sp[31] + -8.166666666666682 * sp[34] + -16.66666666666669 * sp[35] + 3.333333333333397 * sp[29] + -5.166666666666727 * sp[32] + 3.166666666666671 * sp[28] + 10.66666666666667 * sp[29] + 2.666666666666657 * sp[26] + 10.16666666666671 * sp[27] + 3.166666666666742 * sp[31] + -7.833333333333408 * sp[32] + -4.833333333333375 * sp[27] + -17.16666666666676 * sp[30];
    A[27] = -11.78511301977579 * sp[33] + -3.771236166328271 * sp[34] + -12.25651754056681 * sp[28] + -0.9428090415820558 * sp[31] + 8.956685895029638 * sp[34] + 2.592724864350739 * sp[35] + 5.421151989096817 * sp[29] + -0.9428090415821058 * sp[32] + -3.299831645537237 * sp[28] + 1.649915822768597 * sp[29] + -1.178511301977565 * sp[26] + 3.771236166328298 * sp[27] + -3.299831645537299 * sp[31] + -3.299831645537268 * sp[32] + -6.128258770283502 * sp[27] + -3.771236166328302 * sp[30];
    A[28] = 7.794228634059974 * sp[33] + 1.732050807568876 * sp[34] + 1.732050807568884 * sp[28] + -3.464101615137769 * sp[31] + -2.598076211353272 * sp[34] + -0.4330127018921157 * sp[35] + -5.629165124598753 * sp[29] + -3.464101615137683 * sp[32] + 2.598076211353312 * sp[28] + -2.165063509461183 * sp[29] + 13.42339375865885 * sp[26] + 8.66025403784437 * sp[27] + 2.598076211353392 * sp[31] + 2.598076211353411 * sp[32] + -0.8660254037845683 * sp[27] + -5.196152422706634 * sp[30];
    A[29] = -20.83333333333333 * sp[33] + -6.666666666666693 * sp[34] + -12.66666666666664 * sp[28] + 0.333333333333372 * sp[31] + 15.83333333333339 * sp[34] + 4.583333333333429 * sp[35] + 11.58333333333335 * sp[29] + 0.3333333333335551 * sp[32] + -5.833333333333361 * sp[28] + 2.916666666666656 * sp[29] + -10.08333333333342 * sp[26] + -1.333333333333369 * sp[27] + -5.833333333333465 * sp[31] + -5.833333333333423 * sp[32] + 2.166666666666629 * sp[27] + 13.33333333333325 * sp[30];
    A[30] = -0.03333333333332766 * sp[33] + 0.441666666666672 * sp[34] + -0.1916666666666677 * sp[28] + -0.1916666666666696 * sp[31] + -0.8916666666666592 * sp[34] + 1.275000000000012 * sp[35] + -0.7916666666666728 * sp[29] + -0.1916666666666728 * sp[32] + -0.1916666666666671 * sp[28] + -0.7916666666666772 * sp[29] + 1.275000000000011 * sp[26] + 0.4416666666666689 * sp[27] + -0.191666666666662 * sp[31] + -0.1916666666666619 * sp[32] + -0.8916666666666777 * sp[27] + -0.03333333333333222 * sp[30];
    A[31] = 0.8166666666666665 * sp[33] + -0.7166666666666719 * sp[34] + 0.2166666666666679 * sp[28] + 0.2166666666666715 * sp[31] + 2.78333333333334 * sp[34] + -3.466666666666681 * sp[35] + 1.666666666666675 * sp[29] + 0.2166666666666718 * sp[32] + -0.6166666666666727 * sp[28] + sp[29] + -0.8000000000000108 * sp[26] + 0.2833333333333362 * sp[27] + -0.6166666666666754 * sp[31] + -0.6166666666666727 * sp[32] + 1.116666666666672 * sp[27] + -2.016666666666678 * sp[30];
    A[32] = 0.6333333333333369 * sp[33] + 1.691666666666675 * sp[34] + -0.6083333333333384 * sp[28] + -0.6083333333333378 * sp[31] + 1.691666666666675 * sp[34] + 6.191666666666694 * sp[35] + -1.875000000000016 * sp[29] + -0.6083333333333371 * sp[32] + -0.6083333333333384 * sp[28] + -1.875000000000016 * sp[29] + 0.8583333333333414 * sp[26] + 0.3583333333333339 * sp[27] + -0.6083333333333378 * sp[31] + -0.6083333333333371 * sp[32] + 0.3583333333333339 * sp[27] + 2.633333333333346 * sp[30];
    A[33] = -1.008333333333342 * sp[33] + -1.150000000000007 * sp[34] + -1.116666666666675 * sp[28] + -1.150000000000005 * sp[31] + -2.191666666666686 * sp[34] + -3.170833333333352 * sp[35] + -1.154166666666681 * sp[29] + -2.133333333333347 * sp[32] + 1.108333333333341 * sp[28] + 1.479166666666677 * sp[29] + 0.3625000000000067 * sp[26] + 0.7333333333333416 * sp[27] + 1.108333333333337 * sp[31] + 1.108333333333333 * sp[32] + 1.108333333333341 * sp[27] + 1.091666666666671 * sp[30];
    A[34] = 1.266666666666675 * sp[33] + 2.133333333333344 * sp[34] + 0.9000000000000014 * sp[28] + 2.133333333333338 * sp[31] + 3.383333333333354 * sp[34] + 7.258333333333369 * sp[35] + 1.058333333333334 * sp[29] + 4.933333333333344 * sp[32] + -1.216666666666678 * sp[28] + -2.375000000000019 * sp[29] + -0.3083333333333375 * sp[26] + -1.466666666666677 * sp[27] + -1.216666666666676 * sp[31] + -1.216666666666672 * sp[32] + -1.216666666666676 * sp[27] + -2.600000000000015 * sp[30];
    A[35] = 0.4083333333333334 * sp[33] + -0.9833333333333389 * sp[34] + 0.7166666666666675 * sp[28] + -0.9833333333333396 * sp[31] + 1.39166666666667 * sp[34] + -4.295833333333349 * sp[35] + 2.88750000000001 * sp[29] + -2.800000000000012 * sp[32] + -0.3083333333333366 * sp[28] + 1.187500000000013 * sp[29] + -0.7625000000000085 * sp[26] + 0.7333333333333476 * sp[27] + -0.3083333333333377 * sp[31] + -0.3083333333333352 * sp[32] + -0.3083333333333378 * sp[27] + 1.508333333333338 * sp[30];
    A[36] = -0.5083333333333346 * sp[33] + -0.6916666666666652 * sp[34] + -0.6916666666666724 * sp[28] + -0.6916666666666706 * sp[31] + 0.2666666666666638 * sp[34] + 1.095833333333346 * sp[35] + -1.520833333333349 * sp[29] + -0.6916666666666709 * sp[32] + 0.4666666666666719 * sp[28] + 0.112499999999998 * sp[29] + 1.295833333333342 * sp[26] + 0.9416666666666708 * sp[27] + 0.6499999999999985 * sp[31] + 2.283333333333351 * sp[32] + 0.6499999999999971 * sp[27] + 1.591666666666676 * sp[30];
    A[37] = 0.6000000000000043 * sp[33] + 0.383333333333335 * sp[34] + 0.383333333333336 * sp[28] + 0.3833333333333366 * sp[31] + 0.1333333333333414 * sp[34] + -0.4416666666666666 * sp[35] + 0.9583333333333435 * sp[29] + 0.3833333333333399 * sp[32] + -0.9333333333333451 * sp[28] + -0.1416666666666676 * sp[29] + -1.675000000000014 * sp[26] + -0.8833333333333371 * sp[27] + 0.5333333333333415 * sp[31] + 0.09999999999999387 * sp[32] + 0.533333333333347 * sp[27] + 0.06666666666666465 * sp[30];
    A[38] = -0.09166666666666996 * sp[33] + -0.1083333333333397 * sp[34] + -0.1083333333333343 * sp[28] + -0.1083333333333371 * sp[31] + -0.4000000000000062 * sp[34] + 0.6374999999999957 * sp[35] + -1.145833333333341 * sp[29] + -0.1083333333333382 * sp[32] + 0.4666666666666736 * sp[28] + -0.5125000000000006 * sp[29] + 0.8375000000000107 * sp[26] + -0.1416666666666685 * sp[27] + -1.18333333333334 * sp[31] + 2.11666666666668 * sp[32] + -1.183333333333341 * sp[27] + 1.008333333333342 * sp[30];
    A[39] = 4.006938426723796 * sp[33] + 5.185449728701378 * sp[34] + -0.4714045207910366 * sp[28] + -0.4714045207910277 * sp[31] + 10.13519719700724 * sp[34] + 7.660323462854308 * sp[35] + 2.003469213361879 * sp[29] + -0.4714045207910389 * sp[32] + -4.006938426723802 * sp[28] + -3.181980515339485 * sp[29] + 2.474873734152923 * sp[26] + 3.299831645537242 * sp[27] + -4.006938426723792 * sp[31] + -16.73486048808169 * sp[32] + 1.64991582276859 * sp[27] + -5.892556509887926 * sp[30];
    A[40] = -0.5773502691895926 * sp[33] + -0.7216878364869903 * sp[34] + -3.319764047840375 * sp[28] + -3.319764047840356 * sp[31] + 4.474464586219603 * sp[34] + 4.041451884327454 * sp[35] + -2.886751345948191 * sp[29] + -3.319764047840369 * sp[32] + -0.7216878364870347 * sp[28] + 6.928203230275538 * sp[26] + 7.64989106676258 * sp[27] + -0.7216878364870083 * sp[31] + -5.051814855409188 * sp[32] + 6.206515393788451 * sp[27] + -0.5773502691896253 * sp[30];
    A[41] = 4.833333333333341 * sp[33] + 2.416666666666672 * sp[34] + -4.083333333333371 * sp[28] + -4.083333333333368 * sp[31] + 14.91666666666671 * sp[34] + 22.91666666666672 * sp[35] + -12.08333333333344 * sp[29] + -4.083333333333358 * sp[32] + -4.083333333333367 * sp[28] + -5.750000000000019 * sp[29] + 3.250000000000037 * sp[26] + 1.583333333333339 * sp[27] + -4.083333333333377 * sp[31] + 11.41666666666673 * sp[32] + 4.916666666666705 * sp[27] + 19.83333333333344 * sp[30];
    A[42] = -5.892556509887918 * sp[33] + -4.006938426723787 * sp[34] + 0.2357022603955474 * sp[28] + 1.649915822768635 * sp[31] + -17.44196726926824 * sp[34] + -10.72445284799604 * sp[35] + -5.067598598503547 * sp[29] + 1.649915822768648 * sp[32] + 5.185449728701396 * sp[28] + 3.889087296526026 * sp[29] + -1.767766952966375 * sp[26] + -3.064129385141746 * sp[27] + 5.1854497287014 * sp[31] + 5.185449728701377 * sp[32] + -0.4714045207910003 * sp[27] + -1.64991582276861 * sp[30];
    A[43] = -3.897114317030002 * sp[33] + -3.031088913245562 * sp[34] + -3.031088913245569 * sp[28] + -0.4330127018922387 * sp[31] + -5.196152422706641 * sp[34] + -4.113620667976137 * sp[35] + -1.515544456622865 * sp[29] + -0.4330127018922822 * sp[32] + 5.196152422706636 * sp[28] + 5.412658773652787 * sp[29] + -2.381569860407207 * sp[26] + -2.165063509461071 * sp[27] + 5.196152422706609 * sp[31] + 5.196152422706597 * sp[32] + -1.732050807568815 * sp[27] + 0.433012701892211 * sp[30];
    A[44] = -10.4166666666667 * sp[33] + -7.083333333333357 * sp[34] + -4.083333333333324 * sp[28] + -0.5833333333333142 * sp[31] + -30.83333333333344 * sp[34] + -18.95833333333342 * sp[35] + -12.45833333333335 * sp[29] + -0.5833333333333824 * sp[32] + 9.166666666666744 * sp[28] + 6.875000000000014 * sp[29] + 3.375000000000051 * sp[26] + 1.083333333333319 * sp[27] + 9.16666666666675 * sp[31] + 9.166666666666721 * sp[32] + 0.1666666666666843 * sp[27] + -12.91666666666668 * sp[30];
    A[45] = -1.591666666666673 * sp[33] + -0.9416666666666786 * sp[34] + 0.6916666666666695 * sp[28] + 0.691666666666667 * sp[31] + -0.6500000000000064 * sp[34] + -1.29583333333335 * sp[35] + 1.520833333333349 * sp[29] + 0.6916666666666711 * sp[32] + -2.283333333333345 * sp[28] + -0.1125000000000057 * sp[29] + -1.095833333333332 * sp[26] + 0.6916666666666694 * sp[27] + -0.6500000000000122 * sp[31] + -0.4666666666666764 * sp[32] + -0.2666666666666581 * sp[27] + 0.50833333333334 * sp[30];
    A[46] = -0.06666666666667112 * sp[33] + 0.4666666666666823 * sp[34] + 0.03333333333332877 * sp[28] + 0.03333333333333394 * sp[31] + -0.9500000000000035 * sp[34] + 1.258333333333353 * sp[35] + -0.7083333333333459 * sp[29] + 0.03333333333333871 * sp[32] + 0.316666666666669 * sp[28] + -0.1083333333333291 * sp[29] + 0.858333333333331 * sp[26] + 0.03333333333332605 * sp[27] + -0.9499999999999953 * sp[31] + 0.6833333333333438 * sp[32] + 0.1166666666666591 * sp[27] + -0.1833333333333399 * sp[30];
    A[47] = -1.008333333333342 * sp[33] + -2.191666666666686 * sp[34] + 1.108333333333341 * sp[28] + 1.108333333333337 * sp[31] + -1.150000000000007 * sp[34] + -3.170833333333352 * sp[35] + 1.479166666666677 * sp[29] + 1.108333333333333 * sp[32] + -1.116666666666675 * sp[28] + -1.154166666666681 * sp[29] + 0.3625000000000067 * sp[26] + 1.108333333333341 * sp[27] + -1.150000000000005 * sp[31] + -2.133333333333347 * sp[32] + 0.7333333333333416 * sp[27] + 1.091666666666671 * sp[30];
    A[48] = 2.633333333333347 * sp[33] + 2.275000000000013 * sp[34] + 3.24166666666668 * sp[28] + 2.275000000000013 * sp[31] + 2.275000000000013 * sp[34] + 2.775000000000014 * sp[35] + 1.008333333333345 * sp[29] + 1.508333333333344 * sp[32] + 3.24166666666668 * sp[28] + 1.008333333333345 * sp[29] + 10.04166666666666 * sp[26] + 5.508333333333336 * sp[27] + 2.275000000000013 * sp[31] + 1.508333333333344 * sp[32] + 5.508333333333336 * sp[27] + 3.683333333333335 * sp[30];
    A[49] = -2.016666666666683 * sp[33] + -3.133333333333357 * sp[34] + -1.400000000000006 * sp[28] + -3.133333333333344 * sp[31] + -2.300000000000015 * sp[34] + -4.216666666666689 * sp[35] + -0.683333333333337 * sp[29] + -2.600000000000007 * sp[32] + -2.233333333333349 * sp[28] + -1.683333333333353 * sp[29] + -5.083333333333328 * sp[26] + -7.933333333333334 * sp[27] + -2.300000000000011 * sp[31] + -2.766666666666684 * sp[32] + -3.433333333333327 * sp[27] + -5.866666666666665 * sp[30];
    A[50] = -0.03333333333333606 * sp[33] + 0.8583333333333483 * sp[34] + 0.1583333333333282 * sp[28] + 0.8583333333333504 * sp[31] + -0.475000000000002 * sp[34] + 1.691666666666684 * sp[35] + -1.075000000000006 * sp[29] + 1.091666666666684 * sp[32] + 0.1583333333333335 * sp[28] + 0.2583333333333393 * sp[29] + 1.624999999999998 * sp[26] + 2.425000000000002 * sp[27] + -0.4749999999999984 * sp[31] + 1.091666666666677 * sp[32] + -0.2416666666666673 * sp[27] + 2.18333333333334 * sp[30];
    A[51] = 1.508333333333336 * sp[33] + 1.816666666666666 * sp[34] + 1.816666666666675 * sp[28] + 1.816666666666671 * sp[31] + 0.7750000000000069 * sp[34] + 0.3208333333333285 * sp[35] + 2.270833333333347 * sp[29] + 1.816666666666673 * sp[32] + 4.308333333333326 * sp[28] + 7.504166666666658 * sp[29] + 0.3208333333333435 * sp[26] + 1.816666666666674 * sp[27] + 2.591666666666663 * sp[31] + 4.308333333333323 * sp[32] + 0.7750000000000116 * sp[27] + 1.508333333333339 * sp[30];
    A[52] = -2.600000000000009 * sp[33] + -1.383333333333335 * sp[34] + -1.383333333333338 * sp[28] + -1.383333333333335 * sp[31] + -1.133333333333352 * sp[34] + -0.2250000000000038 * sp[35] + -2.291666666666686 * sp[29] + -1.383333333333341 * sp[32] + -7.533333333333331 * sp[28] + -5.258333333333326 * sp[29] + 0.9416666666666623 * sp[26] + -1.383333333333338 * sp[27] + -3.93333333333334 * sp[31] + -2.866666666666664 * sp[32] + 0.03333333333332122 * sp[27] + -1.016666666666675 * sp[30];
    A[53] = 1.091666666666674 * sp[33] + -0.01666666666666433 * sp[34] + -0.01666666666666328 * sp[28] + -0.01666666666666779 * sp[31] + 0.3583333333333456 * sp[34] + -0.3875000000000002 * sp[35] + 0.7291666666666797 * sp[29] + -0.0166666666666693 * sp[32] + 3.225000000000005 * sp[28] + 0.9625000000000028 * sp[29] + -1.054166666666664 * sp[26] + -0.01666666666666251 * sp[27] + 1.341666666666677 * sp[31] + 0.5583333333333398 * sp[32] + -0.3083333333333252 * sp[27] + 0.09166666666667259 * sp[30];
    A[54] = -7.542472332656555 * sp[33] + -8.720983634634123 * sp[34] + 4.006938426723771 * sp[28] + 4.006938426723774 * sp[31] + -7.778174593052069 * sp[34] + -8.249579113843067 * sp[35] + 4.478342947514819 * sp[29] + 4.006938426723807 * sp[32] + -8.720983634634122 * sp[28] + -12.96362432175341 * sp[29] + -0.2357022603955037 * sp[26] + 4.006938426723756 * sp[27] + -7.778174593052054 * sp[31] + -11.07800623858926 * sp[32] + 0.2357022603955325 * sp[27] + 2.357022603955161 * sp[30];
    A[55] = -5.917840259193714 * sp[33] + 0.7216878364869981 * sp[34] + 11.98001808568476 * sp[28] + 11.98001808568476 * sp[31] + -0.866025403784461 * sp[34] + -2.237232293109831 * sp[35] + 13.35122497501015 * sp[29] + 11.9800180856848 * sp[32] + -11.83568051838743 * sp[28] + 18.25870226312184 * sp[29] + 2.670244995002061 * sp[26] + 11.98001808568474 * sp[27] + -0.8660254037845454 * sp[31] + 10.96965511460279 * sp[32] + 4.041451884327429 * sp[27] + 8.804591605141809 * sp[30];
    A[56] = -3.58333333333338 * sp[33] + -4.916666666666693 * sp[34] + 6.583333333333394 * sp[28] + 6.58333333333337 * sp[31] + -7.00000000000003 * sp[34] + -7.708333333333353 * sp[35] + 7.291666666666718 * sp[29] + 6.583333333333331 * sp[32] + -2.666666666666694 * sp[28] + 4.45833333333327 * sp[29] + 5.458333333333393 * sp[26] + 6.583333333333402 * sp[27] + -7.000000000000001 * sp[31] + 2.16666666666661 * sp[32] + 6.166666666666715 * sp[27] + 6.916666666666698 * sp[30];
    A[57] = 5.892556509887958 * sp[33] + 7.542472332656531 * sp[34] + -10.84230397819376 * sp[28] + -5.185449728701392 * sp[31] + 9.192388155425171 * sp[34] + 8.367430244040824 * sp[35] + -4.360491817317086 * sp[29] + -5.185449728701421 * sp[32] + 5.421151989096901 * sp[28] + 5.067598598503629 * sp[29] + -18.97403196183906 * sp[26] + -5.185449728701348 * sp[27] + 9.192388155425133 * sp[31] + 5.892556509887911 * sp[32] + -6.835365551470018 * sp[27] + -4.006938426723801 * sp[30];
    A[58] = 16.8874953737966 * sp[33] + 9.526279441628873 * sp[34] + 9.526279441628873 * sp[28] + -1.732050807568834 * sp[31] + 11.69134295108995 * sp[34] + 10.60881119635945 * sp[35] + -0.6495190528383041 * sp[29] + -1.732050807568833 * sp[32] + 22.08364779650325 * sp[28] + 2.814582562299458 * sp[29] + 36.58957330989252 * sp[26] + -1.732050807568889 * sp[27] + 11.69134295108997 * sp[31] + 3.897114317030015 * sp[32] + 19.48557158514986 * sp[27] + 0.433012701892217 * sp[30];
    A[59] = 10.41666666666677 * sp[33] + 13.33333333333336 * sp[34] + 0.3333333333333561 * sp[28] + 1.833333333333298 * sp[31] + 16.25000000000008 * sp[34] + 14.79166666666667 * sp[35] + 3.291666666666704 * sp[29] + 1.833333333333319 * sp[32] + 9.583333333333396 * sp[28] + 8.958333333333405 * sp[29] + 7.458333333333298 * sp[26] + 1.833333333333304 * sp[27] + 16.25000000000002 * sp[31] + 10.41666666666669 * sp[32] + 9.416666666666636 * sp[27] + 2.916666666666619 * sp[30];
    A[60] = -0.0666666666666581 * sp[33] + 0.8833333333333449 * sp[34] + -0.383333333333337 * sp[28] + -0.3833333333333393 * sp[31] + -0.5333333333333246 * sp[34] + 1.675000000000017 * sp[35] + -0.9583333333333421 * sp[29] + -0.3833333333333402 * sp[32] + -0.09999999999999065 * sp[28] + 0.1416666666666708 * sp[29] + 0.4416666666666644 * sp[26] + -0.3833333333333403 * sp[27] + -0.5333333333333253 * sp[31] + 0.933333333333333 * sp[32] + -0.1333333333333292 * sp[27] + -0.6000000000000064 * sp[30];
    A[61] = 1.633333333333337 * sp[33] + -1.433333333333346 * sp[34] + 0.4333333333333379 * sp[28] + 0.4333333333333431 * sp[31] + 3.066666666666674 * sp[34] + -3.683333333333357 * sp[35] + 1.583333333333346 * sp[29] + 0.4333333333333395 * sp[32] + 1.199999999999993 * sp[28] + -0.2833333333333329 * sp[29] + -0.2166666666666652 * sp[26] + 0.4333333333333484 * sp[27] + 3.066666666666666 * sp[31] + -2.53333333333333 * sp[32] + 0.9333333333333391 * sp[27] + 1.200000000000024 * sp[30];
    A[62] = 1.266666666666675 * sp[33] + 3.383333333333354 * sp[34] + -1.216666666666678 * sp[28] + -1.216666666666676 * sp[31] + 2.133333333333344 * sp[34] + 7.258333333333369 * sp[35] + -2.375000000000019 * sp[29] + -1.216666666666672 * sp[32] + 0.9000000000000014 * sp[28] + 1.058333333333334 * sp[29] + -0.3083333333333375 * sp[26] + -1.216666666666676 * sp[27] + 2.133333333333338 * sp[31] + 4.933333333333344 * sp[32] + -1.466666666666677 * sp[27] + -2.600000000000015 * sp[30];
    A[63] = -2.016666666666683 * sp[33] + -2.300000000000015 * sp[34] + -2.233333333333349 * sp[28] + -2.300000000000011 * sp[31] + -3.133333333333357 * sp[34] + -4.216666666666689 * sp[35] + -1.683333333333353 * sp[29] + -2.766666666666684 * sp[32] + -1.400000000000006 * sp[28] + -0.683333333333337 * sp[29] + -5.083333333333328 * sp[26] + -3.433333333333327 * sp[27] + -3.133333333333344 * sp[31] + -2.600000000000007 * sp[32] + -7.933333333333334 * sp[27] + -5.866666666666665 * sp[30];
    A[64] = 2.533333333333351 * sp[33] + 4.266666666666693 * sp[34] + 1.800000000000004 * sp[28] + 4.26666666666668 * sp[31] + 4.266666666666693 * sp[34] + 8.766666666666712 * sp[35] + 1.366666666666669 * sp[29] + 5.866666666666684 * sp[32] + 1.800000000000004 * sp[28] + 1.366666666666669 * sp[29] + 3.833333333333324 * sp[26] + 5.866666666666656 * sp[27] + 4.26666666666668 * sp[31] + 5.866666666666684 * sp[32] + 5.866666666666656 * sp[27] + 11.73333333333333 * sp[30];
    A[65] = 0.8166666666666685 * sp[33] + -1.966666666666681 * sp[34] + 1.433333333333339 * sp[28] + -1.966666666666683 * sp[31] + 1.533333333333338 * sp[34] + -4.716666666666692 * sp[35] + 3.150000000000013 * sp[29] + -3.100000000000023 * sp[32] + 0.5999999999999972 * sp[28] + -0.5166666666666662 * sp[29] + 0.416666666666665 * sp[26] + -2.433333333333332 * sp[27] + 1.533333333333334 * sp[31] + -3.266666666666667 * sp[32] + 2.066666666666674 * sp[27] + -5.866666666666667 * sp[30];
    A[66] = -1.016666666666669 * sp[33] + -1.383333333333331 * sp[34] + -1.383333333333346 * sp[28] + -1.383333333333342 * sp[31] + 0.03333333333333038 * sp[34] + 0.9416666666666805 * sp[35] + -2.291666666666685 * sp[29] + -1.383333333333339 * sp[32] + -2.86666666666666 * sp[28] + -5.258333333333321 * sp[29] + -0.2250000000000064 * sp[26] + -1.383333333333338 * sp[27] + -3.933333333333321 * sp[31] + -7.533333333333321 * sp[32] + -1.13333333333334 * sp[27] + -2.600000000000006 * sp[30];
    A[67] = 1.200000000000008 * sp[33] + 0.7666666666666695 * sp[34] + 0.7666666666666735 * sp[28] + 0.7666666666666733 * sp[31] + 0.2666666666666798 * sp[34] + -0.3833333333333329 * sp[35] + 1.416666666666679 * sp[29] + 0.766666666666674 * sp[32] + 3.733333333333327 * sp[28] + 3.016666666666663 * sp[29] + -0.3833333333333287 * sp[26] + 0.7666666666666733 * sp[27] + 5.866666666666655 * sp[31] + 3.733333333333325 * sp[32] + 0.2666666666666636 * sp[27] + 1.200000000000004 * sp[30];
    A[68] = -0.1833333333333394 * sp[33] + -0.2166666666666788 * sp[34] + -0.2166666666666705 * sp[28] + -0.2166666666666743 * sp[31] + -0.3000000000000112 * sp[34] + 0.5249999999999934 * sp[35] + -1.041666666666677 * sp[29] + -0.2166666666666724 * sp[32] + -0.8666666666666669 * sp[28] + -1.008333333333349 * sp[29] + 0.358333333333331 * sp[26] + -0.2166666666666785 * sp[27] + -1.933333333333333 * sp[31] + -1.533333333333354 * sp[32] + -0.4666666666666702 * sp[27] + -0.6000000000000169 * sp[30];
    A[69] = 8.013876853447595 * sp[33] + 10.37089945740276 * sp[34] + -0.9428090415820713 * sp[28] + -0.9428090415820554 * sp[31] + 13.19932658214897 * sp[34] + 11.78511301977585 * sp[35] + 0.47140452079103 * sp[29] + -0.9428090415820711 * sp[32] + 5.65685424949239 * sp[28] + 11.78511301977582 * sp[29] + 0.4714045207910189 * sp[26] + -0.9428090415820363 * sp[27] + 13.19932658214892 * sp[31] + 24.51303508113372 * sp[32] + 1.885618083164149 * sp[27];
    A[70] = -1.154700538379196 * sp[33] + -1.443375672973986 * sp[34] + -6.639528095680748 * sp[28] + -6.639528095680713 * sp[31] + 4.618802153517053 * sp[34] + 5.91784025919376 * sp[35] + -7.938566201357419 * sp[29] + -6.639528095680722 * sp[32] + -5.196152422706566 * sp[28] + -14.86676943163275 * sp[29] + -1.010362971081878 * sp[26] + -6.639528095680672 * sp[27] + 4.618802153517082 * sp[31] + -16.16580753730938 * sp[32] + -2.309401076758501 * sp[27] + -10.3923048454132 * sp[30];
    A[71] = 9.666666666666698 * sp[33] + 4.83333333333335 * sp[34] + -8.166666666666746 * sp[28] + -8.166666666666735 * sp[31] + 17.33333333333339 * sp[34] + 24.58333333333341 * sp[35] + -15.4166666666668 * sp[29] + -8.166666666666705 * sp[32] + 6.99999999999998 * sp[28] + -11.41666666666667 * sp[29] + -3.416666666666697 * sp[26] + -8.16666666666673 * sp[27] + 17.33333333333334 * sp[31] + -2.666666666666658 * sp[32] + -10.66666666666677 * sp[27] + -18.00000000000013 * sp[30];
    A[72] = -11.78511301977585 * sp[33] + -8.013876853447577 * sp[34] + 0.4714045207910789 * sp[28] + 3.29983164553727 * sp[31] + -20.74179891480549 * sp[34] + -14.37783788412654 * sp[35] + -3.064129385141652 * sp[29] + 3.29983164553728 * sp[32] + -8.485281374238557 * sp[28] + -3.064129385141707 * sp[29] + 2.592724864350706 * sp[26] + 3.299831645537237 * sp[27] + -20.74179891480542 * sp[31] + -9.428090415820691 * sp[32] + 1.885618083164136 * sp[27] + 5.656854249492365 * sp[30];
    A[73] = -7.794228634059991 * sp[33] + -6.062177826491124 * sp[34] + -6.062177826491125 * sp[28] + -0.866025403784477 * sp[31] + -10.39230484541328 * sp[34] + -8.227241335952233 * sp[35] + -3.031088913245635 * sp[29] + -0.8660254037845074 * sp[32] + -5.196152422706656 * sp[28] + -1.29903810567668 * sp[29] + -16.88749537379652 * sp[26] + -0.8660254037844425 * sp[27] + -10.39230484541324 * sp[31] + -3.464101615137741 * sp[32] + -17.32050807568881 * sp[27] + 3.464101615137742 * sp[30];
    A[74] = -20.83333333333343 * sp[33] + -14.16666666666672 * sp[34] + -8.166666666666671 * sp[28] + -1.166666666666627 * sp[31] + -36.66666666666681 * sp[34] + -25.41666666666675 * sp[35] + -12.41666666666669 * sp[29] + -1.166666666666674 * sp[32] + -14.99999999999997 * sp[28] + -5.416666666666677 * sp[29] + -12.41666666666661 * sp[26] + -1.166666666666615 * sp[27] + -36.66666666666671 * sp[31] + -16.66666666666676 * sp[32] + -24.66666666666663 * sp[27] + 10.00000000000003 * sp[30];
    A[75] = -1.008333333333332 * sp[33] + 0.1416666666666676 * sp[34] + 0.1083333333333334 * sp[28] + 0.1083333333333299 * sp[31] + 1.183333333333327 * sp[34] + -0.8375000000000088 * sp[35] + 1.145833333333344 * sp[29] + 0.1083333333333401 * sp[32] + -2.116666666666667 * sp[28] + 0.5125000000000058 * sp[29] + -0.6375000000000102 * sp[26] + 0.1083333333333257 * sp[27] + 1.183333333333326 * sp[31] + -0.4666666666666696 * sp[32] + 0.4000000000000128 * sp[27] + 0.09166666666667787 * sp[30];
    A[76] = 1.266666666666667 * sp[33] + -0.8666666666666678 * sp[34] + 0.3666666666666678 * sp[28] + 0.3666666666666754 * sp[31] + -2.11666666666667 * sp[34] + 3.008333333333337 * sp[35] + -1.958333333333341 * sp[29] + 0.3666666666666703 * sp[32] + 2.483333333333337 * sp[28] + -2.025000000000009 * sp[29] + 1.27500000000001 * sp[26] + 0.3666666666666761 * sp[27] + -2.11666666666667 * sp[31] + 1.84999999999999 * sp[32] + -1.050000000000007 * sp[27] + -1.016666666666666 * sp[30];
    A[77] = 0.4083333333333334 * sp[33] + 1.39166666666667 * sp[34] + -0.3083333333333366 * sp[28] + -0.3083333333333377 * sp[31] + -0.9833333333333389 * sp[34] + -4.295833333333349 * sp[35] + 1.187500000000013 * sp[29] + -0.3083333333333352 * sp[32] + 0.7166666666666675 * sp[28] + 2.88750000000001 * sp[29] + -0.7625000000000085 * sp[26] + -0.3083333333333378 * sp[27] + -0.9833333333333396 * sp[31] + -2.800000000000012 * sp[32] + 0.7333333333333476 * sp[27] + 1.508333333333338 * sp[30];
    A[78] = -0.03333333333333606 * sp[33] + -0.475000000000002 * sp[34] + 0.1583333333333335 * sp[28] + -0.4749999999999984 * sp[31] + 0.8583333333333483 * sp[34] + 1.691666666666684 * sp[35] + 0.2583333333333393 * sp[29] + 1.091666666666677 * sp[32] + 0.1583333333333282 * sp[28] + -1.075000000000006 * sp[29] + 1.624999999999998 * sp[26] + -0.2416666666666673 * sp[27] + 0.8583333333333504 * sp[31] + 1.091666666666684 * sp[32] + 2.425000000000002 * sp[27] + 2.18333333333334 * sp[30];
    A[79] = 0.8166666666666685 * sp[33] + 1.533333333333338 * sp[34] + 0.5999999999999972 * sp[28] + 1.533333333333334 * sp[31] + -1.966666666666681 * sp[34] + -4.716666666666692 * sp[35] + -0.5166666666666662 * sp[29] + -3.266666666666667 * sp[32] + 1.433333333333339 * sp[28] + 3.150000000000013 * sp[29] + 0.416666666666665 * sp[26] + 2.066666666666674 * sp[27] + -1.966666666666683 * sp[31] + -3.100000000000023 * sp[32] + -2.433333333333332 * sp[27] + -5.866666666666667 * sp[30];
    A[80] = 0.6333333333333333 * sp[33] + -1.058333333333335 * sp[34] + 1.241666666666668 * sp[28] + -1.058333333333336 * sp[31] + -1.058333333333335 * sp[34] + 3.441666666666672 * sp[35] + -2.325000000000009 * sp[29] + 2.174999999999995 * sp[32] + 1.241666666666668 * sp[28] + -2.325000000000009 * sp[29] + 2.708333333333341 * sp[26] + -1.825000000000009 * sp[27] + -1.058333333333336 * sp[31] + 2.174999999999995 * sp[32] + -1.825000000000009 * sp[27] + 3.683333333333317 * sp[30];
    A[81] = 0.09166666666666863 * sp[33] + -0.01666666666666165 * sp[34] + -0.01666666666666915 * sp[28] + -0.01666666666666794 * sp[31] + -0.3083333333333279 * sp[34] + -1.054166666666682 * sp[35] + 0.7291666666666843 * sp[29] + -0.01666666666666217 * sp[32] + 0.5583333333333307 * sp[28] + 0.9625000000000061 * sp[29] + -0.3875000000000082 * sp[26] + -0.01666666666667016 * sp[27] + 1.341666666666671 * sp[31] + 3.224999999999997 * sp[32] + 0.3583333333333535 * sp[27] + 1.091666666666682 * sp[30];
    A[82] = -0.6000000000000031 * sp[33] + -0.2166666666666677 * sp[34] + -0.2166666666666662 * sp[28] + -0.2166666666666643 * sp[31] + -0.4666666666666727 * sp[34] + 0.3583333333333322 * sp[35] + -1.041666666666684 * sp[29] + -0.2166666666666763 * sp[32] + -1.533333333333328 * sp[28] + -1.008333333333332 * sp[29] + 0.525000000000012 * sp[26] + -0.2166666666666592 * sp[27] + -1.933333333333336 * sp[31] + -0.866666666666672 * sp[32] + -0.3000000000000203 * sp[27] + -0.1833333333333522 * sp[30];
    A[83] = 0.5083333333333343 * sp[33] + -0.1833333333333419 * sp[34] + -0.1833333333333342 * sp[28] + -0.1833333333333404 * sp[31] + 0.7750000000000011 * sp[34] + -1.012500000000006 * sp[35] + 1.604166666666675 * sp[29] + -0.1833333333333344 * sp[32] + 0.9749999999999968 * sp[28] + 0.170833333333323 * sp[29] + -1.01250000000001 * sp[26] + -0.1833333333333422 * sp[27] + 0.5916666666666651 * sp[31] + 0.974999999999995 * sp[32] + 0.7750000000000079 * sp[27] + 0.5083333333333351 * sp[30];
    A[84] = 1.885618083164135 * sp[33] + 3.064129385141726 * sp[34] + 1.649915822768613 * sp[28] + 1.649915822768628 * sp[31] + -5.421151989096911 * sp[34] + -1.178511301977583 * sp[35] + -2.592724864350647 * sp[29] + 1.64991582276865 * sp[32] + 3.064129385141726 * sp[28] + 3.535533905932765 * sp[29] + 2.121320343559639 * sp[26] + 1.649915822768615 * sp[27] + -5.421151989096914 * sp[31] + -13.43502884254442 * sp[32] + -2.121320343559606 * sp[27] + -2.357022603955105 * sp[30];
    A[85] = -4.474464586219583 * sp[33] + -0.7216878364869809 * sp[34] + 1.876388374866274 * sp[28] + 1.876388374866304 * sp[31] + -3.752776749732466 * sp[34] + -0.07216878364873142 * sp[35] + -1.804219591217485 * sp[29] + 1.876388374866346 * sp[32] + -8.948929172439197 * sp[28] + 0.2165063509461709 * sp[29] + 1.948557158514959 * sp[26] + 1.876388374866282 * sp[27] + -3.752776749732438 * sp[31] + 5.196152422706647 * sp[32] + -1.732050807568763 * sp[27] + 1.587713240271592 * sp[30];
    A[86] = 5.583333333333327 * sp[33] + 0.9166666666666656 * sp[34] + -2.583333333333357 * sp[28] + -2.583333333333361 * sp[31] + -10.33333333333336 * sp[34] + -18.95833333333336 * sp[35] + 6.04166666666674 * sp[29] + -2.583333333333357 * sp[32] + 10.66666666666667 * sp[28] + 4.875000000000004 * sp[29] + -4.125000000000039 * sp[26] + -2.583333333333353 * sp[27] + -10.33333333333336 * sp[31] + 0.5 * sp[32] + 4.500000000000076 * sp[27] + 11.08333333333336 * sp[30];
    A[87] = -5.892556509887897 * sp[33] + -1.885618083164137 * sp[34] + -6.128258770283405 * sp[28] + -0.4714045207910272 * sp[31] + 11.54941075938032 * sp[34] + 4.831896338108142 * sp[35] + 6.246109900481134 * sp[29] + -0.4714045207910607 * sp[32] + -11.07800623858926 * sp[28] + -3.181980515339478 * sp[29] + -13.08147545195112 * sp[26] + -0.4714045207910047 * sp[27] + 11.54941075938032 * sp[31] + 3.535533905932827 * sp[32] + 4.9497474683058 * sp[27] + -1.649915822768633 * sp[30];
    A[88] = 3.897114317029984 * sp[33] + 0.8660254037844378 * sp[34] + 0.8660254037844392 * sp[28] + -1.732050807568883 * sp[31] + -1.299038105676636 * sp[34] + -0.2165063509460357 * sp[35] + -2.814582562299329 * sp[29] + -1.732050807568809 * sp[32] + 9.093266739736638 * sp[28] + 0.6495190528383108 * sp[29] + 8.443747686898289 * sp[26] + -1.732050807568887 * sp[27] + -1.299038105676618 * sp[31] + -0.4330127018921535 * sp[32] + -2.165063509461001 * sp[27] + -3.89711431702996 * sp[30];
    A[89] = -10.41666666666667 * sp[33] + -3.333333333333347 * sp[34] + -6.333333333333321 * sp[28] + 0.1666666666666863 * sp[31] + 20.41666666666674 * sp[34] + 8.541666666666764 * sp[35] + 12.04166666666667 * sp[29] + 0.1666666666668286 * sp[32] + -19.58333333333336 * sp[28] + -5.625000000000014 * sp[29] + -12.12500000000002 * sp[26] + 0.1666666666666858 * sp[27] + 20.41666666666675 * sp[31] + 6.250000000000159 * sp[32] + 15.25 * sp[27] + -12.91666666666645 * sp[30];
    A[90] = -1.091666666666673 * sp[33] + -0.7333333333333457 * sp[34] + 2.133333333333352 * sp[28] + 1.150000000000003 * sp[31] + -1.108333333333343 * sp[34] + -0.362499999999996 * sp[35] + 1.154166666666658 * sp[29] + 1.116666666666665 * sp[32] + -1.108333333333336 * sp[28] + -1.479166666666685 * sp[29] + 3.170833333333351 * sp[26] + 1.150000000000001 * sp[27] + -1.108333333333336 * sp[31] + -1.108333333333343 * sp[32] + 2.191666666666671 * sp[27] + 1.008333333333332 * sp[30];
    A[91] = 0.1833333333333381 * sp[33] + -0.1166666666666571 * sp[34] + -0.6833333333333466 * sp[28] + 0.9500000000000035 * sp[31] + -0.03333333333332197 * sp[34] + -0.858333333333349 * sp[35] + 0.1083333333333369 * sp[29] + -0.3166666666666877 * sp[32] + -0.03333333333333802 * sp[28] + 0.7083333333333554 * sp[29] + -1.258333333333348 * sp[26] + 0.9500000000000105 * sp[27] + -0.03333333333333549 * sp[31] + -0.033333333333327 * sp[32] + -0.4666666666666713 * sp[27] + 0.06666666666666252 * sp[30];
    A[92] = -0.5083333333333346 * sp[33] + 0.2666666666666638 * sp[34] + 0.4666666666666719 * sp[28] + 0.6499999999999985 * sp[31] + -0.6916666666666652 * sp[34] + 1.095833333333346 * sp[35] + 0.112499999999998 * sp[29] + 2.283333333333351 * sp[32] + -0.6916666666666724 * sp[28] + -1.520833333333349 * sp[29] + 1.295833333333342 * sp[26] + 0.6499999999999971 * sp[27] + -0.6916666666666706 * sp[31] + -0.6916666666666709 * sp[32] + 0.9416666666666708 * sp[27] + 1.591666666666676 * sp[30];
    A[93] = 1.508333333333336 * sp[33] + 0.7750000000000069 * sp[34] + 4.308333333333326 * sp[28] + 2.591666666666663 * sp[31] + 1.816666666666666 * sp[34] + 0.3208333333333285 * sp[35] + 7.504166666666658 * sp[29] + 4.308333333333323 * sp[32] + 1.816666666666675 * sp[28] + 2.270833333333347 * sp[29] + 0.3208333333333435 * sp[26] + 0.7750000000000116 * sp[27] + 1.816666666666671 * sp[31] + 1.816666666666673 * sp[32] + 1.816666666666674 * sp[27] + 1.508333333333339 * sp[30];
    A[94] = -1.016666666666669 * sp[33] + 0.03333333333333038 * sp[34] + -2.86666666666666 * sp[28] + -3.933333333333321 * sp[31] + -1.383333333333331 * sp[34] + 0.9416666666666805 * sp[35] + -5.258333333333321 * sp[29] + -7.533333333333321 * sp[32] + -1.383333333333346 * sp[28] + -2.291666666666685 * sp[29] + -0.2250000000000064 * sp[26] + -1.13333333333334 * sp[27] + -1.383333333333342 * sp[31] + -1.383333333333339 * sp[32] + -1.383333333333338 * sp[27] + -2.600000000000006 * sp[30];
    A[95] = 0.09166666666666863 * sp[33] + -0.3083333333333279 * sp[34] + 0.5583333333333307 * sp[28] + 1.341666666666671 * sp[31] + -0.01666666666666165 * sp[34] + -1.054166666666682 * sp[35] + 0.9625000000000061 * sp[29] + 3.224999999999997 * sp[32] + -0.01666666666666915 * sp[28] + 0.7291666666666843 * sp[29] + -0.3875000000000082 * sp[26] + 0.3583333333333535 * sp[27] + -0.01666666666666794 * sp[31] + -0.01666666666666217 * sp[32] + -0.01666666666667016 * sp[27] + 1.091666666666682 * sp[30];
    A[96] = 3.683333333333333 * sp[33] + 5.50833333333332 * sp[34] + 1.508333333333343 * sp[28] + 2.275000000000003 * sp[31] + 5.50833333333332 * sp[34] + 10.04166666666666 * sp[35] + 1.008333333333329 * sp[29] + 3.241666666666672 * sp[32] + 1.508333333333343 * sp[28] + 1.008333333333329 * sp[29] + 2.775000000000011 * sp[26] + 2.275000000000004 * sp[27] + 2.275000000000003 * sp[31] + 3.241666666666672 * sp[32] + 2.275000000000004 * sp[27] + 2.633333333333341 * sp[30];
    A[97] = -5.866666666666673 * sp[33] + -3.433333333333328 * sp[34] + -2.766666666666688 * sp[28] + -2.300000000000005 * sp[31] + -7.933333333333317 * sp[34] + -5.083333333333321 * sp[35] + -1.683333333333323 * sp[29] + -2.233333333333329 * sp[32] + -2.60000000000002 * sp[28] + -0.6833333333333351 * sp[29] + -4.216666666666687 * sp[26] + -2.300000000000002 * sp[27] + -3.133333333333339 * sp[31] + -1.399999999999999 * sp[32] + -3.133333333333338 * sp[27] + -2.016666666666666 * sp[30];
    A[98] = 2.183333333333342 * sp[33] + -0.2416666666666663 * sp[34] + 1.091666666666682 * sp[28] + -0.4750000000000028 * sp[31] + 2.424999999999996 * sp[34] + 1.625000000000023 * sp[35] + 0.2583333333333291 * sp[29] + 0.1583333333333447 * sp[32] + 1.091666666666679 * sp[28] + -1.075000000000002 * sp[29] + 1.691666666666682 * sp[26] + -0.475000000000008 * sp[27] + 0.8583333333333361 * sp[31] + 0.1583333333333446 * sp[32] + 0.8583333333333374 * sp[27] + -0.03333333333333262 * sp[30];
    A[99] = -4.006938426723773 * sp[33] + -6.835365551469943 * sp[34] + 5.892556509887917 * sp[28] + 9.192388155425135 * sp[31] + -5.185449728701331 * sp[34] + -18.9740319618391 * sp[35] + 5.067598598503574 * sp[29] + 5.421151989096782 * sp[32] + -5.185449728701385 * sp[28] + -4.36049181731705 * sp[29] + 8.367430244040824 * sp[26] + 9.192388155425155 * sp[27] + -5.18544972870137 * sp[31] + -10.84230397819379 * sp[32] + 7.542472332656506 * sp[27] + 5.892556509887879 * sp[30];
    A[100] = 2.742413778650689 * sp[33] + 17.89785834487833 * sp[34] + 10.96965511460292 * sp[28] + 19.91858428704212 * sp[31] + 0.7216878364868942 * sp[34] + 24.75389279150506 * sp[35] + 9.165435523385272 * sp[29] + 19.34123401785238 * sp[32] + 0.7216878364870309 * sp[28] + 2.525907427704585 * sp[29] + 18.11436469582454 * sp[26] + 19.91858428704215 * sp[27] + 0.7216878364870016 * sp[31] + 5.051814855409177 * sp[32] + 16.31014510460693 * sp[27] + 17.46484564298619 * sp[30];
    A[101] = -1.083333333333322 * sp[33] + 12.16666666666666 * sp[34] + -1.833333333333329 * sp[28] + 1.999999999999993 * sp[31] + -2.416666666666624 * sp[34] + 27.95833333333339 * sp[35] + -2.041666666666648 * sp[29] + 14.33333333333349 * sp[32] + -2.416666666666699 * sp[28] + -2.208333333333337 * sp[29] + 1.791666666666702 * sp[26] + 1.999999999999989 * sp[27] + -2.416666666666686 * sp[31] + 8.083333333333396 * sp[32] + 1.583333333333364 * sp[27] + 9.416666666666753 * sp[30];
    A[102] = 2.357022603955151 * sp[33] + 0.2357022603954935 * sp[34] + -11.07800623858926 * sp[28] + -7.778174593052068 * sp[31] + 4.006938426723725 * sp[34] + -0.2357022603955206 * sp[35] + -12.96362432175338 * sp[29] + -8.720983634634067 * sp[32] + 4.006938426723819 * sp[28] + 4.478342947514796 * sp[29] + -8.249579113843071 * sp[26] + -7.778174593052099 * sp[27] + 4.006938426723799 * sp[31] + 4.006938426723767 * sp[32] + -8.720983634634086 * sp[27] + -7.542472332656554 * sp[30];
    A[103] = 10.39230484541329 * sp[33] + 7.361215932167795 * sp[34] + 7.361215932167656 * sp[28] + -6.495190528383262 * sp[31] + 11.69134295108995 * sp[34] + 6.062177826491061 * sp[35] + 12.99038105676651 * sp[29] + -8.227241335952183 * sp[32] + 11.69134295108995 * sp[28] + 12.99038105676667 * sp[29] + -7.794228634059944 * sp[26] + -6.495190528383223 * sp[27] + 11.69134295108994 * sp[31] + 11.69134295108997 * sp[32] + -3.897114317029983 * sp[27] + -6.06217782649103 * sp[30];
    A[104] = 4.166666666666655 * sp[33] + 0.4166666666666341 * sp[34] + 8.416666666666677 * sp[28] + 2.749999999999961 * sp[31] + 7.083333333333258 * sp[34] + -0.416666666666651 * sp[35] + 13.58333333333326 * sp[29] + -8.916666666666835 * sp[32] + 7.083333333333412 * sp[28] + 7.916666666666644 * sp[29] + 1.916666666666736 * sp[26] + 2.749999999999966 * sp[27] + 7.083333333333381 * sp[31] + 7.083333333333328 * sp[32] + 3.083333333333362 * sp[27] + -3.333333333333436 * sp[30];
    A[105] = 2.600000000000015 * sp[33] + 1.466666666666688 * sp[34] + -4.933333333333367 * sp[28] + -2.133333333333334 * sp[31] + 1.216666666666671 * sp[34] + 0.3083333333333402 * sp[35] + -1.058333333333332 * sp[29] + -0.899999999999999 * sp[32] + 1.216666666666671 * sp[28] + 2.37500000000003 * sp[29] + -7.25833333333338 * sp[26] + -2.133333333333334 * sp[27] + 1.216666666666665 * sp[31] + 1.21666666666668 * sp[32] + -3.383333333333339 * sp[27] + -1.266666666666663 * sp[30];
    A[106] = -1.200000000000008 * sp[33] + -0.9333333333333453 * sp[34] + 2.533333333333359 * sp[28] + -3.066666666666689 * sp[31] + -0.4333333333333363 * sp[34] + 0.2166666666666629 * sp[35] + 0.2833333333333328 * sp[29] + -1.199999999999991 * sp[32] + -0.4333333333333325 * sp[28] + -1.58333333333336 * sp[29] + 3.683333333333367 * sp[26] + -3.066666666666698 * sp[27] + -0.433333333333329 * sp[31] + -0.4333333333333471 * sp[32] + 1.433333333333341 * sp[27] + -1.633333333333334 * sp[30];
    A[107] = 0.6000000000000043 * sp[33] + 0.1333333333333414 * sp[34] + -0.9333333333333451 * sp[28] + 0.5333333333333415 * sp[31] + 0.383333333333335 * sp[34] + -0.4416666666666666 * sp[35] + -0.1416666666666676 * sp[29] + 0.09999999999999387 * sp[32] + 0.383333333333336 * sp[28] + 0.9583333333333435 * sp[29] + -1.675000000000014 * sp[26] + 0.533333333333347 * sp[27] + 0.3833333333333366 * sp[31] + 0.3833333333333399 * sp[32] + -0.8833333333333371 * sp[27] + 0.06666666666666465 * sp[30];
    A[108] = -2.600000000000009 * sp[33] + -1.133333333333352 * sp[34] + -7.533333333333331 * sp[28] + -3.93333333333334 * sp[31] + -1.383333333333335 * sp[34] + -0.2250000000000038 * sp[35] + -5.258333333333326 * sp[29] + -2.866666666666664 * sp[32] + -1.383333333333338 * sp[28] + -2.291666666666686 * sp[29] + 0.9416666666666623 * sp[26] + 0.03333333333332122 * sp[27] + -1.383333333333335 * sp[31] + -1.383333333333341 * sp[32] + -1.383333333333338 * sp[27] + -1.016666666666675 * sp[30];
    A[109] = 1.200000000000008 * sp[33] + 0.2666666666666798 * sp[34] + 3.733333333333327 * sp[28] + 5.866666666666655 * sp[31] + 0.7666666666666695 * sp[34] + -0.3833333333333329 * sp[35] + 3.016666666666663 * sp[29] + 3.733333333333325 * sp[32] + 0.7666666666666735 * sp[28] + 1.416666666666679 * sp[29] + -0.3833333333333287 * sp[26] + 0.2666666666666636 * sp[27] + 0.7666666666666733 * sp[31] + 0.766666666666674 * sp[32] + 0.7666666666666733 * sp[27] + 1.200000000000004 * sp[30];
    A[110] = -0.6000000000000031 * sp[33] + -0.4666666666666727 * sp[34] + -1.533333333333328 * sp[28] + -1.933333333333336 * sp[31] + -0.2166666666666677 * sp[34] + 0.3583333333333322 * sp[35] + -1.008333333333332 * sp[29] + -0.866666666666672 * sp[32] + -0.2166666666666662 * sp[28] + -1.041666666666684 * sp[29] + 0.525000000000012 * sp[26] + -0.3000000000000203 * sp[27] + -0.2166666666666643 * sp[31] + -0.2166666666666763 * sp[32] + -0.2166666666666592 * sp[27] + -0.1833333333333522 * sp[30];
    A[111] = -5.866666666666673 * sp[33] + -7.933333333333317 * sp[34] + -2.60000000000002 * sp[28] + -3.133333333333339 * sp[31] + -3.433333333333328 * sp[34] + -5.083333333333321 * sp[35] + -0.6833333333333351 * sp[29] + -1.399999999999999 * sp[32] + -2.766666666666688 * sp[28] + -1.683333333333323 * sp[29] + -4.216666666666687 * sp[26] + -3.133333333333338 * sp[27] + -2.300000000000005 * sp[31] + -2.233333333333329 * sp[32] + -2.300000000000002 * sp[27] + -2.016666666666666 * sp[30];
    A[112] = 11.73333333333336 * sp[33] + 5.866666666666656 * sp[34] + 5.86666666666671 * sp[28] + 4.266666666666672 * sp[31] + 5.866666666666656 * sp[34] + 3.833333333333324 * sp[35] + 1.366666666666667 * sp[29] + 1.799999999999996 * sp[32] + 5.86666666666671 * sp[28] + 1.366666666666667 * sp[29] + 8.766666666666721 * sp[26] + 4.266666666666673 * sp[27] + 4.266666666666672 * sp[31] + 1.799999999999996 * sp[32] + 4.266666666666673 * sp[27] + 2.533333333333327 * sp[30];
    A[113] = -5.866666666666686 * sp[33] + 2.066666666666685 * sp[34] + -3.266666666666695 * sp[28] + 1.533333333333352 * sp[31] + -2.433333333333329 * sp[34] + 0.4166666666666549 * sp[35] + -0.5166666666666664 * sp[29] + 0.5999999999999955 * sp[32] + -3.100000000000022 * sp[28] + 3.150000000000018 * sp[29] + -4.716666666666705 * sp[26] + 1.533333333333356 * sp[27] + -1.966666666666668 * sp[31] + 1.433333333333326 * sp[32] + -1.966666666666674 * sp[27] + 0.8166666666666704 * sp[30];
    A[114] = 5.656854249492398 * sp[33] + 1.885618083164101 * sp[34] + -9.42809041582068 * sp[28] + -20.74179891480546 * sp[31] + 3.299831645537223 * sp[34] + 2.592724864350703 * sp[35] + -3.064129385141709 * sp[29] + -8.485281374238529 * sp[32] + 3.299831645537242 * sp[28] + -3.064129385141741 * sp[29] + -14.37783788412651 * sp[26] + -20.7417989148055 * sp[27] + 3.299831645537236 * sp[31] + 0.471404520791066 * sp[32] + -8.013876853447533 * sp[27] + -11.78511301977577 * sp[30];
    A[115] = 10.39230484541329 * sp[33] + -30.02221399786048 * sp[34] + -16.1658075373096 * sp[28] + -36.95041722813616 * sp[31] + -1.443375672974041 * sp[34] + -19.19689645055495 * sp[35] + -5.340489990004045 * sp[29] + -15.58845726811984 * sp[32] + -1.443375672974121 * sp[28] + -12.26869322027953 * sp[29] + -26.12509968083065 * sp[26] + -36.9504172281362 * sp[27] + -1.443375672974081 * sp[31] + -10.10362971081839 * sp[32] + -15.29978213352507 * sp[27] + -21.93931022920576 * sp[30];
    A[116] = -2.000000000000008 * sp[33] + -2.666666666666618 * sp[34] + 5.333333333333316 * sp[28] + 9.333333333333382 * sp[31] + -0.1666666666666682 * sp[34] + -8.416666666666707 * sp[35] + 1.583333333333315 * sp[29] + 2.999999999999943 * sp[32] + -0.1666666666666607 * sp[28] + 3.583333333333318 * sp[29] + 5.583333333333335 * sp[26] + 9.333333333333428 * sp[27] + -0.1666666666666419 * sp[31] + -1.166666666666722 * sp[32] + 1.833333333333308 * sp[27] + 3.666666666666634 * sp[30];
    A[117] = 1.885618083164124 * sp[34] + 24.51303508113369 * sp[28] + 13.19932658214895 * sp[31] + -0.9428090415820616 * sp[34] + 0.4714045207910442 * sp[35] + 11.78511301977578 * sp[29] + 5.656854249492392 * sp[32] + -0.9428090415820854 * sp[28] + 0.4714045207910635 * sp[29] + 11.78511301977582 * sp[26] + 13.19932658214901 * sp[27] + -0.9428090415820957 * sp[31] + -0.9428090415820469 * sp[32] + 10.37089945740267 * sp[27] + 8.013876853447584 * sp[30];
    A[118] = -20.78460969082661 * sp[33] + -10.39230484541341 * sp[34] + -10.39230484541319 * sp[28] + 17.32050807568873 * sp[31] + -10.39230484541328 * sp[34] + -3.464101615137794 * sp[35] + -17.32050807568873 * sp[29] + 3.464101615137695 * sp[32] + -10.39230484541329 * sp[28] + -17.32050807568895 * sp[29] + 24.24871130596435 * sp[26] + 17.32050807568868 * sp[27] + -10.39230484541326 * sp[31] + -10.39230484541333 * sp[32] + 3.464101615137767 * sp[27] + 7.794228634059853 * sp[30];
    A[119] = 3.333333333333329 * sp[34] + -12.66666666666671 * sp[28] + -4.666666666666685 * sp[31] + -1.666666666666667 * sp[34] + 0.8333333333333508 * sp[35] + -7.16666666666665 * sp[29] + -7.999999999999927 * sp[32] + -1.666666666666705 * sp[28] + 0.8333333333334063 * sp[29] + -7.166666666666799 * sp[26] + -4.666666666666658 * sp[27] + -1.666666666666722 * sp[31] + -1.666666666666631 * sp[32] + -3.666666666666728 * sp[27] + -5.833333333333255 * sp[30];
    A[120] = -1.508333333333342 * sp[33] + -0.7333333333333423 * sp[34] + 2.800000000000017 * sp[28] + 0.9833333333333307 * sp[31] + 0.3083333333333466 * sp[34] + 0.7625000000000113 * sp[35] + -2.887500000000016 * sp[29] + -0.7166666666666628 * sp[32] + 0.3083333333333321 * sp[28] + -1.187500000000015 * sp[29] + 4.295833333333365 * sp[26] + 0.9833333333333359 * sp[27] + 0.3083333333333459 * sp[31] + 0.3083333333333424 * sp[32] + -1.391666666666686 * sp[27] + -0.408333333333335 * sp[30];
    A[121] = 1.016666666666669 * sp[33] + 1.050000000000002 * sp[34] + -1.850000000000012 * sp[28] + 2.116666666666684 * sp[31] + -0.3666666666666838 * sp[34] + -1.275000000000013 * sp[35] + 2.025000000000012 * sp[29] + -2.483333333333346 * sp[32] + -0.3666666666666683 * sp[28] + 1.958333333333345 * sp[29] + -3.008333333333358 * sp[26] + 2.116666666666685 * sp[27] + -0.3666666666666808 * sp[31] + -0.3666666666666727 * sp[32] + 0.8666666666666769 * sp[27] + -1.266666666666679 * sp[30];
    A[122] = -0.09166666666666996 * sp[33] + -0.4000000000000062 * sp[34] + 0.4666666666666736 * sp[28] + -1.18333333333334 * sp[31] + -0.1083333333333397 * sp[34] + 0.6374999999999957 * sp[35] + -0.5125000000000006 * sp[29] + 2.11666666666668 * sp[32] + -0.1083333333333343 * sp[28] + -1.145833333333341 * sp[29] + 0.8375000000000107 * sp[26] + -1.183333333333341 * sp[27] + -0.1083333333333371 * sp[31] + -0.1083333333333382 * sp[32] + -0.1416666666666685 * sp[27] + 1.008333333333342 * sp[30];
    A[123] = 1.091666666666674 * sp[33] + 0.3583333333333456 * sp[34] + 3.225000000000005 * sp[28] + 1.341666666666677 * sp[31] + -0.01666666666666433 * sp[34] + -0.3875000000000002 * sp[35] + 0.9625000000000028 * sp[29] + 0.5583333333333398 * sp[32] + -0.01666666666666328 * sp[28] + 0.7291666666666797 * sp[29] + -1.054166666666664 * sp[26] + -0.3083333333333252 * sp[27] + -0.01666666666666779 * sp[31] + -0.0166666666666693 * sp[32] + -0.01666666666666251 * sp[27] + 0.09166666666667259 * sp[30];
    A[124] = -0.1833333333333394 * sp[33] + -0.3000000000000112 * sp[34] + -0.8666666666666669 * sp[28] + -1.933333333333333 * sp[31] + -0.2166666666666788 * sp[34] + 0.5249999999999934 * sp[35] + -1.008333333333349 * sp[29] + -1.533333333333354 * sp[32] + -0.2166666666666705 * sp[28] + -1.041666666666677 * sp[29] + 0.358333333333331 * sp[26] + -0.4666666666666702 * sp[27] + -0.2166666666666743 * sp[31] + -0.2166666666666724 * sp[32] + -0.2166666666666785 * sp[27] + -0.6000000000000169 * sp[30];
    A[125] = 0.5083333333333343 * sp[33] + 0.7750000000000011 * sp[34] + 0.9749999999999968 * sp[28] + 0.5916666666666651 * sp[31] + -0.1833333333333419 * sp[34] + -1.012500000000006 * sp[35] + 0.170833333333323 * sp[29] + 0.974999999999995 * sp[32] + -0.1833333333333342 * sp[28] + 1.604166666666675 * sp[29] + -1.01250000000001 * sp[26] + 0.7750000000000079 * sp[27] + -0.1833333333333404 * sp[31] + -0.1833333333333344 * sp[32] + -0.1833333333333422 * sp[27] + 0.5083333333333351 * sp[30];
    A[126] = 2.183333333333342 * sp[33] + 2.424999999999996 * sp[34] + 1.091666666666679 * sp[28] + 0.8583333333333361 * sp[31] + -0.2416666666666663 * sp[34] + 1.625000000000023 * sp[35] + -1.075000000000002 * sp[29] + 0.1583333333333446 * sp[32] + 1.091666666666682 * sp[28] + 0.2583333333333291 * sp[29] + 1.691666666666682 * sp[26] + 0.8583333333333374 * sp[27] + -0.4750000000000028 * sp[31] + 0.1583333333333447 * sp[32] + -0.475000000000008 * sp[27] + -0.03333333333333262 * sp[30];
    A[127] = -5.866666666666686 * sp[33] + -2.433333333333329 * sp[34] + -3.100000000000022 * sp[28] + -1.966666666666668 * sp[31] + 2.066666666666685 * sp[34] + 0.4166666666666549 * sp[35] + 3.150000000000018 * sp[29] + 1.433333333333326 * sp[32] + -3.266666666666695 * sp[28] + -0.5166666666666664 * sp[29] + -4.716666666666705 * sp[26] + -1.966666666666674 * sp[27] + 1.533333333333352 * sp[31] + 0.5999999999999955 * sp[32] + 1.533333333333356 * sp[27] + 0.8166666666666704 * sp[30];
    A[128] = 3.683333333333344 * sp[33] + -1.825000000000019 * sp[34] + 2.175000000000013 * sp[28] + -1.058333333333349 * sp[31] + -1.825000000000019 * sp[34] + 2.708333333333342 * sp[35] + -2.325000000000014 * sp[29] + 1.241666666666676 * sp[32] + 2.175000000000013 * sp[28] + -2.325000000000014 * sp[29] + 3.441666666666694 * sp[26] + -1.058333333333347 * sp[27] + -1.058333333333349 * sp[31] + 1.241666666666676 * sp[32] + -1.058333333333347 * sp[27] + 0.6333333333333412 * sp[30];
    A[129] = -1.649915822768627 * sp[33] + 4.949747468305839 * sp[34] + 3.535533905932764 * sp[28] + 11.54941075938033 * sp[31] + -0.4714045207910604 * sp[34] + -13.08147545195119 * sp[35] + -3.181980515339477 * sp[29] + -11.07800623858926 * sp[32] + -0.4714045207910444 * sp[28] + 6.246109900481182 * sp[29] + 4.831896338108107 * sp[26] + 11.54941075938035 * sp[27] + -0.4714045207910475 * sp[31] + -6.12825877028346 * sp[32] + -1.885618083164163 * sp[27] + -5.892556509887942 * sp[30];
    A[130] = -13.13471862406398 * sp[33] + 12.12435565298215 * sp[34] + 5.196152422706689 * sp[28] + 17.03183294109404 * sp[31] + -0.7216878364868531 * sp[34] + -6.278684177437057 * sp[35] + -4.546633369868307 * sp[29] + -12.41303078757693 * sp[32] + -0.721687836486973 * sp[28] + 9.021097956087907 * sp[29] + 7.289047148519091 * sp[26] + 17.03183294109407 * sp[27] + -0.721687836486921 * sp[31] + -5.05181485540917 * sp[32] + -2.45373864405596 * sp[27] + -7.072540797572966 * sp[30];
    A[131] = 3.083333333333327 * sp[33] + -9.500000000000039 * sp[34] + -3.499999999999986 * sp[28] + -11.33333333333337 * sp[31] + -1.583333333333413 * sp[34] + 13.3750000000001 * sp[35] + 3.375000000000035 * sp[29] + 17.66666666666676 * sp[32] + -1.583333333333336 * sp[28] + -8.458333333333336 * sp[29] + -4.45833333333333 * sp[26] + -11.33333333333339 * sp[27] + -1.583333333333393 * sp[31] + 3.91666666666673 * sp[32] + 2.416666666666701 * sp[27] + 8.5833333333334 * sp[30];
    A[132] = -2.357022603955149 * sp[33] + -2.121320343559615 * sp[34] + -13.43502884254444 * sp[28] + -5.421151989096883 * sp[31] + 1.649915822768694 * sp[34] + 2.121320343559693 * sp[35] + 3.535533905932814 * sp[29] + 3.06412938514173 * sp[32] + 1.649915822768623 * sp[28] + -2.592724864350672 * sp[29] + -1.17851130197759 * sp[26] + -5.421151989096922 * sp[27] + 1.649915822768672 * sp[31] + 1.649915822768643 * sp[32] + 3.064129385141784 * sp[27] + 1.88561808316416 * sp[30];
    A[133] = 10.39230484541333 * sp[33] + 3.031088913245617 * sp[34] + 3.03108891324553 * sp[28] + -10.82531754730546 * sp[31] + -1.299038105676702 * sp[34] + -2.598076211353367 * sp[35] + 4.330127018922297 * sp[29] + 4.76313972081441 * sp[32] + -1.29903810567665 * sp[28] + 4.330127018922294 * sp[29] + -16.45448267190439 * sp[26] + -10.82531754730545 * sp[27] + -1.299038105676719 * sp[31] + -1.299038105676716 * sp[32] + 0.4330127018923136 * sp[27] + 2.598076211353348 * sp[30];
    A[134] = -4.16666666666664 * sp[33] + -3.749999999999956 * sp[34] + 4.250000000000033 * sp[28] + 1.916666666666723 * sp[31] + 2.916666666666811 * sp[34] + 3.750000000000104 * sp[35] + -2.24999999999996 * sp[29] + -13.0833333333332 * sp[32] + 2.916666666666691 * sp[28] + -4.583333333333339 * sp[29] + 9.41666666666676 * sp[26] + 1.916666666666706 * sp[27] + 2.916666666666773 * sp[31] + 2.916666666666727 * sp[32] + -1.083333333333296 * sp[27] + -6.666666666666606 * sp[30];
    A[135] = 1.649915822768633 * sp[33] + 3.064129385141745 * sp[34] + -1.649915822768623 * sp[28] + -1.649915822768624 * sp[31] + 0.4714045207910269 * sp[34] + 1.767766952966353 * sp[35] + 5.067598598503618 * sp[29] + -0.2357022603955377 * sp[32] + -5.185449728701357 * sp[28] + -3.889087296526059 * sp[29] + 10.72445284799601 * sp[26] + 4.00693842672376 * sp[27] + -5.185449728701387 * sp[31] + -5.185449728701428 * sp[32] + 17.44196726926826 * sp[27] + 5.892556509887884 * sp[30];
    A[136] = 3.771236166328266 * sp[33] + -3.771236166328299 * sp[34] + 0.9428090415820787 * sp[28] + 0.9428090415820845 * sp[31] + 6.128258770283447 * sp[34] + 1.1785113019776 * sp[35] + -5.421151989096865 * sp[29] + 12.25651754056688 * sp[32] + 3.299831645537224 * sp[28] + -1.649915822768566 * sp[29] + -2.592724864350703 * sp[26] + 3.7712361663283 * sp[27] + 3.299831645537258 * sp[31] + 3.299831645537295 * sp[32] + -8.956685895029661 * sp[27] + 11.78511301977584 * sp[30];
    A[137] = 4.006938426723796 * sp[33] + 10.13519719700724 * sp[34] + -4.006938426723802 * sp[28] + -4.006938426723792 * sp[31] + 5.185449728701378 * sp[34] + 7.660323462854308 * sp[35] + -3.181980515339485 * sp[29] + -16.73486048808169 * sp[32] + -0.4714045207910366 * sp[28] + 2.003469213361879 * sp[29] + 2.474873734152923 * sp[26] + 1.64991582276859 * sp[27] + -0.4714045207910277 * sp[31] + -0.4714045207910389 * sp[32] + 3.299831645537242 * sp[27] + -5.892556509887926 * sp[30];
    A[138] = -7.542472332656555 * sp[33] + -7.778174593052069 * sp[34] + -8.720983634634122 * sp[28] + -7.778174593052054 * sp[31] + -8.720983634634123 * sp[34] + -8.249579113843067 * sp[35] + -12.96362432175341 * sp[29] + -11.07800623858926 * sp[32] + 4.006938426723771 * sp[28] + 4.478342947514819 * sp[29] + -0.2357022603955037 * sp[26] + 0.2357022603955325 * sp[27] + 4.006938426723774 * sp[31] + 4.006938426723807 * sp[32] + 4.006938426723756 * sp[27] + 2.357022603955161 * sp[30];
    A[139] = 8.013876853447595 * sp[33] + 13.19932658214897 * sp[34] + 5.65685424949239 * sp[28] + 13.19932658214892 * sp[31] + 10.37089945740276 * sp[34] + 11.78511301977585 * sp[35] + 11.78511301977582 * sp[29] + 24.51303508113372 * sp[32] + -0.9428090415820713 * sp[28] + 0.47140452079103 * sp[29] + 0.4714045207910189 * sp[26] + 1.885618083164149 * sp[27] + -0.9428090415820554 * sp[31] + -0.9428090415820711 * sp[32] + -0.9428090415820363 * sp[27];
    A[140] = 1.885618083164135 * sp[33] + -5.421151989096911 * sp[34] + 3.064129385141726 * sp[28] + -5.421151989096914 * sp[31] + 3.064129385141726 * sp[34] + -1.178511301977583 * sp[35] + 3.535533905932765 * sp[29] + -13.43502884254442 * sp[32] + 1.649915822768613 * sp[28] + -2.592724864350647 * sp[29] + 2.121320343559639 * sp[26] + -2.121320343559606 * sp[27] + 1.649915822768628 * sp[31] + 1.64991582276865 * sp[32] + 1.649915822768615 * sp[27] + -2.357022603955105 * sp[30];
    A[141] = -4.006938426723773 * sp[33] + -5.185449728701331 * sp[34] + -5.185449728701385 * sp[28] + -5.18544972870137 * sp[31] + -6.835365551469943 * sp[34] + -18.9740319618391 * sp[35] + -4.36049181731705 * sp[29] + -10.84230397819379 * sp[32] + 5.892556509887917 * sp[28] + 5.067598598503574 * sp[29] + 8.367430244040824 * sp[26] + 7.542472332656506 * sp[27] + 9.192388155425135 * sp[31] + 5.421151989096782 * sp[32] + 9.192388155425155 * sp[27] + 5.892556509887879 * sp[30];
    A[142] = 5.656854249492398 * sp[33] + 3.299831645537223 * sp[34] + 3.299831645537242 * sp[28] + 3.299831645537236 * sp[31] + 1.885618083164101 * sp[34] + 2.592724864350703 * sp[35] + -3.064129385141741 * sp[29] + 0.471404520791066 * sp[32] + -9.42809041582068 * sp[28] + -3.064129385141709 * sp[29] + -14.37783788412651 * sp[26] + -8.013876853447533 * sp[27] + -20.74179891480546 * sp[31] + -8.485281374238529 * sp[32] + -20.7417989148055 * sp[27] + -11.78511301977577 * sp[30];
    A[143] = -1.649915822768627 * sp[33] + -0.4714045207910604 * sp[34] + -0.4714045207910444 * sp[28] + -0.4714045207910475 * sp[31] + 4.949747468305839 * sp[34] + -13.08147545195119 * sp[35] + 6.246109900481182 * sp[29] + -6.12825877028346 * sp[32] + 3.535533905932764 * sp[28] + -3.181980515339477 * sp[29] + 4.831896338108107 * sp[26] + -1.885618083164163 * sp[27] + 11.54941075938033 * sp[31] + -11.07800623858926 * sp[32] + 11.54941075938035 * sp[27] + -5.892556509887942 * sp[30];
    A[144] = 26.66666666666684 * sp[33] + 33.3333333333335 * sp[34] + -6.666666666666686 * sp[28] + -6.66666666666665 * sp[31] + 33.3333333333335 * sp[34] + 113.3333333333336 * sp[35] + -6.666666666666581 * sp[29] + 33.33333333333342 * sp[32] + -6.666666666666686 * sp[28] + -6.666666666666581 * sp[29] + 33.33333333333336 * sp[26] + 33.33333333333344 * sp[27] + -6.66666666666665 * sp[31] + 33.33333333333342 * sp[32] + 33.33333333333344 * sp[27] + 66.66666666666676 * sp[30];
    A[145] = 4.082482904638763 * sp[33] + -4.082482904638399 * sp[34] + -28.57738033247055 * sp[28] + -28.57738033247046 * sp[31] + 8.164965809277316 * sp[34] + 14.2886901662351 * sp[35] + -34.70110468942831 * sp[29] + -4.082482904638756 * sp[32] + 8.164965809277284 * sp[28] + 14.28869016623515 * sp[29] + 63.27848502189879 * sp[26] + 69.40220937885684 * sp[27] + 8.164965809276964 * sp[31] + 57.15476066494033 * sp[32] + 57.15476066494098 * sp[27] + 102.0620726159658 * sp[30];
    A[146] = 25.92724864350687 * sp[33] + 16.49915822768617 * sp[34] + -25.92724864350699 * sp[28] + -25.92724864350693 * sp[31] + 37.71236166328274 * sp[34] + -64.818121608767 * sp[35] + -36.53385036130523 * sp[29] + -124.9221980096239 * sp[32] + 9.428090415820623 * sp[28] + 20.03469213361892 * sp[29] + -8.249579113843076 * sp[26] + 2.357022603955048 * sp[27] + 9.428090415820767 * sp[31] + -18.85618083164135 * sp[32] + -18.85618083164131 * sp[27] + -58.92556509887913 * sp[30];
    A[147] = -33.33333333333353 * sp[33] + -26.66666666666678 * sp[34] + 13.33333333333344 * sp[28] + 13.33333333333348 * sp[31] + -46.66666666666694 * sp[34] + -36.66666666666686 * sp[35] + 3.333333333333272 * sp[29] + 13.33333333333336 * sp[32] + -6.666666666666642 * sp[28] + 3.333333333333215 * sp[29] + -36.66666666666669 * sp[26] + -26.66666666666688 * sp[27] + -6.666666666666787 * sp[31] + -6.666666666666837 * sp[32] + -46.66666666666683 * sp[27] + -33.33333333333358 * sp[30];
    A[148] = -36.74234614174778 * sp[33] + -24.49489742783195 * sp[34] + -24.49489742783192 * sp[28] + -36.74234614174761 * sp[34] + -30.61862178478958 * sp[35] + -6.123724356958228 * sp[29] + 36.74234614174776 * sp[28] + 42.86607049870585 * sp[29] + -30.61862178478975 * sp[26] + -24.49489742783155 * sp[27] + 36.74234614174787 * sp[31] + 36.74234614174811 * sp[32] + -12.24744871391629 * sp[27] + -36.74234614174739 * sp[30];
    A[149] = -58.92556509887927 * sp[33] + -47.14045207910331 * sp[34] + -18.85618083164129 * sp[28] + -4.714045207910209 * sp[31] + -82.49579113843097 * sp[34] + -64.81812160876723 * sp[35] + -22.39171473757406 * sp[29] + 80.13876853447543 * sp[32] + -11.78511301977575 * sp[28] + 5.89255650988768 * sp[29] + -8.249579113842914 * sp[26] + 9.428090415820522 * sp[27] + -11.785113019776 * sp[31] + -11.78511301977614 * sp[32] + 16.49915822768617 * sp[27] + 54.2115198909682 * sp[30];
    A[150] = 10.9696551146029 * sp[33] + 0.1443375672973251 * sp[34] + 0.7216878364870946 * sp[28] + 0.7216878364870842 * sp[31] + 0.7216878364869659 * sp[34] + -1.732050807568899 * sp[35] + 11.5470053837925 * sp[29] + 5.05181485540921 * sp[32] + -10.53664241271068 * sp[28] + -8.660254037844496 * sp[29] + 18.4752086140681 * sp[26] + 7.649891066762531 * sp[27] + -10.53664241271073 * sp[31] + -10.5366424127108 * sp[32] + 29.30052616137363 * sp[27] + 10.96965511460287 * sp[30];
    A[151] = -8.94892917243917 * sp[33] + -3.175426480542795 * sp[34] + 1.443375672974017 * sp[28] + 1.443375672973939 * sp[31] + -1.443375672973958 * sp[34] + 2.020725942163689 * sp[35] + -7.21687836487032 * sp[29] + 10.10362971081835 * sp[32] + 3.75277674973255 * sp[28] + -1.443375672973936 * sp[29] + -3.752776749732634 * sp[26] + 4.907477288111886 * sp[27] + 3.752776749732613 * sp[31] + 3.752776749732678 * sp[32] + -12.41303078757705 * sp[27] + 14.14508159514587 * sp[30];
    A[152] = -0.5773502691895926 * sp[33] + 4.474464586219603 * sp[34] + -0.7216878364870347 * sp[28] + -0.7216878364870083 * sp[31] + -0.7216878364869903 * sp[34] + 4.041451884327454 * sp[35] + -5.051814855409188 * sp[32] + -3.319764047840375 * sp[28] + -2.886751345948191 * sp[29] + 6.928203230275538 * sp[26] + 6.206515393788451 * sp[27] + -3.319764047840356 * sp[31] + -3.319764047840369 * sp[32] + 7.64989106676258 * sp[27] + -0.5773502691896253 * sp[30];
    A[153] = -5.917840259193714 * sp[33] + -0.866025403784461 * sp[34] + -11.83568051838743 * sp[28] + -0.8660254037845454 * sp[31] + 0.7216878364869981 * sp[34] + -2.237232293109831 * sp[35] + 18.25870226312184 * sp[29] + 10.96965511460279 * sp[32] + 11.98001808568476 * sp[28] + 13.35122497501015 * sp[29] + 2.670244995002061 * sp[26] + 4.041451884327429 * sp[27] + 11.98001808568476 * sp[31] + 11.9800180856848 * sp[32] + 11.98001808568474 * sp[27] + 8.804591605141809 * sp[30];
    A[154] = -1.154700538379196 * sp[33] + 4.618802153517053 * sp[34] + -5.196152422706566 * sp[28] + 4.618802153517082 * sp[31] + -1.443375672973986 * sp[34] + 5.91784025919376 * sp[35] + -14.86676943163275 * sp[29] + -16.16580753730938 * sp[32] + -6.639528095680748 * sp[28] + -7.938566201357419 * sp[29] + -1.010362971081878 * sp[26] + -2.309401076758501 * sp[27] + -6.639528095680713 * sp[31] + -6.639528095680722 * sp[32] + -6.639528095680672 * sp[27] + -10.3923048454132 * sp[30];
    A[155] = -4.474464586219583 * sp[33] + -3.752776749732466 * sp[34] + -8.948929172439197 * sp[28] + -3.752776749732438 * sp[31] + -0.7216878364869809 * sp[34] + -0.07216878364873142 * sp[35] + 0.2165063509461709 * sp[29] + 5.196152422706647 * sp[32] + 1.876388374866274 * sp[28] + -1.804219591217485 * sp[29] + 1.948557158514959 * sp[26] + -1.732050807568763 * sp[27] + 1.876388374866304 * sp[31] + 1.876388374866346 * sp[32] + 1.876388374866282 * sp[27] + 1.587713240271592 * sp[30];
    A[156] = 2.742413778650689 * sp[33] + 0.7216878364868942 * sp[34] + 0.7216878364870309 * sp[28] + 0.7216878364870016 * sp[31] + 17.89785834487833 * sp[34] + 24.75389279150506 * sp[35] + 2.525907427704585 * sp[29] + 5.051814855409177 * sp[32] + 10.96965511460292 * sp[28] + 9.165435523385272 * sp[29] + 18.11436469582454 * sp[26] + 16.31014510460693 * sp[27] + 19.91858428704212 * sp[31] + 19.34123401785238 * sp[32] + 19.91858428704215 * sp[27] + 17.46484564298619 * sp[30];
    A[157] = 10.39230484541329 * sp[33] + -1.443375672974041 * sp[34] + -1.443375672974121 * sp[28] + -1.443375672974081 * sp[31] + -30.02221399786048 * sp[34] + -19.19689645055495 * sp[35] + -12.26869322027953 * sp[29] + -10.10362971081839 * sp[32] + -16.1658075373096 * sp[28] + -5.340489990004045 * sp[29] + -26.12509968083065 * sp[26] + -15.29978213352507 * sp[27] + -36.95041722813616 * sp[31] + -15.58845726811984 * sp[32] + -36.9504172281362 * sp[27] + -21.93931022920576 * sp[30];
    A[158] = -13.13471862406398 * sp[33] + -0.7216878364868531 * sp[34] + -0.721687836486973 * sp[28] + -0.721687836486921 * sp[31] + 12.12435565298215 * sp[34] + -6.278684177437057 * sp[35] + 9.021097956087907 * sp[29] + -5.05181485540917 * sp[32] + 5.196152422706689 * sp[28] + -4.546633369868307 * sp[29] + 7.289047148519091 * sp[26] + -2.45373864405596 * sp[27] + 17.03183294109404 * sp[31] + -12.41303078757693 * sp[32] + 17.03183294109407 * sp[27] + -7.072540797572966 * sp[30];
    A[159] = 4.082482904638763 * sp[33] + 8.164965809277316 * sp[34] + 8.164965809277284 * sp[28] + 8.164965809276964 * sp[31] + -4.082482904638399 * sp[34] + 14.2886901662351 * sp[35] + 14.28869016623515 * sp[29] + 57.15476066494033 * sp[32] + -28.57738033247055 * sp[28] + -34.70110468942831 * sp[29] + 63.27848502189879 * sp[26] + 57.15476066494098 * sp[27] + -28.57738033247046 * sp[31] + -4.082482904638756 * sp[32] + 69.40220937885684 * sp[27] + 102.0620726159658 * sp[30];
    A[160] = 189.9999999999993 * sp[33] + 57.49999999999885 * sp[34] + 12.49999999999994 * sp[28] + 12.49999999999939 * sp[31] + 57.49999999999885 * sp[34] + 132.4999999999986 * sp[35] + 12.49999999999981 * sp[29] + 87.49999999999918 * sp[32] + 12.49999999999994 * sp[28] + 12.49999999999981 * sp[29] + 132.5 * sp[26] + 132.5000000000002 * sp[27] + 12.49999999999939 * sp[31] + 87.49999999999918 * sp[32] + 132.5000000000002 * sp[27] + 190.0000000000001 * sp[30];
    A[161] = -31.75426480542914 * sp[33] + 105.3664241271068 * sp[34] + -7.216878364870505 * sp[28] + -7.216878364870297 * sp[31] + -7.216878364869808 * sp[34] + 57.73502691896252 * sp[35] + -28.86751345948137 * sp[29] + -50.51814855409192 * sp[32] + 1.443375672973913 * sp[28] + 23.09401076758508 * sp[29] + 5.77350269189637 * sp[26] + 27.42413778650713 * sp[27] + 1.443375672974196 * sp[31] + 10.10362971081854 * sp[32] + -15.87713240271465 * sp[27] + -31.7542648054293 * sp[30];
    A[162] = 28.57738033247015 * sp[33] + -4.082482904639212 * sp[34] + 69.40220937885675 * sp[28] + -4.082482904638992 * sp[31] + 8.164965809276708 * sp[34] + -22.45365597551276 * sp[35] + -22.45365597551264 * sp[29] + -28.57738033247038 * sp[32] + 8.164965809277481 * sp[28] + 26.53613888015094 * sp[29] + -71.44345083117607 * sp[26] + -53.07227776030265 * sp[27] + 8.164965809277188 * sp[31] + 8.164965809277039 * sp[32] + -89.8146239020501 * sp[27] + -69.40220937885721 * sp[30];
    A[163] = -67.50000000000026 * sp[33] + 7.500000000000107 * sp[34] + 7.499999999998941 * sp[28] + 52.50000000000017 * sp[31] + 3.7500000000001 * sp[35] + 48.7499999999992 * sp[29] + -22.49999999999988 * sp[32] + 90.00000000000014 * sp[28] + 93.75000000000045 * sp[29] + -41.24999999999996 * sp[26] + -37.49999999999952 * sp[27] + 90.00000000000033 * sp[31] + 90.00000000000071 * sp[32] + -30.00000000000059 * sp[27] + -67.49999999999957 * sp[30];
    A[164] = 50.51814855409172 * sp[33] + -7.21687836487132 * sp[34] + 44.74464586219592 * sp[28] + 105.3664241271053 * sp[31] + 14.43375672973969 * sp[34] + -39.69283100678724 * sp[35] + 72.89047148518972 * sp[29] + 62.06515393788342 * sp[32] + 14.43375672974099 * sp[28] + 46.90970937165675 * sp[29] + -13.71206889325328 * sp[26] + 18.7638837486625 * sp[27] + 14.4337567297405 * sp[31] + 14.43375672974019 * sp[32] + 31.75426480542954 * sp[27] + 50.51814855409123 * sp[30];
    A[165] = -6.833333333333296 * sp[33] + 2.416666666666688 * sp[34] + 0.08333333333333626 * sp[28] + 0.08333333333330165 * sp[31] + 1.583333333333356 * sp[34] + 3.75 * sp[35] + -4.916666666666648 * sp[29] + 0.5833333333333746 * sp[32] + 0.08333333333332993 * sp[28] + -1.250000000000026 * sp[29] + -5.916666666666671 * sp[26] + -0.9166666666666471 * sp[27] + 0.08333333333335347 * sp[31] + 0.08333333333337967 * sp[32] + -10.91666666666674 * sp[27] + -1.833333333333316 * sp[30];
    A[166] = 11.16666666666665 * sp[33] + -8.166666666666682 * sp[34] + 3.166666666666671 * sp[28] + 3.166666666666742 * sp[31] + 1.833333333333331 * sp[34] + -16.66666666666669 * sp[35] + 10.66666666666667 * sp[29] + -7.833333333333408 * sp[32] + -5.16666666666671 * sp[28] + 3.333333333333397 * sp[29] + 2.666666666666657 * sp[26] + -4.833333333333375 * sp[27] + -5.166666666666719 * sp[31] + -5.166666666666727 * sp[32] + 10.16666666666671 * sp[27] + -17.16666666666676 * sp[30];
    A[167] = 4.833333333333341 * sp[33] + 14.91666666666671 * sp[34] + -4.083333333333367 * sp[28] + -4.083333333333377 * sp[31] + 2.416666666666672 * sp[34] + 22.91666666666672 * sp[35] + -5.750000000000019 * sp[29] + 11.41666666666673 * sp[32] + -4.083333333333371 * sp[28] + -12.08333333333344 * sp[29] + 3.250000000000037 * sp[26] + 4.916666666666705 * sp[27] + -4.083333333333368 * sp[31] + -4.083333333333358 * sp[32] + 1.583333333333339 * sp[27] + 19.83333333333344 * sp[30];
    A[168] = -3.58333333333338 * sp[33] + -7.00000000000003 * sp[34] + -2.666666666666694 * sp[28] + -7.000000000000001 * sp[31] + -4.916666666666693 * sp[34] + -7.708333333333353 * sp[35] + 4.45833333333327 * sp[29] + 2.16666666666661 * sp[32] + 6.583333333333394 * sp[28] + 7.291666666666718 * sp[29] + 5.458333333333393 * sp[26] + 6.166666666666715 * sp[27] + 6.58333333333337 * sp[31] + 6.583333333333331 * sp[32] + 6.583333333333402 * sp[27] + 6.916666666666698 * sp[30];
    A[169] = 9.666666666666698 * sp[33] + 17.33333333333339 * sp[34] + 6.99999999999998 * sp[28] + 17.33333333333334 * sp[31] + 4.83333333333335 * sp[34] + 24.58333333333341 * sp[35] + -11.41666666666667 * sp[29] + -2.666666666666658 * sp[32] + -8.166666666666746 * sp[28] + -15.4166666666668 * sp[29] + -3.416666666666697 * sp[26] + -10.66666666666677 * sp[27] + -8.166666666666735 * sp[31] + -8.166666666666705 * sp[32] + -8.16666666666673 * sp[27] + -18.00000000000013 * sp[30];
    A[170] = 5.583333333333327 * sp[33] + -10.33333333333336 * sp[34] + 10.66666666666667 * sp[28] + -10.33333333333336 * sp[31] + 0.9166666666666656 * sp[34] + -18.95833333333336 * sp[35] + 4.875000000000004 * sp[29] + 0.5 * sp[32] + -2.583333333333357 * sp[28] + 6.04166666666674 * sp[29] + -4.125000000000039 * sp[26] + 4.500000000000076 * sp[27] + -2.583333333333361 * sp[31] + -2.583333333333357 * sp[32] + -2.583333333333353 * sp[27] + 11.08333333333336 * sp[30];
    A[171] = -1.083333333333322 * sp[33] + -2.416666666666624 * sp[34] + -2.416666666666699 * sp[28] + -2.416666666666686 * sp[31] + 12.16666666666666 * sp[34] + 27.95833333333339 * sp[35] + -2.208333333333337 * sp[29] + 8.083333333333396 * sp[32] + -1.833333333333329 * sp[28] + -2.041666666666648 * sp[29] + 1.791666666666702 * sp[26] + 1.583333333333364 * sp[27] + 1.999999999999993 * sp[31] + 14.33333333333349 * sp[32] + 1.999999999999989 * sp[27] + 9.416666666666753 * sp[30];
    A[172] = -2.000000000000008 * sp[33] + -0.1666666666666682 * sp[34] + -0.1666666666666607 * sp[28] + -0.1666666666666419 * sp[31] + -2.666666666666618 * sp[34] + -8.416666666666707 * sp[35] + 3.583333333333318 * sp[29] + -1.166666666666722 * sp[32] + 5.333333333333316 * sp[28] + 1.583333333333315 * sp[29] + 5.583333333333335 * sp[26] + 1.833333333333308 * sp[27] + 9.333333333333382 * sp[31] + 2.999999999999943 * sp[32] + 9.333333333333428 * sp[27] + 3.666666666666634 * sp[30];
    A[173] = 3.083333333333327 * sp[33] + -1.583333333333413 * sp[34] + -1.583333333333336 * sp[28] + -1.583333333333393 * sp[31] + -9.500000000000039 * sp[34] + 13.3750000000001 * sp[35] + -8.458333333333336 * sp[29] + 3.91666666666673 * sp[32] + -3.499999999999986 * sp[28] + 3.375000000000035 * sp[29] + -4.45833333333333 * sp[26] + 2.416666666666701 * sp[27] + -11.33333333333337 * sp[31] + 17.66666666666676 * sp[32] + -11.33333333333339 * sp[27] + 8.5833333333334 * sp[30];
    A[174] = 25.92724864350687 * sp[33] + 37.71236166328274 * sp[34] + 9.428090415820623 * sp[28] + 9.428090415820767 * sp[31] + 16.49915822768617 * sp[34] + -64.818121608767 * sp[35] + 20.03469213361892 * sp[29] + -18.85618083164135 * sp[32] + -25.92724864350699 * sp[28] + -36.53385036130523 * sp[29] + -8.249579113843076 * sp[26] + -18.85618083164131 * sp[27] + -25.92724864350693 * sp[31] + -124.9221980096239 * sp[32] + 2.357022603955048 * sp[27] + -58.92556509887913 * sp[30];
    A[175] = -31.75426480542914 * sp[33] + -7.216878364869808 * sp[34] + 1.443375672973913 * sp[28] + 1.443375672974196 * sp[31] + 105.3664241271068 * sp[34] + 57.73502691896252 * sp[35] + 23.09401076758508 * sp[29] + 10.10362971081854 * sp[32] + -7.216878364870505 * sp[28] + -28.86751345948137 * sp[29] + 5.77350269189637 * sp[26] + -15.87713240271465 * sp[27] + -7.216878364870297 * sp[31] + -50.51814855409192 * sp[32] + 27.42413778650713 * sp[27] + -31.7542648054293 * sp[30];
    A[176] = 53.33333333333327 * sp[33] + 14.16666666666668 * sp[34] + -30.8333333333336 * sp[28] + -30.83333333333362 * sp[31] + 14.16666666666668 * sp[34] + 219.1666666666672 * sp[35] + -30.83333333333351 * sp[29] + 84.16666666666708 * sp[32] + -30.8333333333336 * sp[28] + -30.83333333333351 * sp[29] + 39.16666666666698 * sp[26] + 39.16666666666693 * sp[27] + -30.83333333333362 * sp[31] + 84.16666666666708 * sp[32] + 39.16666666666693 * sp[27] + 153.3333333333341 * sp[30];
    A[177] = -58.925565098879 * sp[33] + -25.92724864350686 * sp[34] + -40.0693842672375 * sp[28] + 2.357022603955259 * sp[31] + -18.85618083164132 * sp[34] + -22.39171473757423 * sp[35] + 5.89255650988807 * sp[29] + -11.78511301977596 * sp[32] + 37.71236166328289 * sp[28] + 34.17682775734998 * sp[29] + 5.892556509887845 * sp[26] + 2.357022603955056 * sp[27] + 37.71236166328288 * sp[31] + 37.71236166328279 * sp[32] + 9.428090415820748 * sp[27] + -2.357022603955135 * sp[30];
    A[178] = 12.99038105676652 * sp[33] + -4.330127018922287 * sp[34] + -4.330127018922328 * sp[28] + -12.99038105676668 * sp[31] + -25.98076211353313 * sp[34] + 10.8253175473055 * sp[35] + 2.165063509460644 * sp[29] + 12.99038105676641 * sp[32] + 25.98076211353321 * sp[28] + 10.82531754730552 * sp[29] + 36.80607966083884 * sp[26] + 21.65063509461096 * sp[27] + 25.9807621135331 * sp[31] + 25.98076211353289 * sp[32] + -8.660254037843963 * sp[27] + 12.99038105676631 * sp[30];
    A[179] = -104.1666666666667 * sp[33] + -45.83333333333348 * sp[34] + -55.83333333333314 * sp[28] + -0.8333333333331343 * sp[31] + -33.33333333333341 * sp[34] + -39.58333333333351 * sp[35] + 5.41666666666668 * sp[29] + -25.8333333333337 * sp[32] + 66.66666666666724 * sp[28] + 60.41666666666695 * sp[29] + 5.416666666666784 * sp[26] + -0.83333333333346 * sp[27] + 66.66666666666723 * sp[31] + 66.66666666666717 * sp[32] + -3.333333333333288 * sp[27] + -104.1666666666668 * sp[30];
    A[180] = 5.892556509887858 * sp[33] + -3.299831645537259 * sp[34] + 0.4714045207910408 * sp[28] + 0.4714045207910679 * sp[31] + -1.649915822768615 * sp[34] + -2.474873734152936 * sp[35] + -2.003469213361904 * sp[29] + 0.4714045207910286 * sp[32] + 16.73486048808165 * sp[28] + 3.18198051533951 * sp[29] + -7.660323462854283 * sp[26] + -5.185449728701313 * sp[27] + 4.006938426723795 * sp[31] + 4.006938426723844 * sp[32] + -10.13519719700728 * sp[27] + -4.00693842672379 * sp[30];
    A[181] = -11.78511301977579 * sp[33] + 8.956685895029638 * sp[34] + -3.299831645537237 * sp[28] + -3.299831645537299 * sp[31] + -3.771236166328271 * sp[34] + 2.592724864350739 * sp[35] + 1.649915822768597 * sp[29] + -3.299831645537268 * sp[32] + -12.25651754056681 * sp[28] + 5.421151989096817 * sp[29] + -1.178511301977565 * sp[26] + -6.128258770283502 * sp[27] + -0.9428090415820558 * sp[31] + -0.9428090415821058 * sp[32] + 3.771236166328298 * sp[27] + -3.771236166328302 * sp[30];
    A[182] = -5.892556509887918 * sp[33] + -17.44196726926824 * sp[34] + 5.185449728701396 * sp[28] + 5.1854497287014 * sp[31] + -4.006938426723787 * sp[34] + -10.72445284799604 * sp[35] + 3.889087296526026 * sp[29] + 5.185449728701377 * sp[32] + 0.2357022603955474 * sp[28] + -5.067598598503547 * sp[29] + -1.767766952966375 * sp[26] + -0.4714045207910003 * sp[27] + 1.649915822768635 * sp[31] + 1.649915822768648 * sp[32] + -3.064129385141746 * sp[27] + -1.64991582276861 * sp[30];
    A[183] = 5.892556509887958 * sp[33] + 9.192388155425171 * sp[34] + 5.421151989096901 * sp[28] + 9.192388155425133 * sp[31] + 7.542472332656531 * sp[34] + 8.367430244040824 * sp[35] + 5.067598598503629 * sp[29] + 5.892556509887911 * sp[32] + -10.84230397819376 * sp[28] + -4.360491817317086 * sp[29] + -18.97403196183906 * sp[26] + -6.835365551470018 * sp[27] + -5.185449728701392 * sp[31] + -5.185449728701421 * sp[32] + -5.185449728701348 * sp[27] + -4.006938426723801 * sp[30];
    A[184] = -11.78511301977585 * sp[33] + -20.74179891480549 * sp[34] + -8.485281374238557 * sp[28] + -20.74179891480542 * sp[31] + -8.013876853447577 * sp[34] + -14.37783788412654 * sp[35] + -3.064129385141707 * sp[29] + -9.428090415820691 * sp[32] + 0.4714045207910789 * sp[28] + -3.064129385141652 * sp[29] + 2.592724864350706 * sp[26] + 1.885618083164136 * sp[27] + 3.29983164553727 * sp[31] + 3.29983164553728 * sp[32] + 3.299831645537237 * sp[27] + 5.656854249492365 * sp[30];
    A[185] = -5.892556509887897 * sp[33] + 11.54941075938032 * sp[34] + -11.07800623858926 * sp[28] + 11.54941075938032 * sp[31] + -1.885618083164137 * sp[34] + 4.831896338108142 * sp[35] + -3.181980515339478 * sp[29] + 3.535533905932827 * sp[32] + -6.128258770283405 * sp[28] + 6.246109900481134 * sp[29] + -13.08147545195112 * sp[26] + 4.9497474683058 * sp[27] + -0.4714045207910272 * sp[31] + -0.4714045207910607 * sp[32] + -0.4714045207910047 * sp[27] + -1.649915822768633 * sp[30];
    A[186] = 2.357022603955151 * sp[33] + 4.006938426723725 * sp[34] + 4.006938426723819 * sp[28] + 4.006938426723799 * sp[31] + 0.2357022603954935 * sp[34] + -0.2357022603955206 * sp[35] + 4.478342947514796 * sp[29] + 4.006938426723767 * sp[32] + -11.07800623858926 * sp[28] + -12.96362432175338 * sp[29] + -8.249579113843071 * sp[26] + -8.720983634634086 * sp[27] + -7.778174593052068 * sp[31] + -8.720983634634067 * sp[32] + -7.778174593052099 * sp[27] + -7.542472332656554 * sp[30];
    A[187] = -0.9428090415820616 * sp[34] + -0.9428090415820854 * sp[28] + -0.9428090415820957 * sp[31] + 1.885618083164124 * sp[34] + 0.4714045207910442 * sp[35] + 0.4714045207910635 * sp[29] + -0.9428090415820469 * sp[32] + 24.51303508113369 * sp[28] + 11.78511301977578 * sp[29] + 11.78511301977582 * sp[26] + 10.37089945740267 * sp[27] + 13.19932658214895 * sp[31] + 5.656854249492392 * sp[32] + 13.19932658214901 * sp[27] + 8.013876853447584 * sp[30];
    A[188] = -2.357022603955149 * sp[33] + 1.649915822768694 * sp[34] + 1.649915822768623 * sp[28] + 1.649915822768672 * sp[31] + -2.121320343559615 * sp[34] + 2.121320343559693 * sp[35] + -2.592724864350672 * sp[29] + 1.649915822768643 * sp[32] + -13.43502884254444 * sp[28] + 3.535533905932814 * sp[29] + -1.17851130197759 * sp[26] + 3.064129385141784 * sp[27] + -5.421151989096883 * sp[31] + 3.06412938514173 * sp[32] + -5.421151989096922 * sp[27] + 1.88561808316416 * sp[30];
    A[189] = -33.33333333333353 * sp[33] + -46.66666666666694 * sp[34] + -6.666666666666642 * sp[28] + -6.666666666666787 * sp[31] + -26.66666666666678 * sp[34] + -36.66666666666686 * sp[35] + 3.333333333333215 * sp[29] + -6.666666666666837 * sp[32] + 13.33333333333344 * sp[28] + 3.333333333333272 * sp[29] + -36.66666666666669 * sp[26] + -46.66666666666683 * sp[27] + 13.33333333333348 * sp[31] + 13.33333333333336 * sp[32] + -26.66666666666688 * sp[27] + -33.33333333333358 * sp[30];
    A[190] = 28.57738033247015 * sp[33] + 8.164965809276708 * sp[34] + 8.164965809277481 * sp[28] + 8.164965809277188 * sp[31] + -4.082482904639212 * sp[34] + -22.45365597551276 * sp[35] + 26.53613888015094 * sp[29] + 8.164965809277039 * sp[32] + 69.40220937885675 * sp[28] + -22.45365597551264 * sp[29] + -71.44345083117607 * sp[26] + -89.8146239020501 * sp[27] + -4.082482904638992 * sp[31] + -28.57738033247038 * sp[32] + -53.07227776030265 * sp[27] + -69.40220937885721 * sp[30];
    A[191] = -58.925565098879 * sp[33] + -18.85618083164132 * sp[34] + 37.71236166328289 * sp[28] + 37.71236166328288 * sp[31] + -25.92724864350686 * sp[34] + -22.39171473757423 * sp[35] + 34.17682775734998 * sp[29] + 37.71236166328279 * sp[32] + -40.0693842672375 * sp[28] + 5.89255650988807 * sp[29] + 5.892556509887845 * sp[26] + 9.428090415820748 * sp[27] + 2.357022603955259 * sp[31] + -11.78511301977596 * sp[32] + 2.357022603955056 * sp[27] + -2.357022603955135 * sp[30];
    A[192] = 66.6666666666668 * sp[33] + 33.3333333333335 * sp[34] + 33.33333333333313 * sp[28] + -6.666666666666828 * sp[31] + 33.3333333333335 * sp[34] + 33.33333333333336 * sp[35] + -6.666666666666694 * sp[29] + -6.666666666666714 * sp[32] + 33.33333333333313 * sp[28] + -6.666666666666694 * sp[29] + 113.3333333333334 * sp[26] + 33.33333333333345 * sp[27] + -6.666666666666828 * sp[31] + -6.666666666666714 * sp[32] + 33.33333333333345 * sp[27] + 26.66666666666701 * sp[30];
    A[193] = 12.24744871391606 * sp[34] + 12.24744871391603 * sp[28] + 12.24744871391603 * sp[31] + 36.7423461417476 * sp[34] + 24.49489742783169 * sp[35] + 24.49489742783175 * sp[29] + 12.24744871391586 * sp[32] + -110.2270384252433 * sp[28] + -48.98979485566382 * sp[29] + -48.9897948556637 * sp[26] + 36.74234614174746 * sp[27] + -36.74234614174792 * sp[31] + -36.7423461417482 * sp[32] + 12.24744871391594 * sp[27] + 24.49489742783153 * sp[30];
    A[194] = 117.8511301977581 * sp[33] + 58.92556509887918 * sp[34] + 58.92556509887884 * sp[28] + 2.357022603954942 * sp[31] + 58.9255650988792 * sp[34] + 58.92556509887895 * sp[35] + 2.357022603955189 * sp[29] + 2.357022603954551 * sp[32] + 58.92556509887857 * sp[28] + -11.78511301977582 * sp[29] + 44.78342947514785 * sp[26] + -11.78511301977587 * sp[27] + -11.78511301977606 * sp[31] + -11.78511301977586 * sp[32] + -11.78511301977596 * sp[27] + -9.428090415820863 * sp[30];
    A[195] = -16.88749537379661 * sp[33] + -5.19615242270669 * sp[34] + 5.196152422706653 * sp[28] + 5.196152422706613 * sp[31] + -7.361215932167767 * sp[34] + -6.27868417743729 * sp[35] + 11.90784930203618 * sp[29] + 5.19615242270666 * sp[32] + -7.361215932167767 * sp[28] + 4.979646071760497 * sp[29] + -21.86714144555715 * sp[26] + -1.732050807568863 * sp[27] + 3.897114317029962 * sp[31] + 3.897114317029931 * sp[32] + -15.15544456622761 * sp[27] + -3.897114317029907 * sp[30];
    A[196] = 7.794228634059974 * sp[33] + -2.598076211353272 * sp[34] + 2.598076211353312 * sp[28] + 2.598076211353392 * sp[31] + 1.732050807568876 * sp[34] + -0.4330127018921157 * sp[35] + -2.165063509461183 * sp[29] + 2.598076211353411 * sp[32] + 1.732050807568884 * sp[28] + -5.629165124598753 * sp[29] + 13.42339375865885 * sp[26] + -0.8660254037845683 * sp[27] + -3.464101615137769 * sp[31] + -3.464101615137683 * sp[32] + 8.66025403784437 * sp[27] + -5.196152422706634 * sp[30];
    A[197] = -3.897114317030002 * sp[33] + -5.196152422706641 * sp[34] + 5.196152422706636 * sp[28] + 5.196152422706609 * sp[31] + -3.031088913245562 * sp[34] + -4.113620667976137 * sp[35] + 5.412658773652787 * sp[29] + 5.196152422706597 * sp[32] + -3.031088913245569 * sp[28] + -1.515544456622865 * sp[29] + -2.381569860407207 * sp[26] + -1.732050807568815 * sp[27] + -0.4330127018922387 * sp[31] + -0.4330127018922822 * sp[32] + -2.165063509461071 * sp[27] + 0.433012701892211 * sp[30];
    A[198] = 16.8874953737966 * sp[33] + 11.69134295108995 * sp[34] + 22.08364779650325 * sp[28] + 11.69134295108997 * sp[31] + 9.526279441628873 * sp[34] + 10.60881119635945 * sp[35] + 2.814582562299458 * sp[29] + 3.897114317030015 * sp[32] + 9.526279441628873 * sp[28] + -0.6495190528383041 * sp[29] + 36.58957330989252 * sp[26] + 19.48557158514986 * sp[27] + -1.732050807568834 * sp[31] + -1.732050807568833 * sp[32] + -1.732050807568889 * sp[27] + 0.433012701892217 * sp[30];
    A[199] = -7.794228634059991 * sp[33] + -10.39230484541328 * sp[34] + -5.196152422706656 * sp[28] + -10.39230484541324 * sp[31] + -6.062177826491124 * sp[34] + -8.227241335952233 * sp[35] + -1.29903810567668 * sp[29] + -3.464101615137741 * sp[32] + -6.062177826491125 * sp[28] + -3.031088913245635 * sp[29] + -16.88749537379652 * sp[26] + -17.32050807568881 * sp[27] + -0.866025403784477 * sp[31] + -0.8660254037845074 * sp[32] + -0.8660254037844425 * sp[27] + 3.464101615137742 * sp[30];
    A[200] = 3.897114317029984 * sp[33] + -1.299038105676636 * sp[34] + 9.093266739736638 * sp[28] + -1.299038105676618 * sp[31] + 0.8660254037844378 * sp[34] + -0.2165063509460357 * sp[35] + 0.6495190528383108 * sp[29] + -0.4330127018921535 * sp[32] + 0.8660254037844392 * sp[28] + -2.814582562299329 * sp[29] + 8.443747686898289 * sp[26] + -2.165063509461001 * sp[27] + -1.732050807568883 * sp[31] + -1.732050807568809 * sp[32] + -1.732050807568887 * sp[27] + -3.89711431702996 * sp[30];
    A[201] = 10.39230484541329 * sp[33] + 11.69134295108995 * sp[34] + 11.69134295108995 * sp[28] + 11.69134295108994 * sp[31] + 7.361215932167795 * sp[34] + 6.062177826491061 * sp[35] + 12.99038105676667 * sp[29] + 11.69134295108997 * sp[32] + 7.361215932167656 * sp[28] + 12.99038105676651 * sp[29] + -7.794228634059944 * sp[26] + -3.897114317029983 * sp[27] + -6.495190528383262 * sp[31] + -8.227241335952183 * sp[32] + -6.495190528383223 * sp[27] + -6.06217782649103 * sp[30];
    A[202] = -20.78460969082661 * sp[33] + -10.39230484541328 * sp[34] + -10.39230484541329 * sp[28] + -10.39230484541326 * sp[31] + -10.39230484541341 * sp[34] + -3.464101615137794 * sp[35] + -17.32050807568895 * sp[29] + -10.39230484541333 * sp[32] + -10.39230484541319 * sp[28] + -17.32050807568873 * sp[29] + 24.24871130596435 * sp[26] + 3.464101615137767 * sp[27] + 17.32050807568873 * sp[31] + 3.464101615137695 * sp[32] + 17.32050807568868 * sp[27] + 7.794228634059853 * sp[30];
    A[203] = 10.39230484541333 * sp[33] + -1.299038105676702 * sp[34] + -1.29903810567665 * sp[28] + -1.299038105676719 * sp[31] + 3.031088913245617 * sp[34] + -2.598076211353367 * sp[35] + 4.330127018922294 * sp[29] + -1.299038105676716 * sp[32] + 3.03108891324553 * sp[28] + 4.330127018922297 * sp[29] + -16.45448267190439 * sp[26] + 0.4330127018923136 * sp[27] + -10.82531754730546 * sp[31] + 4.76313972081441 * sp[32] + -10.82531754730545 * sp[27] + 2.598076211353348 * sp[30];
    A[204] = -36.74234614174778 * sp[33] + -36.74234614174761 * sp[34] + 36.74234614174776 * sp[28] + 36.74234614174787 * sp[31] + -24.49489742783195 * sp[34] + -30.61862178478958 * sp[35] + 42.86607049870585 * sp[29] + 36.74234614174811 * sp[32] + -24.49489742783192 * sp[28] + -6.123724356958228 * sp[29] + -30.61862178478975 * sp[26] + -12.24744871391629 * sp[27] + -24.49489742783155 * sp[27] + -36.74234614174739 * sp[30];
    A[205] = -67.50000000000026 * sp[33] + 90.00000000000014 * sp[28] + 90.00000000000033 * sp[31] + 7.500000000000107 * sp[34] + 3.7500000000001 * sp[35] + 93.75000000000045 * sp[29] + 90.00000000000071 * sp[32] + 7.499999999998941 * sp[28] + 48.7499999999992 * sp[29] + -41.24999999999996 * sp[26] + -30.00000000000059 * sp[27] + 52.50000000000017 * sp[31] + -22.49999999999988 * sp[32] + -37.49999999999952 * sp[27] + -67.49999999999957 * sp[30];
    A[206] = 12.99038105676652 * sp[33] + -25.98076211353313 * sp[34] + 25.98076211353321 * sp[28] + 25.9807621135331 * sp[31] + -4.330127018922287 * sp[34] + 10.8253175473055 * sp[35] + 10.82531754730552 * sp[29] + 25.98076211353289 * sp[32] + -4.330127018922328 * sp[28] + 2.165063509460644 * sp[29] + 36.80607966083884 * sp[26] + -8.660254037843963 * sp[27] + -12.99038105676668 * sp[31] + 12.99038105676641 * sp[32] + 21.65063509461096 * sp[27] + 12.99038105676631 * sp[30];
    A[207] = 36.7423461417476 * sp[34] + -110.2270384252433 * sp[28] + -36.74234614174792 * sp[31] + 12.24744871391606 * sp[34] + 24.49489742783169 * sp[35] + -48.98979485566382 * sp[29] + -36.7423461417482 * sp[32] + 12.24744871391603 * sp[28] + 24.49489742783175 * sp[29] + -48.9897948556637 * sp[26] + 12.24744871391594 * sp[27] + 12.24744871391603 * sp[31] + 12.24744871391586 * sp[32] + 36.74234614174746 * sp[27] + 24.49489742783153 * sp[30];
    A[208] = 135.0000000000004 * sp[33] + 67.50000000000028 * sp[34] + 67.50000000000026 * sp[28] + -22.49999999999982 * sp[31] + 67.50000000000028 * sp[34] + 67.50000000000057 * sp[35] + -22.5000000000001 * sp[29] + -22.49999999999982 * sp[32] + 67.50000000000026 * sp[28] + -22.5000000000001 * sp[29] + 247.4999999999996 * sp[26] + 67.4999999999999 * sp[27] + -22.49999999999982 * sp[31] + -22.49999999999982 * sp[32] + 67.4999999999999 * sp[27] + 59.99999999999985 * sp[30];
    A[209] = 64.95190528383273 * sp[34] + -38.97114317029978 * sp[28] + 12.99038105676648 * sp[31] + 21.65063509461122 * sp[34] + 43.30127018922171 * sp[35] + -8.660254037844119 * sp[29] + 12.99038105676665 * sp[32] + 21.65063509461119 * sp[28] + 43.30127018922188 * sp[29] + -8.660254037844755 * sp[26] + 99.59292143520946 * sp[27] + 21.65063509461119 * sp[31] + 21.65063509461092 * sp[32] + -12.99038105676659 * sp[27] + 43.30127018922225 * sp[30];
    A[210] = 10.4166666666666 * sp[33] + -5.833333333333393 * sp[34] + 0.8333333333333518 * sp[28] + 0.8333333333333967 * sp[31] + -2.91666666666667 * sp[34] + -4.375000000000025 * sp[35] + -3.541666666666715 * sp[29] + 0.8333333333333248 * sp[32] + 10.0833333333333 * sp[28] + -2.87500000000004 * sp[29] + 7.95833333333344 * sp[26] + 1.833333333333387 * sp[27] + -1.416666666666679 * sp[31] + -1.416666666666768 * sp[32] + 3.583333333333344 * sp[27] + 2.916666666666655 * sp[30];
    A[211] = -20.83333333333333 * sp[33] + 15.83333333333339 * sp[34] + -5.833333333333361 * sp[28] + -5.833333333333465 * sp[31] + -6.666666666666693 * sp[34] + 4.583333333333429 * sp[35] + 2.916666666666656 * sp[29] + -5.833333333333423 * sp[32] + -12.66666666666664 * sp[28] + 11.58333333333335 * sp[29] + -10.08333333333342 * sp[26] + 2.166666666666629 * sp[27] + 0.333333333333372 * sp[31] + 0.3333333333335551 * sp[32] + -1.333333333333369 * sp[27] + 13.33333333333325 * sp[30];
    A[212] = -10.4166666666667 * sp[33] + -30.83333333333344 * sp[34] + 9.166666666666744 * sp[28] + 9.16666666666675 * sp[31] + -7.083333333333357 * sp[34] + -18.95833333333342 * sp[35] + 6.875000000000014 * sp[29] + 9.166666666666721 * sp[32] + -4.083333333333324 * sp[28] + -12.45833333333335 * sp[29] + 3.375000000000051 * sp[26] + 0.1666666666666843 * sp[27] + -0.5833333333333142 * sp[31] + -0.5833333333333824 * sp[32] + 1.083333333333319 * sp[27] + -12.91666666666668 * sp[30];
    A[213] = 10.41666666666677 * sp[33] + 16.25000000000008 * sp[34] + 9.583333333333396 * sp[28] + 16.25000000000002 * sp[31] + 13.33333333333336 * sp[34] + 14.79166666666667 * sp[35] + 8.958333333333405 * sp[29] + 10.41666666666669 * sp[32] + 0.3333333333333561 * sp[28] + 3.291666666666704 * sp[29] + 7.458333333333298 * sp[26] + 9.416666666666636 * sp[27] + 1.833333333333298 * sp[31] + 1.833333333333319 * sp[32] + 1.833333333333304 * sp[27] + 2.916666666666619 * sp[30];
    A[214] = -20.83333333333343 * sp[33] + -36.66666666666681 * sp[34] + -14.99999999999997 * sp[28] + -36.66666666666671 * sp[31] + -14.16666666666672 * sp[34] + -25.41666666666675 * sp[35] + -5.416666666666677 * sp[29] + -16.66666666666676 * sp[32] + -8.166666666666671 * sp[28] + -12.41666666666669 * sp[29] + -12.41666666666661 * sp[26] + -24.66666666666663 * sp[27] + -1.166666666666627 * sp[31] + -1.166666666666674 * sp[32] + -1.166666666666615 * sp[27] + 10.00000000000003 * sp[30];
    A[215] = -10.41666666666667 * sp[33] + 20.41666666666674 * sp[34] + -19.58333333333336 * sp[28] + 20.41666666666675 * sp[31] + -3.333333333333347 * sp[34] + 8.541666666666764 * sp[35] + -5.625000000000014 * sp[29] + 6.250000000000159 * sp[32] + -6.333333333333321 * sp[28] + 12.04166666666667 * sp[29] + -12.12500000000002 * sp[26] + 15.25 * sp[27] + 0.1666666666666863 * sp[31] + 0.1666666666668286 * sp[32] + 0.1666666666666858 * sp[27] + -12.91666666666645 * sp[30];
    A[216] = 4.166666666666655 * sp[33] + 7.083333333333258 * sp[34] + 7.083333333333412 * sp[28] + 7.083333333333381 * sp[31] + 0.4166666666666341 * sp[34] + -0.416666666666651 * sp[35] + 7.916666666666644 * sp[29] + 7.083333333333328 * sp[32] + 8.416666666666677 * sp[28] + 13.58333333333326 * sp[29] + 1.916666666666736 * sp[26] + 3.083333333333362 * sp[27] + 2.749999999999961 * sp[31] + -8.916666666666835 * sp[32] + 2.749999999999966 * sp[27] + -3.333333333333436 * sp[30];
    A[217] = -1.666666666666667 * sp[34] + -1.666666666666705 * sp[28] + -1.666666666666722 * sp[31] + 3.333333333333329 * sp[34] + 0.8333333333333508 * sp[35] + 0.8333333333334063 * sp[29] + -1.666666666666631 * sp[32] + -12.66666666666671 * sp[28] + -7.16666666666665 * sp[29] + -7.166666666666799 * sp[26] + -3.666666666666728 * sp[27] + -4.666666666666685 * sp[31] + -7.999999999999927 * sp[32] + -4.666666666666658 * sp[27] + -5.833333333333255 * sp[30];
    A[218] = -4.16666666666664 * sp[33] + 2.916666666666811 * sp[34] + 2.916666666666691 * sp[28] + 2.916666666666773 * sp[31] + -3.749999999999956 * sp[34] + 3.750000000000104 * sp[35] + -4.583333333333339 * sp[29] + 2.916666666666727 * sp[32] + 4.250000000000033 * sp[28] + -2.24999999999996 * sp[29] + 9.41666666666676 * sp[26] + -1.083333333333296 * sp[27] + 1.916666666666723 * sp[31] + -13.0833333333332 * sp[32] + 1.916666666666706 * sp[27] + -6.666666666666606 * sp[30];
    A[219] = -58.92556509887927 * sp[33] + -82.49579113843097 * sp[34] + -11.78511301977575 * sp[28] + -11.785113019776 * sp[31] + -47.14045207910331 * sp[34] + -64.81812160876723 * sp[35] + 5.89255650988768 * sp[29] + -11.78511301977614 * sp[32] + -18.85618083164129 * sp[28] + -22.39171473757406 * sp[29] + -8.249579113842914 * sp[26] + 16.49915822768617 * sp[27] + -4.714045207910209 * sp[31] + 80.13876853447543 * sp[32] + 9.428090415820522 * sp[27] + 54.2115198909682 * sp[30];
    A[220] = 50.51814855409172 * sp[33] + 14.43375672973969 * sp[34] + 14.43375672974099 * sp[28] + 14.4337567297405 * sp[31] + -7.21687836487132 * sp[34] + -39.69283100678724 * sp[35] + 46.90970937165675 * sp[29] + 14.43375672974019 * sp[32] + 44.74464586219592 * sp[28] + 72.89047148518972 * sp[29] + -13.71206889325328 * sp[26] + 31.75426480542954 * sp[27] + 105.3664241271053 * sp[31] + 62.06515393788342 * sp[32] + 18.7638837486625 * sp[27] + 50.51814855409123 * sp[30];
    A[221] = -104.1666666666667 * sp[33] + -33.33333333333341 * sp[34] + 66.66666666666724 * sp[28] + 66.66666666666723 * sp[31] + -45.83333333333348 * sp[34] + -39.58333333333351 * sp[35] + 60.41666666666695 * sp[29] + 66.66666666666717 * sp[32] + -55.83333333333314 * sp[28] + 5.41666666666668 * sp[29] + 5.416666666666784 * sp[26] + -3.333333333333288 * sp[27] + -0.8333333333331343 * sp[31] + -25.8333333333337 * sp[32] + -0.83333333333346 * sp[27] + -104.1666666666668 * sp[30];
    A[222] = 117.8511301977581 * sp[33] + 58.9255650988792 * sp[34] + 58.92556509887857 * sp[28] + -11.78511301977606 * sp[31] + 58.92556509887918 * sp[34] + 58.92556509887895 * sp[35] + -11.78511301977582 * sp[29] + -11.78511301977586 * sp[32] + 58.92556509887884 * sp[28] + 2.357022603955189 * sp[29] + 44.78342947514785 * sp[26] + -11.78511301977596 * sp[27] + 2.357022603954942 * sp[31] + 2.357022603954551 * sp[32] + -11.78511301977587 * sp[27] + -9.428090415820863 * sp[30];
    A[223] = 21.65063509461122 * sp[34] + 21.65063509461119 * sp[28] + 21.65063509461119 * sp[31] + 64.95190528383273 * sp[34] + 43.30127018922171 * sp[35] + 43.30127018922188 * sp[29] + 21.65063509461092 * sp[32] + -38.97114317029978 * sp[28] + -8.660254037844119 * sp[29] + -8.660254037844755 * sp[26] + -12.99038105676659 * sp[27] + 12.99038105676648 * sp[31] + 12.99038105676665 * sp[32] + 99.59292143520946 * sp[27] + 43.30127018922225 * sp[30];
    A[224] = 208.3333333333335 * sp[33] + 104.166666666667 * sp[34] + 104.1666666666664 * sp[28] + 4.166666666666242 * sp[31] + 104.166666666667 * sp[34] + 104.1666666666665 * sp[35] + 4.166666666666703 * sp[29] + 4.166666666665517 * sp[32] + 104.1666666666664 * sp[28] + 4.166666666666703 * sp[29] + 104.1666666666666 * sp[26] + 4.166666666666611 * sp[27] + 4.166666666666242 * sp[31] + 4.166666666665517 * sp[32] + 4.166666666666611 * sp[27] + 183.3333333333314 * sp[30];
  }

};


class forms_cell_integral_1_otherwise: public ufc::cell_integral
{
public:

  forms_cell_integral_1_otherwise() : ufc::cell_integral()
  {

  }

  ~forms_cell_integral_1_otherwise() override
  {

  }

  const std::vector<bool> & enabled_coefficients() const final override
  {
static const std::vector<bool> enabled({});
return enabled;
  }

  void tabulate_tensor(double * A,
                       const double * const * w,
                       const double * coordinate_dofs,
                       int cell_orientation) const final override
  {
    // This function was generated using 'uflacs' representation
    // with the following integrals metadata:
    // 
    // num_cells:         None
    // optimize:          True
    // precision:         16
    // quadrature_degree: 6
    // quadrature_rule:   'default'
    // representation:    'uflacs'
    // 
    // and the following integral 0 metadata:
    // 
    // estimated_polynomial_degree: 6
    // optimize:                    True
    // precision:                   16
    // quadrature_degree:           6
    // quadrature_rule:             'default'
    // representation:              'uflacs'
    // Precomputed values of basis functions and precomputations
    // FE* dimensions: [entities][points][dofs]
    // PI* dimensions: [entities][dofs][dofs] or [entities][dofs]
    // PM* dimensions: [entities][dofs][dofs]
    alignas(32) static const double FE3_C0_D01_Q12[1][1][2] = { { { -1.0, 1.0 } } };
    // Unstructured piecewise computations
    const double J_c0 = coordinate_dofs[0] * FE3_C0_D01_Q12[0][0][0] + coordinate_dofs[2] * FE3_C0_D01_Q12[0][0][1];
    const double J_c3 = coordinate_dofs[1] * FE3_C0_D01_Q12[0][0][0] + coordinate_dofs[5] * FE3_C0_D01_Q12[0][0][1];
    const double J_c1 = coordinate_dofs[0] * FE3_C0_D01_Q12[0][0][0] + coordinate_dofs[4] * FE3_C0_D01_Q12[0][0][1];
    const double J_c2 = coordinate_dofs[1] * FE3_C0_D01_Q12[0][0][0] + coordinate_dofs[3] * FE3_C0_D01_Q12[0][0][1];
    alignas(32) double sp[20];
    sp[0] = J_c0 * J_c3;
    sp[1] = J_c1 * J_c2;
    sp[2] = sp[0] + -1 * sp[1];
    sp[3] = J_c0 / sp[2];
    sp[4] = -1 * J_c1 / sp[2];
    sp[5] = sp[3] * sp[3];
    sp[6] = sp[3] * sp[4];
    sp[7] = sp[4] * sp[4];
    sp[8] = J_c3 / sp[2];
    sp[9] = -1 * J_c2 / sp[2];
    sp[10] = sp[9] * sp[9];
    sp[11] = sp[8] * sp[9];
    sp[12] = sp[8] * sp[8];
    sp[13] = sp[5] + sp[10];
    sp[14] = sp[6] + sp[11];
    sp[15] = sp[12] + sp[7];
    sp[16] = std::abs(sp[2]);
    sp[17] = sp[13] * sp[16];
    sp[18] = sp[14] * sp[16];
    sp[19] = sp[15] * sp[16];
    A[0] = 0.02162698412698433 * sp[19] + -0.01116071428571435 * sp[18] + -0.01116071428571435 * sp[18] + 0.05734126984127031 * sp[17];
    A[1] = -0.02986111111111121 * sp[19] + 0.005952380952380916 * sp[18] + 0.009920634920634981 * sp[18] + -0.04871031746031779 * sp[17];
    A[2] = 0.01765873015873013 * sp[19] + -0.004712301587301568 * sp[18] + -0.00471230158730159 * sp[18] + 0.0176587301587302 * sp[17];
    A[3] = -0.0154265873015874 * sp[19] + -0.0244791666666668 * sp[18] + 0.009052579365079369 * sp[18] + 0.01860119047619064 * sp[17];
    A[4] = 0.01746031746031742 * sp[19] + 0.0216765873015872 * sp[18] + -0.005704365079365075 * sp[18] + -0.01190476190476188 * sp[17];
    A[5] = -0.02385912698412701 * sp[19] + -0.03266369047619057 * sp[18] + 0.00682043650793654 * sp[18] + 0.01116071428571416 * sp[17];
    A[6] = -0.01314484126984128 * sp[19] + -0.008804563492063549 * sp[18] + 0.03067956349206368 * sp[18] + 0.02385912698412709 * sp[17];
    A[7] = 0.02777777777777798 * sp[19] + 0.01413690476190486 * sp[18] + -0.0727678571428578 * sp[18] + -0.06111111111111165 * sp[17];
    A[8] = -0.0205853174603176 * sp[19] + -0.007068452380952368 * sp[18] + 0.05820932539682575 * sp[18] + 0.05114087301587343 * sp[17];
    A[9] = 0.04349267900155113 * sp[19] + -0.02314932914598858 * sp[18] + -0.06243303921190629 * sp[18] + 0.03507474113028568 * sp[17];
    A[10] = 0.065295566158352 * sp[19] + -0.05154913117764585 * sp[18] + -0.1271545235715238 * sp[18] + 0.06529556615835101 * sp[17];
    A[11] = -0.01686507936508123 * sp[19] + -0.007440476190475988 * sp[18] + 0.07192460317460267 * sp[18] + -0.01091269841269927 * sp[17];
    A[12] = 0.03507474113028559 * sp[19] + 0.1283735525368423 * sp[18] + -0.01192541198429714 * sp[18] + -0.1248660784238149 * sp[17];
    A[13] = -0.1005208057964093 * sp[19] + -0.06314768569261563 * sp[18] + 0.07088005536926233 * sp[18] + -0.08505606644311386 * sp[17];
    A[14] = 0.06200396825396909 * sp[19] + 0.09598214285714174 * sp[18] + -0.02108134920634945 * sp[18] + 0.05307539682539866 * sp[17];
    A[15] = -0.02986111111111121 * sp[19] + 0.009920634920634981 * sp[18] + 0.005952380952380916 * sp[18] + -0.04871031746031779 * sp[17];
    A[16] = 0.06865079365079392 * sp[19] + -0.01289682539682549 * sp[18] + -0.01289682539682549 * sp[18] + 0.06865079365079436 * sp[17];
    A[17] = -0.04871031746031754 * sp[19] + 0.005952380952380901 * sp[18] + 0.009920634920635 * sp[18] + -0.02986111111111138 * sp[17];
    A[18] = 0.01746031746031737 * sp[19] + 0.02316468253968251 * sp[18] + -0.00421626984126976 * sp[18] + -0.01041666666666666 * sp[17];
    A[19] = -0.04384920634920631 * sp[19] + -0.05327380952380958 * sp[18] + 0.009424603174603197 * sp[18] + 0.01785714285714286 * sp[17];
    A[20] = 0.0611111111111113 * sp[19] + 0.07524801587301624 * sp[18] + -0.01165674603174614 * sp[18] + -0.02529761904761915 * sp[17];
    A[21] = 0.01041666666666665 * sp[19] + 0.004216269841269766 * sp[18] + -0.02316468253968258 * sp[18] + -0.01746031746031749 * sp[17];
    A[22] = -0.01785714285714292 * sp[19] + -0.009424603174603207 * sp[18] + 0.05327380952380989 * sp[18] + 0.04384920634920661 * sp[17];
    A[23] = 0.02529761904761927 * sp[19] + 0.01165674603174611 * sp[18] + -0.07524801587301658 * sp[18] + -0.06111111111111173 * sp[17];
    A[24] = -0.07856742013183723 * sp[19] + -0.009820927516479949 * sp[18] + 0.1360899955855055 * sp[18] + 0.07014948226057145 * sp[17];
    A[25] = -0.05326743555023473 * sp[19] + -0.008591521862941421 * sp[18] + 0.183858567866935 * sp[18] + 0.08419691425682241 * sp[17];
    A[26] = -0.004960317460314825 * sp[19] + 0.01984126984126947 * sp[18] + -0.1626984126984121 * sp[18] + -0.1021825396825409 * sp[17];
    A[27] = -0.07014948226057123 * sp[19] + -0.1360899955855054 * sp[18] + 0.009820927516480062 * sp[18] + 0.07856742013183728 * sp[17];
    A[28] = 0.0463942180598803 * sp[19] + 0.04897167461876225 * sp[18] + -0.01288728279441047 * sp[18] + 0.03092947870658574 * sp[17];
    A[29] = -0.1240079365079383 * sp[19] + -0.2405753968253962 * sp[18] + 0.01736111111111134 * sp[18] + 0.04365079365079534 * sp[17];
    A[30] = 0.01765873015873013 * sp[19] + -0.00471230158730159 * sp[18] + -0.004712301587301568 * sp[18] + 0.0176587301587302 * sp[17];
    A[31] = -0.04871031746031754 * sp[19] + 0.009920634920635 * sp[18] + 0.005952380952380901 * sp[18] + -0.02986111111111138 * sp[17];
    A[32] = 0.05734126984127012 * sp[19] + -0.01116071428571436 * sp[18] + -0.01116071428571436 * sp[18] + 0.02162698412698439 * sp[17];
    A[33] = -0.02385912698412705 * sp[19] + -0.03067956349206367 * sp[18] + 0.008804563492063535 * sp[18] + 0.01314484126984127 * sp[17];
    A[34] = 0.06111111111111145 * sp[19] + 0.07276785714285765 * sp[18] + -0.01413690476190487 * sp[18] + -0.02777777777777795 * sp[17];
    A[35] = -0.05114087301587316 * sp[19] + -0.05820932539682562 * sp[18] + 0.007068452380952376 * sp[18] + 0.02058531746031758 * sp[17];
    A[36] = -0.01860119047619065 * sp[19] + -0.009052579365079402 * sp[18] + 0.02447916666666683 * sp[18] + 0.01542658730158744 * sp[17];
    A[37] = 0.01190476190476192 * sp[19] + 0.005704365079365082 * sp[18] + -0.02167658730158727 * sp[18] + -0.01746031746031749 * sp[17];
    A[38] = -0.01116071428571432 * sp[19] + -0.006820436507936547 * sp[18] + 0.03266369047619071 * sp[18] + 0.02385912698412716 * sp[17];
    A[39] = 0.1248660784238152 * sp[19] + 0.01192541198429713 * sp[18] + -0.1283735525368424 * sp[18] + -0.03507474113028582 * sp[17];
    A[40] = -0.003436608745177594 * sp[19] + -0.01718304372588166 * sp[18] + -0.05154913117764451 * sp[18] + -0.00343660874517665 * sp[17];
    A[41] = 0.1001984126984116 * sp[19] + -0.07192460317460392 * sp[18] + 0.1026785714285715 * sp[18] + 0.1180555555555576 * sp[17];
    A[42] = -0.03507474113028567 * sp[19] + 0.06243303921190645 * sp[18] + 0.02314932914598852 * sp[18] + -0.04349267900155104 * sp[17];
    A[43] = -0.02319710902993973 * sp[19] + 0.001288728279440682 * sp[18] + 0.03221820698602816 * sp[18] + -0.01804219591217498 * sp[17];
    A[44] = -0.06200396825396918 * sp[19] + 0.1460813492063476 * sp[18] + 0.04092261904761976 * sp[18] + -0.06498015873016078 * sp[17];
    A[45] = -0.0154265873015874 * sp[19] + 0.009052579365079369 * sp[18] + -0.0244791666666668 * sp[18] + 0.01860119047619064 * sp[17];
    A[46] = 0.01746031746031737 * sp[19] + -0.00421626984126976 * sp[18] + 0.02316468253968251 * sp[18] + -0.01041666666666666 * sp[17];
    A[47] = -0.02385912698412705 * sp[19] + 0.008804563492063535 * sp[18] + -0.03067956349206367 * sp[18] + 0.01314484126984127 * sp[17];
    A[48] = 0.02162698412698431 * sp[19] + 0.03278769841269866 * sp[18] + 0.03278769841269866 * sp[18] + 0.1012896825396832 * sp[17];
    A[49] = -0.02986111111111127 * sp[19] + -0.03581349206349217 * sp[18] + -0.03978174603174635 * sp[18] + -0.09444444444444486 * sp[17];
    A[50] = 0.01765873015873009 * sp[19] + 0.02237103174603167 * sp[18] + 0.02237103174603173 * sp[18] + 0.04474206349206341 * sp[17];
    A[51] = 0.02058531746031757 * sp[19] + 0.01351686507936521 * sp[18] + 0.0787946428571432 * sp[18] + 0.02058531746031761 * sp[17];
    A[52] = -0.02777777777777793 * sp[19] + -0.01364087301587309 * sp[18] + -0.1005456349206356 * sp[18] + -0.02529761904761931 * sp[17];
    A[53] = 0.01314484126984125 * sp[19] + 0.004340277777777705 * sp[18] + 0.04382440476190488 * sp[18] + 0.01116071428571434 * sp[17];
    A[54] = -0.07856742013183687 * sp[19] + 0.02665680325901711 * sp[18] + -0.1529258713280408 * sp[18] + 0.0420896893563429 * sp[17];
    A[55] = -0.03522523963805736 * sp[19] + 0.07947157723220404 * sp[18] + 0.02104922856420362 * sp[18] + 0.1159855451497029 * sp[17];
    A[56] = -0.04513888888888815 * sp[19] + 0.04340277777777821 * sp[18] + 0.005704365079364716 * sp[18] + 0.05208333333333318 * sp[17];
    A[57] = 0.03507474113028569 * sp[19] + -0.0932988114065567 * sp[18] + 0.04700015311458285 * sp[18] + -0.2062394778460747 * sp[17];
    A[58] = 0.1005208057964092 * sp[19] + 0.03737312010379365 * sp[18] + 0.1714008611656714 * sp[18] + 0.1933092419161686 * sp[17];
    A[59] = 0.06200396825396928 * sp[19] + -0.03397817460317273 * sp[18] + 0.08308531746031898 * sp[18] + 0.04017857142857466 * sp[17];
    A[60] = 0.01746031746031742 * sp[19] + -0.005704365079365075 * sp[18] + 0.0216765873015872 * sp[18] + -0.01190476190476188 * sp[17];
    A[61] = -0.04384920634920631 * sp[19] + 0.009424603174603197 * sp[18] + -0.05327380952380958 * sp[18] + 0.01785714285714286 * sp[17];
    A[62] = 0.06111111111111145 * sp[19] + -0.01413690476190487 * sp[18] + 0.07276785714285765 * sp[18] + -0.02777777777777795 * sp[17];
    A[63] = -0.02986111111111127 * sp[19] + -0.03978174603174635 * sp[18] + -0.03581349206349217 * sp[18] + -0.09444444444444486 * sp[17];
    A[64] = 0.0686507936507941 * sp[19] + 0.08154761904761966 * sp[18] + 0.08154761904761966 * sp[18] + 0.1630952380952395 * sp[17];
    A[65] = -0.04871031746031754 * sp[19] + -0.05466269841269852 * sp[18] + -0.05863095238095261 * sp[18] + -0.09444444444444489 * sp[17];
    A[66] = -0.02529761904761929 * sp[19] + -0.01364087301587313 * sp[18] + -0.1005456349206357 * sp[18] + -0.027777777777778 * sp[17];
    A[67] = 0.01785714285714294 * sp[19] + 0.008432539682539712 * sp[18] + 0.0711309523809525 * sp[18] + 0.01785714285714293 * sp[17];
    A[68] = -0.01041666666666662 * sp[19] + -0.006200396825396814 * sp[18] + -0.03358134920634905 * sp[18] + -0.01190476190476187 * sp[17];
    A[69] = 0.1487169023924088 * sp[19] + 0.002805979290422801 * sp[18] + 0.2946278254943949 * sp[18];
    A[70] = -0.00687321749035464 * sp[19] + -0.04725337024617524 * sp[18] + -0.1778445025628795 * sp[18] + -0.1030982623552915 * sp[17];
    A[71] = 0.1289682539682533 * sp[19] + -0.09176587301587404 * sp[18] + -0.01636904761904719 * sp[18] + -0.1785714285714303 * sp[17];
    A[72] = -0.07014948226057138 * sp[19] + 0.06594051332493445 * sp[18] + -0.0799704097770513 * sp[18] + 0.1346870059402919 * sp[17];
    A[73] = -0.04639421805988047 * sp[19] + 0.002577456558881199 * sp[18] + -0.05928150085429065 * sp[18] + -0.04123930494211466 * sp[17];
    A[74] = -0.1240079365079385 * sp[19] + 0.116567460317458 * sp[18] + -0.1413690476190499 * sp[18] + 0.1428571428571428 * sp[17];
    A[75] = -0.02385912698412701 * sp[19] + 0.00682043650793654 * sp[18] + -0.03266369047619057 * sp[18] + 0.01116071428571416 * sp[17];
    A[76] = 0.0611111111111113 * sp[19] + -0.01165674603174614 * sp[18] + 0.07524801587301624 * sp[18] + -0.02529761904761915 * sp[17];
    A[77] = -0.05114087301587316 * sp[19] + 0.007068452380952376 * sp[18] + -0.05820932539682562 * sp[18] + 0.02058531746031758 * sp[17];
    A[78] = 0.01765873015873009 * sp[19] + 0.02237103174603173 * sp[18] + 0.02237103174603167 * sp[18] + 0.04474206349206341 * sp[17];
    A[79] = -0.04871031746031754 * sp[19] + -0.05863095238095261 * sp[18] + -0.05466269841269852 * sp[18] + -0.09444444444444489 * sp[17];
    A[80] = 0.05734126984127003 * sp[19] + 0.06850198412698445 * sp[18] + 0.06850198412698445 * sp[18] + 0.1012896825396832 * sp[17];
    A[81] = 0.01116071428571432 * sp[19] + 0.004340277777777722 * sp[18] + 0.04382440476190491 * sp[18] + 0.01314484126984127 * sp[17];
    A[82] = -0.01190476190476191 * sp[19] + -0.006200396825396827 * sp[18] + -0.03358134920634896 * sp[18] + -0.01041666666666652 * sp[17];
    A[83] = 0.01860119047619063 * sp[19] + 0.009548611111111199 * sp[18] + 0.04308035714285732 * sp[18] + 0.01860119047619048 * sp[17];
    A[84] = -0.08979133729352934 * sp[19] + -0.01543288609732571 * sp[18] + -0.1950155606843835 * sp[18] + -0.04208968935634282 * sp[17];
    A[85] = -0.0266337177751171 * sp[19] + -0.01073940232867669 * sp[18] + -0.007302793583500569 * sp[18] + -0.01288728279441198 * sp[17];
    A[86] = -0.03819444444444213 * sp[19] + 0.03596230158730159 * sp[18] + 0.1054067460317486 * sp[18] + 0.1264880952380966 * sp[17];
    A[87] = -0.03507474113028562 * sp[19] + -0.09750778034219187 * sp[18] + -0.05822407027627419 * sp[18] + -0.1641497884897316 * sp[17];
    A[88] = 0.02319710902993959 * sp[19] + 0.02448583730938098 * sp[18] + 0.05541531601596769 * sp[18] + 0.07474624020758415 * sp[17];
    A[89] = -0.0620039682539692 * sp[19] + -0.2080853174603165 * sp[18] + -0.1029265873015889 * sp[18] + -0.3139880952380975 * sp[17];
    A[90] = -0.01314484126984128 * sp[19] + 0.03067956349206368 * sp[18] + -0.008804563492063549 * sp[18] + 0.02385912698412709 * sp[17];
    A[91] = 0.01041666666666665 * sp[19] + -0.02316468253968258 * sp[18] + 0.004216269841269766 * sp[18] + -0.01746031746031749 * sp[17];
    A[92] = -0.01860119047619065 * sp[19] + 0.02447916666666683 * sp[18] + -0.009052579365079402 * sp[18] + 0.01542658730158744 * sp[17];
    A[93] = 0.02058531746031757 * sp[19] + 0.0787946428571432 * sp[18] + 0.01351686507936521 * sp[18] + 0.02058531746031761 * sp[17];
    A[94] = -0.02529761904761929 * sp[19] + -0.1005456349206357 * sp[18] + -0.01364087301587313 * sp[18] + -0.027777777777778 * sp[17];
    A[95] = 0.01116071428571432 * sp[19] + 0.04382440476190491 * sp[18] + 0.004340277777777722 * sp[18] + 0.01314484126984127 * sp[17];
    A[96] = 0.1012896825396833 * sp[19] + 0.03278769841269873 * sp[18] + 0.03278769841269873 * sp[18] + 0.02162698412698436 * sp[17];
    A[97] = -0.09444444444444489 * sp[19] + -0.03978174603174636 * sp[18] + -0.03581349206349224 * sp[18] + -0.02986111111111132 * sp[17];
    A[98] = 0.04474206349206349 * sp[19] + 0.02237103174603181 * sp[18] + 0.02237103174603176 * sp[18] + 0.0176587301587302 * sp[17];
    A[99] = -0.2062394778460753 * sp[19] + 0.04700015311458279 * sp[18] + -0.09329881140655698 * sp[18] + 0.03507474113028556 * sp[17];
    A[100] = 0.1314502845029979 * sp[19] + 0.1576544261849667 * sp[18] + -0.01073940232867413 * sp[18] + 0.1039574145415858 * sp[17];
    A[101] = 0.1473214285714275 * sp[19] + 0.1068948412698423 * sp[18] + 0.04935515873015897 * sp[18] + 0.05605158730158821 * sp[17];
    A[102] = 0.04208968935634273 * sp[19] + -0.1529258713280408 * sp[18] + 0.02665680325901711 * sp[18] + -0.07856742013183683 * sp[17];
    A[103] = 0.1030982623552904 * sp[19] + 0.01546473935329218 * sp[18] + 0.07732369676646854 * sp[18] + -0.05670404429540898 * sp[17];
    A[104] = 0.07440476190476317 * sp[19] + 0.01537698412698334 * sp[18] + 0.0471230158730167 * sp[18] + -0.0079365079365079 * sp[17];
    A[105] = 0.02777777777777798 * sp[19] + -0.0727678571428578 * sp[18] + 0.01413690476190486 * sp[18] + -0.06111111111111165 * sp[17];
    A[106] = -0.01785714285714292 * sp[19] + 0.05327380952380989 * sp[18] + -0.009424603174603207 * sp[18] + 0.04384920634920661 * sp[17];
    A[107] = 0.01190476190476192 * sp[19] + -0.02167658730158727 * sp[18] + 0.005704365079365082 * sp[18] + -0.01746031746031749 * sp[17];
    A[108] = -0.02777777777777793 * sp[19] + -0.1005456349206356 * sp[18] + -0.01364087301587309 * sp[18] + -0.02529761904761931 * sp[17];
    A[109] = 0.01785714285714294 * sp[19] + 0.0711309523809525 * sp[18] + 0.008432539682539712 * sp[18] + 0.01785714285714293 * sp[17];
    A[110] = -0.01190476190476191 * sp[19] + -0.03358134920634896 * sp[18] + -0.006200396825396827 * sp[18] + -0.01041666666666652 * sp[17];
    A[111] = -0.09444444444444489 * sp[19] + -0.03581349206349224 * sp[18] + -0.03978174603174636 * sp[18] + -0.02986111111111132 * sp[17];
    A[112] = 0.1630952380952395 * sp[19] + 0.08154761904761984 * sp[18] + 0.08154761904761984 * sp[18] + 0.06865079365079431 * sp[17];
    A[113] = -0.094444444444445 * sp[19] + -0.05863095238095288 * sp[18] + -0.05466269841269868 * sp[18] + -0.04871031746031782 * sp[17];
    A[114] = 0.134687005940292 * sp[19] + -0.0799704097770513 * sp[18] + 0.06594051332493449 * sp[18] + -0.07014948226057129 * sp[17];
    A[115] = 0.1030982623552919 * sp[19] + -0.1520699369740544 * sp[18] + 0.1022391101689945 * sp[18] + -0.1305911323167025 * sp[17];
    A[116] = -0.1071428571428565 * sp[19] + 0.01934523809523983 * sp[18] + -0.05605158730158707 * sp[18] + 0.02182539682539783 * sp[17];
    A[117] = 0.2946278254943946 * sp[18] + 0.00280597929042286 * sp[18] + 0.1487169023924087 * sp[17];
    A[118] = -0.206196524710582 * sp[19] + -0.1030982623552902 * sp[18] + -0.1030982623552911 * sp[18] + 0.1082531754730541 * sp[17];
    A[119] = -0.1458333333333379 * sp[18] + 0.00496031746031745 * sp[18] + -0.07043650793651053 * sp[17];
    A[120] = -0.0205853174603176 * sp[19] + 0.05820932539682575 * sp[18] + -0.007068452380952368 * sp[18] + 0.05114087301587343 * sp[17];
    A[121] = 0.02529761904761927 * sp[19] + -0.07524801587301658 * sp[18] + 0.01165674603174611 * sp[18] + -0.06111111111111173 * sp[17];
    A[122] = -0.01116071428571432 * sp[19] + 0.03266369047619071 * sp[18] + -0.006820436507936547 * sp[18] + 0.02385912698412716 * sp[17];
    A[123] = 0.01314484126984125 * sp[19] + 0.04382440476190488 * sp[18] + 0.004340277777777705 * sp[18] + 0.01116071428571434 * sp[17];
    A[124] = -0.01041666666666662 * sp[19] + -0.03358134920634905 * sp[18] + -0.006200396825396814 * sp[18] + -0.01190476190476187 * sp[17];
    A[125] = 0.01860119047619063 * sp[19] + 0.04308035714285732 * sp[18] + 0.009548611111111199 * sp[18] + 0.01860119047619048 * sp[17];
    A[126] = 0.04474206349206349 * sp[19] + 0.02237103174603176 * sp[18] + 0.02237103174603181 * sp[18] + 0.0176587301587302 * sp[17];
    A[127] = -0.094444444444445 * sp[19] + -0.05466269841269868 * sp[18] + -0.05863095238095288 * sp[18] + -0.04871031746031782 * sp[17];
    A[128] = 0.1012896825396834 * sp[19] + 0.06850198412698472 * sp[18] + 0.06850198412698472 * sp[18] + 0.05734126984127041 * sp[17];
    A[129] = -0.1641497884897317 * sp[19] + -0.05822407027627442 * sp[18] + -0.09750778034219193 * sp[18] + -0.03507474113028578 * sp[17];
    A[130] = -0.2345485468582883 * sp[19] + -0.06142938132002913 * sp[18] + -0.167964252420494 * sp[18] + -0.04209845712841157 * sp[17];
    A[131] = 0.2217261904761911 * sp[19] + 0.09945436507936614 * sp[18] + 0.1252480158730155 * sp[18] + 0.05109126984127019 * sp[17];
    A[132] = -0.04208968935634295 * sp[19] + -0.1950155606843832 * sp[18] + -0.01543288609732574 * sp[18] + -0.08979133729352926 * sp[17];
    A[133] = 0.1030982623552905 * sp[19] + 0.08763352300199817 * sp[18] + 0.02577456558882203 * sp[18] + -0.04639421805987942 * sp[17];
    A[134] = -0.07440476190476308 * sp[19] + -0.05902777777777894 * sp[18] + -0.02728174603174639 * sp[18] + -0.003968253968254082 * sp[17];
    A[135] = 0.04349267900155113 * sp[19] + -0.06243303921190629 * sp[18] + -0.02314932914598858 * sp[18] + 0.03507474113028568 * sp[17];
    A[136] = -0.07856742013183723 * sp[19] + 0.1360899955855055 * sp[18] + -0.009820927516479949 * sp[18] + 0.07014948226057145 * sp[17];
    A[137] = 0.1248660784238152 * sp[19] + -0.1283735525368424 * sp[18] + 0.01192541198429713 * sp[18] + -0.03507474113028582 * sp[17];
    A[138] = -0.07856742013183687 * sp[19] + -0.1529258713280408 * sp[18] + 0.02665680325901711 * sp[18] + 0.0420896893563429 * sp[17];
    A[139] = 0.1487169023924088 * sp[19] + 0.2946278254943949 * sp[18] + 0.002805979290422801 * sp[18];
    A[140] = -0.08979133729352934 * sp[19] + -0.1950155606843835 * sp[18] + -0.01543288609732571 * sp[18] + -0.04208968935634282 * sp[17];
    A[141] = -0.2062394778460753 * sp[19] + -0.09329881140655698 * sp[18] + 0.04700015311458279 * sp[18] + 0.03507474113028556 * sp[17];
    A[142] = 0.134687005940292 * sp[19] + 0.06594051332493449 * sp[18] + -0.0799704097770513 * sp[18] + -0.07014948226057129 * sp[17];
    A[143] = -0.1641497884897317 * sp[19] + -0.09750778034219193 * sp[18] + -0.05822407027627442 * sp[18] + -0.03507474113028578 * sp[17];
    A[144] = 4.920634920634908 * sp[19] + 0.1984126984127019 * sp[18] + 0.1984126984127019 * sp[18] + 0.3968253968254036 * sp[17];
    A[145] = 0.02430049347996821 * sp[19] + -0.06075123369997207 * sp[18] + 0.2308546880599303 * sp[18] + 0.6075123369998057 * sp[17];
    A[146] = -0.5191061687282021 * sp[19] + -0.8067190459965536 * sp[18] + -0.3016427737204515 * sp[18] + -0.3507474113028577 * sp[17];
    A[147] = -0.1984126984127008 * sp[19] + 4.305555555555532 * sp[18] + 0.01984126984127024 * sp[18] + -0.1984126984127011 * sp[17];
    A[148] = -0.2187044413199081 * sp[19] + -0.03645074021998784 * sp[18] + 0.2551551815399188 * sp[18] + -0.2187044413199267 * sp[17];
    A[149] = -0.3507474113028561 * sp[19] + 0.5401510134063866 * sp[18] + 0.03507474113028555 * sp[18] + 0.3226876183986346 * sp[17];
    A[150] = 0.065295566158352 * sp[19] + -0.1271545235715238 * sp[18] + -0.05154913117764585 * sp[18] + 0.06529556615835101 * sp[17];
    A[151] = -0.05326743555023473 * sp[19] + 0.183858567866935 * sp[18] + -0.008591521862941421 * sp[18] + 0.08419691425682241 * sp[17];
    A[152] = -0.003436608745177594 * sp[19] + -0.05154913117764451 * sp[18] + -0.01718304372588166 * sp[18] + -0.00343660874517665 * sp[17];
    A[153] = -0.03522523963805736 * sp[19] + 0.02104922856420362 * sp[18] + 0.07947157723220404 * sp[18] + 0.1159855451497029 * sp[17];
    A[154] = -0.00687321749035464 * sp[19] + -0.1778445025628795 * sp[18] + -0.04725337024617524 * sp[18] + -0.1030982623552915 * sp[17];
    A[155] = -0.0266337177751171 * sp[19] + -0.007302793583500569 * sp[18] + -0.01073940232867669 * sp[18] + -0.01288728279441198 * sp[17];
    A[156] = 0.1314502845029979 * sp[19] + -0.01073940232867413 * sp[18] + 0.1576544261849667 * sp[18] + 0.1039574145415858 * sp[17];
    A[157] = 0.1030982623552919 * sp[19] + 0.1022391101689945 * sp[18] + -0.1520699369740544 * sp[18] + -0.1305911323167025 * sp[17];
    A[158] = -0.2345485468582883 * sp[19] + -0.167964252420494 * sp[18] + -0.06142938132002913 * sp[18] + -0.04209845712841157 * sp[17];
    A[159] = 0.02430049347996821 * sp[19] + 0.2308546880599303 * sp[18] + -0.06075123369997207 * sp[18] + 0.6075123369998057 * sp[17];
    A[160] = 5.41666666666671 * sp[19] + 0.4315476190476338 * sp[18] + 0.4315476190476338 * sp[18] + 1.130952380952398 * sp[17];
    A[161] = -0.189013480984709 * sp[19] + -0.06873217490352396 * sp[18] + -0.2749286996141048 * sp[18] + -0.1890134809847019 * sp[17];
    A[162] = 0.1701034543599527 * sp[19] + 0.4495591293798427 * sp[18] + 0.1579532076199498 * sp[18] + -0.4131083891598578 * sp[17];
    A[163] = -0.4017857142857212 * sp[19] + 3.593749999999996 * sp[18] + 0.5580357142857229 * sp[18] + -0.4017857142857151 * sp[17];
    A[164] = 0.3007032652029456 * sp[19] + 0.1761261981902886 * sp[18] + 0.2792244605455826 * sp[18] + 0.3007032652029423 * sp[17];
    A[165] = -0.01686507936508123 * sp[19] + 0.07192460317460267 * sp[18] + -0.007440476190475988 * sp[18] + -0.01091269841269927 * sp[17];
    A[166] = -0.004960317460314825 * sp[19] + -0.1626984126984121 * sp[18] + 0.01984126984126947 * sp[18] + -0.1021825396825409 * sp[17];
    A[167] = 0.1001984126984116 * sp[19] + 0.1026785714285715 * sp[18] + -0.07192460317460392 * sp[18] + 0.1180555555555576 * sp[17];
    A[168] = -0.04513888888888815 * sp[19] + 0.005704365079364716 * sp[18] + 0.04340277777777821 * sp[18] + 0.05208333333333318 * sp[17];
    A[169] = 0.1289682539682533 * sp[19] + -0.01636904761904719 * sp[18] + -0.09176587301587404 * sp[18] + -0.1785714285714303 * sp[17];
    A[170] = -0.03819444444444213 * sp[19] + 0.1054067460317486 * sp[18] + 0.03596230158730159 * sp[18] + 0.1264880952380966 * sp[17];
    A[171] = 0.1473214285714275 * sp[19] + 0.04935515873015897 * sp[18] + 0.1068948412698423 * sp[18] + 0.05605158730158821 * sp[17];
    A[172] = -0.1071428571428565 * sp[19] + -0.05605158730158707 * sp[18] + 0.01934523809523983 * sp[18] + 0.02182539682539783 * sp[17];
    A[173] = 0.2217261904761911 * sp[19] + 0.1252480158730155 * sp[18] + 0.09945436507936614 * sp[18] + 0.05109126984127019 * sp[17];
    A[174] = -0.5191061687282021 * sp[19] + -0.3016427737204515 * sp[18] + -0.8067190459965536 * sp[18] + -0.3507474113028577 * sp[17];
    A[175] = -0.189013480984709 * sp[19] + -0.2749286996141048 * sp[18] + -0.06873217490352396 * sp[18] + -0.1890134809847019 * sp[17];
    A[176] = 5.555555555555565 * sp[19] + 0.5902777777777793 * sp[18] + 0.5902777777777793 * sp[18] + 0.9126984126984306 * sp[17];
    A[177] = -0.3507474113028574 * sp[19] + -0.3016427737204441 * sp[18] + 0.2034334985556569 * sp[18] + -0.01402989645209655 * sp[17];
    A[178] = 0.07732369676647335 * sp[19] + 0.1675346763273467 * sp[18] + 0.06443641397205596 * sp[18] + 0.07732369676647219 * sp[17];
    A[179] = -0.6200396825396914 * sp[19] + 3.395337301587294 * sp[18] + 0.3596230158730222 * sp[18] + -0.6200396825397031 * sp[17];
    A[180] = 0.03507474113028559 * sp[19] + -0.01192541198429714 * sp[18] + 0.1283735525368423 * sp[18] + -0.1248660784238149 * sp[17];
    A[181] = -0.07014948226057123 * sp[19] + 0.009820927516480062 * sp[18] + -0.1360899955855054 * sp[18] + 0.07856742013183728 * sp[17];
    A[182] = -0.03507474113028567 * sp[19] + 0.02314932914598852 * sp[18] + 0.06243303921190645 * sp[18] + -0.04349267900155104 * sp[17];
    A[183] = 0.03507474113028569 * sp[19] + 0.04700015311458285 * sp[18] + -0.0932988114065567 * sp[18] + -0.2062394778460747 * sp[17];
    A[184] = -0.07014948226057138 * sp[19] + -0.0799704097770513 * sp[18] + 0.06594051332493445 * sp[18] + 0.1346870059402919 * sp[17];
    A[185] = -0.03507474113028562 * sp[19] + -0.05822407027627419 * sp[18] + -0.09750778034219187 * sp[18] + -0.1641497884897316 * sp[17];
    A[186] = 0.04208968935634273 * sp[19] + 0.02665680325901711 * sp[18] + -0.1529258713280408 * sp[18] + -0.07856742013183683 * sp[17];
    A[187] = 0.00280597929042286 * sp[18] + 0.2946278254943946 * sp[18] + 0.1487169023924087 * sp[17];
    A[188] = -0.04208968935634295 * sp[19] + -0.01543288609732574 * sp[18] + -0.1950155606843832 * sp[18] + -0.08979133729352926 * sp[17];
    A[189] = -0.1984126984127008 * sp[19] + 0.01984126984127024 * sp[18] + 4.305555555555532 * sp[18] + -0.1984126984127011 * sp[17];
    A[190] = 0.1701034543599527 * sp[19] + 0.1579532076199498 * sp[18] + 0.4495591293798427 * sp[18] + -0.4131083891598578 * sp[17];
    A[191] = -0.3507474113028574 * sp[19] + 0.2034334985556569 * sp[18] + -0.3016427737204441 * sp[18] + -0.01402989645209655 * sp[17];
    A[192] = 0.396825396825403 * sp[19] + 0.1984126984127019 * sp[18] + 0.1984126984127019 * sp[18] + 4.920634920634905 * sp[17];
    A[193] = -0.1458029608799463 * sp[18] + -0.7290148043997458 * sp[18] + -0.4374088826398507 * sp[17];
    A[194] = 0.7014948226057124 * sp[19] + 0.3507474113028557 * sp[18] + 0.3507474113028561 * sp[18] + 0.2805979290422574 * sp[17];
    A[195] = -0.1005208057964093 * sp[19] + 0.07088005536926233 * sp[18] + -0.06314768569261563 * sp[18] + -0.08505606644311386 * sp[17];
    A[196] = 0.0463942180598803 * sp[19] + -0.01288728279441047 * sp[18] + 0.04897167461876225 * sp[18] + 0.03092947870658574 * sp[17];
    A[197] = -0.02319710902993973 * sp[19] + 0.03221820698602816 * sp[18] + 0.001288728279440682 * sp[18] + -0.01804219591217498 * sp[17];
    A[198] = 0.1005208057964092 * sp[19] + 0.1714008611656714 * sp[18] + 0.03737312010379365 * sp[18] + 0.1933092419161686 * sp[17];
    A[199] = -0.04639421805988047 * sp[19] + -0.05928150085429065 * sp[18] + 0.002577456558881199 * sp[18] + -0.04123930494211466 * sp[17];
    A[200] = 0.02319710902993959 * sp[19] + 0.05541531601596769 * sp[18] + 0.02448583730938098 * sp[18] + 0.07474624020758415 * sp[17];
    A[201] = 0.1030982623552904 * sp[19] + 0.07732369676646854 * sp[18] + 0.01546473935329218 * sp[18] + -0.05670404429540898 * sp[17];
    A[202] = -0.206196524710582 * sp[19] + -0.1030982623552911 * sp[18] + -0.1030982623552902 * sp[18] + 0.1082531754730541 * sp[17];
    A[203] = 0.1030982623552905 * sp[19] + 0.02577456558882203 * sp[18] + 0.08763352300199817 * sp[18] + -0.04639421805987942 * sp[17];
    A[204] = -0.2187044413199081 * sp[19] + 0.2551551815399188 * sp[18] + -0.03645074021998784 * sp[18] + -0.2187044413199267 * sp[17];
    A[205] = -0.4017857142857212 * sp[19] + 0.5580357142857229 * sp[18] + 3.593749999999996 * sp[18] + -0.4017857142857151 * sp[17];
    A[206] = 0.07732369676647335 * sp[19] + 0.06443641397205596 * sp[18] + 0.1675346763273467 * sp[18] + 0.07732369676647219 * sp[17];
    A[207] = -0.7290148043997458 * sp[18] + -0.1458029608799463 * sp[18] + -0.4374088826398507 * sp[17];
    A[208] = 0.8035714285714409 * sp[19] + 0.4017857142857196 * sp[18] + 0.4017857142857196 * sp[18] + 5.357142857142866 * sp[17];
    A[209] = -0.05154913117763647 * sp[18] + -0.2577456558882186 * sp[18] + -0.1546473935329296 * sp[17];
    A[210] = 0.06200396825396909 * sp[19] + -0.02108134920634945 * sp[18] + 0.09598214285714174 * sp[18] + 0.05307539682539866 * sp[17];
    A[211] = -0.1240079365079383 * sp[19] + 0.01736111111111134 * sp[18] + -0.2405753968253962 * sp[18] + 0.04365079365079534 * sp[17];
    A[212] = -0.06200396825396918 * sp[19] + 0.04092261904761976 * sp[18] + 0.1460813492063476 * sp[18] + -0.06498015873016078 * sp[17];
    A[213] = 0.06200396825396928 * sp[19] + 0.08308531746031898 * sp[18] + -0.03397817460317273 * sp[18] + 0.04017857142857466 * sp[17];
    A[214] = -0.1240079365079385 * sp[19] + -0.1413690476190499 * sp[18] + 0.116567460317458 * sp[18] + 0.1428571428571428 * sp[17];
    A[215] = -0.0620039682539692 * sp[19] + -0.1029265873015889 * sp[18] + -0.2080853174603165 * sp[18] + -0.3139880952380975 * sp[17];
    A[216] = 0.07440476190476317 * sp[19] + 0.0471230158730167 * sp[18] + 0.01537698412698334 * sp[18] + -0.0079365079365079 * sp[17];
    A[217] = 0.00496031746031745 * sp[18] + -0.1458333333333379 * sp[18] + -0.07043650793651053 * sp[17];
    A[218] = -0.07440476190476308 * sp[19] + -0.02728174603174639 * sp[18] + -0.05902777777777894 * sp[18] + -0.003968253968254082 * sp[17];
    A[219] = -0.3507474113028561 * sp[19] + 0.03507474113028555 * sp[18] + 0.5401510134063866 * sp[18] + 0.3226876183986346 * sp[17];
    A[220] = 0.3007032652029456 * sp[19] + 0.2792244605455826 * sp[18] + 0.1761261981902886 * sp[18] + 0.3007032652029423 * sp[17];
    A[221] = -0.6200396825396914 * sp[19] + 0.3596230158730222 * sp[18] + 3.395337301587294 * sp[18] + -0.6200396825397031 * sp[17];
    A[222] = 0.7014948226057124 * sp[19] + 0.3507474113028561 * sp[18] + 0.3507474113028557 * sp[18] + 0.2805979290422574 * sp[17];
    A[223] = -0.2577456558882186 * sp[18] + -0.05154913117763647 * sp[18] + -0.1546473935329296 * sp[17];
    A[224] = 1.240079365079383 * sp[19] + 0.6200396825396914 * sp[18] + 0.6200396825396914 * sp[18] + 5.615079365079413 * sp[17];
  }

};


class forms_form_0: public ufc::form
{
public:

  forms_form_0() : ufc::form()
  {
    // Do nothing
  }

  ~forms_form_0() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "f7ade342237e5af4964c4356cf0b121fecb7c546c2c72d54a3d7f9c3718a8755a939353c4e59adb32539a005c2463fb5e8af82bc1aadd81f9dfdc51a48bee4cd";
  }

  std::size_t rank() const final override
  {
    return 2;
  }

  std::size_t num_coefficients() const final override
  {
    return 0;
  }

  std::size_t original_coefficient_position(std::size_t i) const final override
  {
    throw std::runtime_error("Invalid original coefficient index.");
    return i;
  }

  ufc::finite_element * create_coordinate_finite_element() const final override
  {
    return new forms_finite_element_1();
  }

  ufc::dofmap * create_coordinate_dofmap() const final override
  {
    return new forms_dofmap_1();
   }

  ufc::coordinate_mapping * create_coordinate_mapping() const final override
  {
    return new forms_coordinate_mapping_1();
  }

  ufc::finite_element * create_finite_element(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
        return new forms_finite_element_2();
    case 1:
        return new forms_finite_element_2();
    default:
        return nullptr;
    }
  }

  ufc::dofmap * create_dofmap(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
        return new forms_dofmap_2();
    case 1:
        return new forms_dofmap_2();
    default:
        return nullptr;
    }
  }

  std::size_t max_cell_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_exterior_facet_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_interior_facet_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_vertex_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_custom_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_cutcell_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_interface_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_overlap_subdomain_id() const final override
  {
    return 0;
  }

  bool has_cell_integrals() const final override
  {
    return true;
  }

  bool has_exterior_facet_integrals() const final override
  {
    return false;
  }

  bool has_interior_facet_integrals() const final override
  {
    return false;
  }

  bool has_vertex_integrals() const final override
  {
    return false;
  }

  bool has_custom_integrals() const final override
  {
    return false;
  }

  bool has_cutcell_integrals() const final override
  {
    return false;
  }

  bool has_interface_integrals() const final override
  {
    return false;
  }

  bool has_overlap_integrals() const final override
  {
    return false;
  }

  ufc::cell_integral * create_cell_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::exterior_facet_integral * create_exterior_facet_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::interior_facet_integral * create_interior_facet_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::vertex_integral * create_vertex_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::custom_integral * create_custom_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::cutcell_integral * create_cutcell_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::interface_integral * create_interface_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::overlap_integral * create_overlap_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::cell_integral * create_default_cell_integral() const final override
  {
    return new forms_cell_integral_0_otherwise();
  }

  ufc::exterior_facet_integral * create_default_exterior_facet_integral() const final override
  {
    return nullptr;
  }

  ufc::interior_facet_integral * create_default_interior_facet_integral() const final override
  {
    return nullptr;
  }

  ufc::vertex_integral * create_default_vertex_integral() const final override
  {
    return nullptr;
  }

  ufc::custom_integral * create_default_custom_integral() const final override
  {
    return nullptr;
  }

  ufc::cutcell_integral * create_default_cutcell_integral() const final override
  {
    return nullptr;
  }

  ufc::interface_integral * create_default_interface_integral() const final override
  {
    return nullptr;
  }

  ufc::overlap_integral * create_default_overlap_integral() const final override
  {
    return nullptr;
  }

};


class forms_form_1: public ufc::form
{
public:

  forms_form_1() : ufc::form()
  {
    // Do nothing
  }

  ~forms_form_1() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "a3226853386d2b74b50fbefb85d9e0f4f839379042f756b24439e8ccc90d14f112726c9f00229d697576706f783f14fe1fb718aff5c3d4d48b40494a4aef7b2b";
  }

  std::size_t rank() const final override
  {
    return 2;
  }

  std::size_t num_coefficients() const final override
  {
    return 0;
  }

  std::size_t original_coefficient_position(std::size_t i) const final override
  {
    throw std::runtime_error("Invalid original coefficient index.");
    return i;
  }

  ufc::finite_element * create_coordinate_finite_element() const final override
  {
    return new forms_finite_element_1();
  }

  ufc::dofmap * create_coordinate_dofmap() const final override
  {
    return new forms_dofmap_1();
   }

  ufc::coordinate_mapping * create_coordinate_mapping() const final override
  {
    return new forms_coordinate_mapping_1();
  }

  ufc::finite_element * create_finite_element(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
        return new forms_finite_element_2();
    case 1:
        return new forms_finite_element_2();
    default:
        return nullptr;
    }
  }

  ufc::dofmap * create_dofmap(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
        return new forms_dofmap_2();
    case 1:
        return new forms_dofmap_2();
    default:
        return nullptr;
    }
  }

  std::size_t max_cell_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_exterior_facet_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_interior_facet_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_vertex_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_custom_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_cutcell_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_interface_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_overlap_subdomain_id() const final override
  {
    return 0;
  }

  bool has_cell_integrals() const final override
  {
    return true;
  }

  bool has_exterior_facet_integrals() const final override
  {
    return false;
  }

  bool has_interior_facet_integrals() const final override
  {
    return false;
  }

  bool has_vertex_integrals() const final override
  {
    return false;
  }

  bool has_custom_integrals() const final override
  {
    return false;
  }

  bool has_cutcell_integrals() const final override
  {
    return false;
  }

  bool has_interface_integrals() const final override
  {
    return false;
  }

  bool has_overlap_integrals() const final override
  {
    return false;
  }

  ufc::cell_integral * create_cell_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::exterior_facet_integral * create_exterior_facet_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::interior_facet_integral * create_interior_facet_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::vertex_integral * create_vertex_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::custom_integral * create_custom_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::cutcell_integral * create_cutcell_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::interface_integral * create_interface_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::overlap_integral * create_overlap_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::cell_integral * create_default_cell_integral() const final override
  {
    return new forms_cell_integral_1_otherwise();
  }

  ufc::exterior_facet_integral * create_default_exterior_facet_integral() const final override
  {
    return nullptr;
  }

  ufc::interior_facet_integral * create_default_interior_facet_integral() const final override
  {
    return nullptr;
  }

  ufc::vertex_integral * create_default_vertex_integral() const final override
  {
    return nullptr;
  }

  ufc::custom_integral * create_default_custom_integral() const final override
  {
    return nullptr;
  }

  ufc::cutcell_integral * create_default_cutcell_integral() const final override
  {
    return nullptr;
  }

  ufc::interface_integral * create_default_interface_integral() const final override
  {
    return nullptr;
  }

  ufc::overlap_integral * create_default_overlap_integral() const final override
  {
    return nullptr;
  }

};

// DOLFIN wrappers

// Standard library includes
#include <string>

// DOLFIN includes
#include <dolfin/common/NoDeleter.h>
#include <dolfin/mesh/Mesh.h>
#include <dolfin/mesh/MultiMesh.h>
#include <dolfin/fem/FiniteElement.h>
#include <dolfin/fem/DofMap.h>
#include <dolfin/fem/Form.h>
#include <dolfin/fem/MultiMeshForm.h>
#include <dolfin/function/FunctionSpace.h>
#include <dolfin/function/MultiMeshFunctionSpace.h>
#include <dolfin/function/GenericFunction.h>
#include <dolfin/function/CoefficientAssigner.h>
#include <dolfin/function/MultiMeshCoefficientAssigner.h>
#include <dolfin/adaptivity/ErrorControl.h>
#include <dolfin/adaptivity/GoalFunctional.h>
#include <dolfin/la/GenericVector.h>

namespace Forms
{

class Form_a_FunctionSpace_0: public dolfin::FunctionSpace
{
public:

  // Constructor for standard function space
  Form_a_FunctionSpace_0(std::shared_ptr<const dolfin::Mesh> mesh):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh))
  {
    // Do nothing
  }

  // Constructor for constrained function space
  Form_a_FunctionSpace_0(std::shared_ptr<const dolfin::Mesh> mesh, std::shared_ptr<const dolfin::SubDomain> constrained_domain):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh, constrained_domain))
  {
    // Do nothing
  }

};

class Form_a_FunctionSpace_1: public dolfin::FunctionSpace
{
public:

  // Constructor for standard function space
  Form_a_FunctionSpace_1(std::shared_ptr<const dolfin::Mesh> mesh):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh))
  {
    // Do nothing
  }

  // Constructor for constrained function space
  Form_a_FunctionSpace_1(std::shared_ptr<const dolfin::Mesh> mesh, std::shared_ptr<const dolfin::SubDomain> constrained_domain):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh, constrained_domain))
  {
    // Do nothing
  }

};

class Form_a_MultiMeshFunctionSpace_0: public dolfin::MultiMeshFunctionSpace
{
public:

  // Constructor for multimesh function space
  Form_a_MultiMeshFunctionSpace_0(std::shared_ptr<const dolfin::MultiMesh> multimesh): dolfin::MultiMeshFunctionSpace(multimesh)
  {
    // Create and add standard function spaces
    for (std::size_t part = 0; part < multimesh->num_parts(); part++)
    {
      std::shared_ptr<const dolfin::FunctionSpace> V(new Form_a_FunctionSpace_0(multimesh->part(part)));
      add(V);
    }

    // Build multimesh function space
    build();
  }

};

class Form_a_MultiMeshFunctionSpace_1: public dolfin::MultiMeshFunctionSpace
{
public:

  // Constructor for multimesh function space
  Form_a_MultiMeshFunctionSpace_1(std::shared_ptr<const dolfin::MultiMesh> multimesh): dolfin::MultiMeshFunctionSpace(multimesh)
  {
    // Create and add standard function spaces
    for (std::size_t part = 0; part < multimesh->num_parts(); part++)
    {
      std::shared_ptr<const dolfin::FunctionSpace> V(new Form_a_FunctionSpace_1(multimesh->part(part)));
      add(V);
    }

    // Build multimesh function space
    build();
  }

};

class Form_a: public dolfin::Form
{
public:

  // Constructor
  Form_a(std::shared_ptr<const dolfin::FunctionSpace> V1, std::shared_ptr<const dolfin::FunctionSpace> V0):
    dolfin::Form(2, 0)
  {
    _function_spaces[0] = V0;
    _function_spaces[1] = V1;

    _ufc_form = std::make_shared<const forms_form_0>();
  }

  // Destructor
  ~Form_a()
  {}

  /// Return the number of the coefficient with this name
  virtual std::size_t coefficient_number(const std::string& name) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return 0;
  }

  /// Return the name of the coefficient with this number
  virtual std::string coefficient_name(std::size_t i) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return "unnamed";
  }

  // Typedefs
  typedef Form_a_FunctionSpace_0 TestSpace;
  typedef Form_a_FunctionSpace_1 TrialSpace;
  typedef Form_a_MultiMeshFunctionSpace_0 MultiMeshTestSpace;
  typedef Form_a_MultiMeshFunctionSpace_1 MultiMeshTrialSpace;

  // Coefficients
};

class MultiMeshForm_a: public dolfin::MultiMeshForm
{
public:

  // Constructor
  MultiMeshForm_a(std::shared_ptr<const dolfin::MultiMeshFunctionSpace> V1, std::shared_ptr<const dolfin::MultiMeshFunctionSpace> V0):
    dolfin::MultiMeshForm(V1, V0)
  {
    // Create and add standard forms
    std::size_t num_parts = V0->num_parts(); // assume all equal and pick first
    for (std::size_t part = 0; part < num_parts; part++)
    {
      std::shared_ptr<dolfin::Form> a(new Form_a(V1->part(part), V0->part(part)));
    add(a);

    }
    // Build multimesh form
    build();

    /// Assign coefficients

  }

  // Destructor
  ~MultiMeshForm_a()
  {}

  /// Return the number of the coefficient with this name
  virtual std::size_t coefficient_number(const std::string& name) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return 0;
  }

  /// Return the name of the coefficient with this number
  virtual std::string coefficient_name(std::size_t i) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return "unnamed";
  }

  // Typedefs
  typedef Form_a_FunctionSpace_0 TestSpace;
  typedef Form_a_FunctionSpace_1 TrialSpace;
  typedef Form_a_MultiMeshFunctionSpace_0 MultiMeshTestSpace;
  typedef Form_a_MultiMeshFunctionSpace_1 MultiMeshTrialSpace;

  // Coefficients
};

class Form_L_FunctionSpace_0: public dolfin::FunctionSpace
{
public:

  // Constructor for standard function space
  Form_L_FunctionSpace_0(std::shared_ptr<const dolfin::Mesh> mesh):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh))
  {
    // Do nothing
  }

  // Constructor for constrained function space
  Form_L_FunctionSpace_0(std::shared_ptr<const dolfin::Mesh> mesh, std::shared_ptr<const dolfin::SubDomain> constrained_domain):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh, constrained_domain))
  {
    // Do nothing
  }

};

class Form_L_FunctionSpace_1: public dolfin::FunctionSpace
{
public:

  // Constructor for standard function space
  Form_L_FunctionSpace_1(std::shared_ptr<const dolfin::Mesh> mesh):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh))
  {
    // Do nothing
  }

  // Constructor for constrained function space
  Form_L_FunctionSpace_1(std::shared_ptr<const dolfin::Mesh> mesh, std::shared_ptr<const dolfin::SubDomain> constrained_domain):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh, constrained_domain))
  {
    // Do nothing
  }

};

class Form_L_MultiMeshFunctionSpace_0: public dolfin::MultiMeshFunctionSpace
{
public:

  // Constructor for multimesh function space
  Form_L_MultiMeshFunctionSpace_0(std::shared_ptr<const dolfin::MultiMesh> multimesh): dolfin::MultiMeshFunctionSpace(multimesh)
  {
    // Create and add standard function spaces
    for (std::size_t part = 0; part < multimesh->num_parts(); part++)
    {
      std::shared_ptr<const dolfin::FunctionSpace> V(new Form_L_FunctionSpace_0(multimesh->part(part)));
      add(V);
    }

    // Build multimesh function space
    build();
  }

};

class Form_L_MultiMeshFunctionSpace_1: public dolfin::MultiMeshFunctionSpace
{
public:

  // Constructor for multimesh function space
  Form_L_MultiMeshFunctionSpace_1(std::shared_ptr<const dolfin::MultiMesh> multimesh): dolfin::MultiMeshFunctionSpace(multimesh)
  {
    // Create and add standard function spaces
    for (std::size_t part = 0; part < multimesh->num_parts(); part++)
    {
      std::shared_ptr<const dolfin::FunctionSpace> V(new Form_L_FunctionSpace_1(multimesh->part(part)));
      add(V);
    }

    // Build multimesh function space
    build();
  }

};

class Form_L: public dolfin::Form
{
public:

  // Constructor
  Form_L(std::shared_ptr<const dolfin::FunctionSpace> V1, std::shared_ptr<const dolfin::FunctionSpace> V0):
    dolfin::Form(2, 0)
  {
    _function_spaces[0] = V0;
    _function_spaces[1] = V1;

    _ufc_form = std::make_shared<const forms_form_1>();
  }

  // Destructor
  ~Form_L()
  {}

  /// Return the number of the coefficient with this name
  virtual std::size_t coefficient_number(const std::string& name) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return 0;
  }

  /// Return the name of the coefficient with this number
  virtual std::string coefficient_name(std::size_t i) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return "unnamed";
  }

  // Typedefs
  typedef Form_L_FunctionSpace_0 TestSpace;
  typedef Form_L_FunctionSpace_1 TrialSpace;
  typedef Form_L_MultiMeshFunctionSpace_0 MultiMeshTestSpace;
  typedef Form_L_MultiMeshFunctionSpace_1 MultiMeshTrialSpace;

  // Coefficients
};

class MultiMeshForm_L: public dolfin::MultiMeshForm
{
public:

  // Constructor
  MultiMeshForm_L(std::shared_ptr<const dolfin::MultiMeshFunctionSpace> V1, std::shared_ptr<const dolfin::MultiMeshFunctionSpace> V0):
    dolfin::MultiMeshForm(V1, V0)
  {
    // Create and add standard forms
    std::size_t num_parts = V0->num_parts(); // assume all equal and pick first
    for (std::size_t part = 0; part < num_parts; part++)
    {
      std::shared_ptr<dolfin::Form> a(new Form_L(V1->part(part), V0->part(part)));
    add(a);

    }
    // Build multimesh form
    build();

    /// Assign coefficients

  }

  // Destructor
  ~MultiMeshForm_L()
  {}

  /// Return the number of the coefficient with this name
  virtual std::size_t coefficient_number(const std::string& name) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return 0;
  }

  /// Return the name of the coefficient with this number
  virtual std::string coefficient_name(std::size_t i) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return "unnamed";
  }

  // Typedefs
  typedef Form_L_FunctionSpace_0 TestSpace;
  typedef Form_L_FunctionSpace_1 TrialSpace;
  typedef Form_L_MultiMeshFunctionSpace_0 MultiMeshTestSpace;
  typedef Form_L_MultiMeshFunctionSpace_1 MultiMeshTrialSpace;

  // Coefficients
};

// Class typedefs
typedef Form_a::TestSpace FunctionSpace;
typedef Form_a::MultiMeshTestSpace MultiMeshFunctionSpace;

}

#endif
